/*
	functions.js
*/

/*
* CONTENTS
*
*    log recordset as a table!
*    calculate income and balance
*    initialize autogrow textarea
*    currencify	
*    scroll and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
*    scroll to bottom and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
*    scroll to bottom
*    near bottom - check if we're near the bottom of the page
*    load all budgets
*      choose which page to show first
*    load all entries
*    export budget
*    add id to budget markup	
*    add id to entry markup
*    update count of entries made - show 'rate this app' every 50 entries & 'rate this app' button after first 50
*    do login
*    log
*    show pro upgrade banner
*    hide pro upgrade banner
*    enable pro version
*    disable pro version
*    show already upgraded popup
*    show & hide review icon
*    prompt for feedback, review, email
*    admob or house ads
*    check pro trial expired
*    show & hide loading screen
*    ga - track view (page)
*    ga - track event
*    show new version popup
*    show notification
*    native alert
*    native confirm
*    native prompt
*    date to unix timestamp
*    unix timestamp to date
*    unix timestamp to nice date
*    zero padding
*    get android version
*    enable emergency mode
*    disable emergency mode
*/

	/*
		>> log recordset as a table!
	*/
	
		function logTable(recordSetRows) {
			var tableString;
			for (var i=0; i < recordSetRows.length; i++) {
				tableString += JSON.stringify(recordSetRows.item(i)) + ', ';
			}
			tableString = tableString.replace('undefined','');
			tableString = tableString.substring(0, tableString.length - 2);
			eval('console.table([' + tableString + '])');
		}


	/*
		>> calculate income and balance
	*/

		function calculateIncomeAndBalance() {
			var totalIncome = 0;
			var totalExpense = 0;
			var totalPaidIncome = 0;
			var totalPaidExpense = 0;

			var incomeValue = 0;
			var expenseValue = 0;
			
			var remainingBalance = 0;
			var remainingPaid = 0;
			
			/* income, expenses and balance */

				// grab income from each income text box and work out total
				$('#entries .income input.amount').each(function(index) {
					incomeValue = parseFloat(this.value, 10);
					if (isNaN(incomeValue)) {
						incomeValue = 0;
					}
					totalIncome += incomeValue;
				});
				
				// round total income to 2 decimal places
				totalIncome = totalIncome.toFixed(2);
				
				// grab expense from each expense text box and work out total
				$('#entries .expense input.amount').each(function(index) {
					expenseValue = parseFloat(this.value, 10);
					if (isNaN(expenseValue)) {
						expenseValue = 0;
					}
					totalExpense -= expenseValue;
				});	
				
				// round total expense to 2 decimal places
				totalExpense = totalExpense.toFixed(2);
				
				// work out remaining balance
				remainingBalance = parseFloat(totalIncome) + parseFloat(totalExpense);
				
				// round remaining balance to 2 decimal places
				remainingBalance = remainingBalance.toFixed(2);
			
				// update total income
				$('#total-income').attr('data-value', totalIncome);
				fakeTotalIncome = currencify(totalIncome);
				$('#total-income').html(fakeTotalIncome);

				// update total expenses
				$('#total-expenses').attr('data-value', totalExpense);
				fakeTotalExpense = currencify(totalExpense);
				$('#total-expenses').html(fakeTotalExpense);		
				
				// update remaining balance
				var fakeRemainingBalance = '';
				if (remainingBalance < 0) {
					fakeRemainingBalance = '- ';
				}
				
				$('#remaining-balance').attr('data-value', remainingBalance);
				absoluteRemainingBalance = Math.abs(remainingBalance); // make negative balance positive to get rid of - symbol
				fakeRemainingBalance += currencify(Math.abs(absoluteRemainingBalance)); // make negative balance positive to get rid of - symbol
				$('#remaining-balance').html(fakeRemainingBalance);
				
				// update padding of #entries-container for when #info gets taller (when budget/income gets really long)
				var infoHeight = $('#info').height() + 10;
				$('#entries-container').css('padding-bottom', infoHeight + 'px');

			/* paid */

				// grab income from each PAID income text box and work out total
				$('#entries .income.paid input.amount').each(function(index) {
					incomeValue = parseFloat(this.value, 10);
					if (isNaN(incomeValue)) {
						incomeValue = 0;
					}
					totalPaidIncome += incomeValue;
				});
				
				// round total paid income to 2 decimal places
				totalPaidIncome = totalPaidIncome.toFixed(2);
				
				// grab expense from each PAID expense text box and work out total
				$('#entries .expense.paid input.amount').each(function(index) {
					expenseValue = parseFloat(this.value, 10);
					if (isNaN(expenseValue)) {
						expenseValue = 0;
					}
					totalPaidExpense -= expenseValue;
				});	
				
				// round total paid expense to 2 decimal places
				totalPaidExpense = totalPaidExpense.toFixed(2);
				
				// work out remaining paid
				remainingPaid = parseFloat(totalPaidIncome) + parseFloat(totalPaidExpense);
				
				// round remaining balance to 2 decimal places
				remainingPaid = remainingPaid.toFixed(2);		
				
				// update remaining paid
				var fakeRemainingPaid = '';
				if (remainingPaid < 0) {
					fakeRemainingPaid = '- ';
				}
				
				$('#remaining-paid').attr('data-value', remainingPaid);
				absoluteRemainingPaid = Math.abs(remainingPaid); // make negative balance positive to get rid of - symbol
				fakeRemainingPaid += currencify(Math.abs(absoluteRemainingPaid)); // make negative paid positive to get rid of - symbol
				$('#remaining-paid').html(fakeRemainingPaid);

		}
		
	/*
		>> initialize autogrow textarea
	*/
	
		function initializeAutogrowTextarea(textarea) {
			var innerHeight, cssHeight;
			getHeights(textarea);
			
			// adjust heights on load
			if (innerHeight !== cssHeight) {
				newHeight = innerHeight;
				textarea.css('height',  newHeight);
			}
			
			// adjust heights when typing
			textarea.on('keyup paste focus', function (e) {
				getHeights($(this));
				// user is deleting, backspacing or cutting
				if (!e || e.which === 8 || e.which === 46 || (e.ctrlKey && e.which === 88)) {
					$(this).removeAttr('style');
					getHeights($(this));
				}
				if (innerHeight !== cssHeight) {
					$(this).css({
						height: innerHeight
					});	
				}
			});			
			
			//get heights function
			function getHeights(selector) {
				innerHeight = selector[0].scrollHeight;
				cssHeight = selector.height();
			}
		}
	
	
	/*
		>> currencify	
		(converts 2344 to £ 2,344)
	*/

		function currencify(value) {
			value = parseFloat(value).toFixed(2);
			value = value.toString();
			return currencySymbol + ' ' + value.replace(/,/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",");
		}
	
		
	/*
		>> scroll and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
	*/
	
		function scrollAndOffset(selector) {
			// get browser y scroll position
			var browserScrollPosition = $(document).scrollTop();
			// scroll to top of the page, then offset entries container so it doesn't suddenly 'jump'
			$(selector).css('top', '-' + browserScrollPosition + 'px');	
			window.scrollTo(0, 0);
		}


	/*
		>> scroll to bottom and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
	*/
	
		function scrollToBottomAndOffset(selector) {
			// get browser y scroll position
			var browserScrollPosition = $(document).scrollTop();
			// scroll to bottom of the page, then offset entries container so it doesn't suddenly 'jump'
			$(selector).css('top', browserScrollPosition + ($(document).height()-$(window).height()) + 'px');	
			window.scrollTo(0, $(document).height()-$(window).height());
		}


	/*
		>> scroll to bottom
	*/
	
		function scrollToBottom() {
			window.scrollTo(0, $(document).height()-$(window).height());
		}


		
	/*
		>> near bottom - check if we're near the bottom of the page
	*/
	
		function nearBottom(pixels) {
			if($(window).scrollTop() + $(window).height() > $(document).height() - pixels) {
			    return true;
			}
			else {
				return false;	
			}
		}
	
	/*
		>> load all budgets
	*/
	
		var numberOfTimesBudgetsLoaded = 0;

		function loadAllBudgets(tx, rs) {
			var rowOutput = '';
			var $budgets = $('#budgets');
			var tableString;
			for (var i=0; i < rs.rows.length; i++) {
				var id = rs.rows.item(i).id;
				var title = rs.rows.item(i).title;
				rowOutput += '<div class="budget item clearfix clear" data-id="' + id + '">';
				rowOutput +=	'<div class="budget-details item-details clearfix theme-border">';
				rowOutput +=		'<textarea class="budget-title item-title off-page theme-color" rows="1" cols="20" placeholder="E.g. March">' + title + '</textarea>';
				rowOutput +=		'<p class="budget-title item-title fake theme-color">' + title + '</p>';
				rowOutput +=		'<i class="icon-arrow-right"></i>';
				rowOutput +=	'</div>';
				rowOutput +=	'<div class="budget-options item-options theme-bg theme-border">';
				rowOutput +=		'<div class="delete option">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-bin"></i>';
				rowOutput +=				'<span>Delete</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=		'<div class="rename option">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-edit"></i>';
				rowOutput +=				'<span>Rename</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=		'<div class="export option disabled-on-free">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-export"></i>';
				rowOutput +=				'<span>Export</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=	'</div>';
				rowOutput += '</div>';
			}
			$budgets.html(rowOutput);
			var t = setTimeout(function(){
				/*
				>>> choose which page to show first
				*/
				// budgets (default)
				if (localStorage.getItem('lastPage') === 'budgets') {
					// GA - track page
					gaTrackView('Budgets');
					// nudge settings container to the left a bit, for ios7 parallax effect
					$('#settings-container').css({x: '-90px'});
					// get entries container ready to be animated
					$('#entries-container').css('transform', 'translate(100%, 0px)');
					// fade in budgets container
					$('#budgets-container').fadeIn(function() {
						// remove styles from #budgets-container
						$('#budgets-container').attr('style', 'display: block;');
						// hide loading screen and show data restored message
						if (!$('#loading').hasClass('hidden')) {
							hideLoadingScreen();
           		    		// showNotification('Data restored from Dropbox', 'success', 4000)
						}
					});
					// show pro upgrade banner
					showProUpgradeBanner();
				}
				// entries
				else if (localStorage.getItem('lastPage') === 'entries') {
					// GA - track page
					gaTrackView('Entries');
					var lastBudgetId = localStorage.getItem('lastBudgetId');
					balance.webdb.getAllEntries(lastBudgetId, loadAllEntries);
					// add active class to budget
					$('#budgets .budget[data-id=' + lastBudgetId + ']').addClass('active');
					var budgetTitle = $('.budget[data-id=' + lastBudgetId + ']').find('textarea').val();
					$entriesTitleBarTitle.text(budgetTitle);
					// nudge budgets container to the left a bit, for ios7 parallax effect
					$('#budgets-container').css({x: '-90px'});
					// nudge settings container to the left a bit, for ios7 parallax effect
					$('#settings-container').css({x: '-90px'});
					// prompt for feedback if created over x entries
					if (localStorage.entriesMade >= showRateThisAppPopupAfterEntries && !localStorage.stopAsking) {
						// if user tapped Later, just show the review icon
						if (localStorage.tappedLater) {
							showReviewIcon();
						}
						// else prompt for feedback
						else {
							setTimeout(function(){
								promptForFeedback();
							}, 1000);
						}
					}
					setTimeout(function(){
						$info.removeClass('off-bottom');
					}, 300);
					// show entries container if we've never loaded budgets before
					if (numberOfTimesBudgetsLoaded === 0) {
						numberOfTimesBudgetsLoaded++;
						$('#entries-container').addClass('invisible').css('display', 'block');
						setTimeout(function(){
							// scroll to bottom
							window.scrollTo(0, $(document).height()-$(window).height());
							setTimeout(function(){
								$('#entries-container').removeClass('invisible');
							}, 200);
							$('#entries textarea.entry-title').each(function(index) {
								textarea = $(this);
								initializeAutogrowTextarea(textarea);
							});
						}, 500);
					}
				}
				// settings
				else if (localStorage.getItem('lastPage') === 'settings') {
					// GA - track page
					gaTrackView('Settings');
					// get entries container ready to be animated
					$('#entries-container').css('transform', 'translate(100%, 0px)');
					// show settings
					$('#settings-container').fadeIn();
					$('#budgets-container').hide().css({
						top: '0px',
						x: '100%'
					});
				}

				setTimeout(function(){
					// show 'new in version x popup' - if they've not already seen it
					if (!localStorage['seenNewVersionPopup'] && !localStorage.emergencyMode) {
						showNewVersionPopup();
					}
					// hide loading screen if it's there
					if (!$('#loading').hasClass('hidden')) {
						hideLoadingScreen();
					}

				}, 600);

			}, 500);
			$budgets.find('textarea.budget-title').each(function(index) {
				initializeAutogrowTextarea($(this));
			});
		}		
		
		
	/*
		>> load all entries
	*/
	
		function loadAllEntries(tx, rs) {

			var entriesMarkup = '';

			for (var i=0; i < rs.rows.length; i++) {
				// console.log('rs.rows.item(i): ', rs.rows.item(i));
				var id = rs.rows.item(i).entry_id;
				var title = rs.rows.item(i).title;
				var amount = rs.rows.item(i).amount;
				var pinned = rs.rows.item(i).pinned;
				var isexpense = rs.rows.item(i).isexpense;
				var paid = rs.rows.item(i).paid;
				var date = rs.rows.item(i).date;
				var entryType;
				var operator;
				var pinnedClass;
				var pinMarkup;
				var paidEntryClass;
				var paidOptionClass;
				var inputDate;
				var placeholderAttr;

				// fix null amount
				if (amount === null) {
					amount = 0;
				}

				if (isexpense === 1) {
					entryType = 'expense';
					operator = '-';
					amount = Math.abs(amount); // make the negative number positive
				}
				else {
					entryType = 'income';	
					operator = '+';
				}
				if (pinned === 1) {
					pinnedClass = 'pinned';	
					pinMarkup = '<div class="unpin option">';
					pinMarkup +=		'<div class="icon">';
					pinMarkup +=			'<i class="icon-star-filled"></i>';
					pinMarkup +=			'<span>Star</span>';
					pinMarkup +=		'</div>';
					pinMarkup +=	'</div>';
				}
				else {
					pinnedClass = '';
					pinMarkup = '<div class="pin option">';
					pinMarkup +=		'<div class="icon">';
					pinMarkup += 			'<i class="icon-star"></i>';
					pinMarkup += 			'<span>Star</span>';
					pinMarkup += 		'</div>';
					pinMarkup += 	'</div>';
				}
				// fix undefined amount
				if (amount === undefined) {
					amount = 0;
				}
				// paid / unpaid
				if (paid) {
					paidEntryClass = 'paid';
					paidOptionClass = 'paid'; 
				}
				else {
					paidEntryClass = '';
					paidOptionClass = 'unpaid';
				}
				// date
				if (date) {
					inputDate = unixToDate(date);
				}
				else {
					inputDate = '';
				}
				// placeholder
				if (date) {
					placeholderAttr = '';
				}
				else {
					placeholderAttr = 'placeholder="Date"';
				}

				var fakeInputTextNew = currencify(amount);
				entriesMarkup += '<div class="entry ' + entryType + ' ' + pinnedClass + ' ' + paidEntryClass + ' item clearfix clear" data-id="' + id + '">';
				entriesMarkup += 	'<div class="entry-details item-details clearfix theme-color theme-border">';
				entriesMarkup +=		'<textarea class="entry-title item-title off-page theme-color" rows="1" cols="20" autocapitalize="on" autocorrect="off" autocomplete="off">' + title + '</textarea>';
				entriesMarkup += 		'<p class="entry-title item-title fake theme-color">' + title + '</p>';
				entriesMarkup += 		'<input class="amount item-title invisible theme-color" type="' + numberInputType + '" value="' + amount + '" autocapitalize="off" autocorrect="off" autocomplete="off">';
				entriesMarkup += 		'<p class="amount item-title fake theme-color"><span>' + operator + ' ' + fakeInputTextNew + '</span></p>';
				// entriesMarkup += 		'<input type="text" class="entry-date theme-color" value="Nov ' + Math.floor((Math.random() * 30) + 1) + ' 2016">';
				entriesMarkup += 		'<input type="date" class="entry-date theme-color" ' + placeholderAttr + ' value="' + inputDate + '">';
				entriesMarkup += 	'</div>'; 
				entriesMarkup += 	'<div class="entry-options item-options theme-bg theme-border">';
				entriesMarkup += 		'<div class="delete option">';
				entriesMarkup +=			'<div class="icon">';
				entriesMarkup +=				'<i class="icon-bin"></i>';
				entriesMarkup +=				'<span>Delete</span>';
				entriesMarkup +=			'</div>';
				entriesMarkup +=		'</div>'; 
				entriesMarkup += 		pinMarkup;
				entriesMarkup += 		'<div class="' + paidOptionClass + ' option">';
				entriesMarkup += 			'<div class="icon"><i class="icon-' + paidOptionClass + '"></i>';
				entriesMarkup += 			'<span>Paid</span></div>';
				entriesMarkup += 		'</div>';
				entriesMarkup +=		'<div class="calculator option disabled-on-free">';
				entriesMarkup +=			'<div class="icon">';
				entriesMarkup +=				'<i class="icon-calculator"></i>';
				entriesMarkup +=				'<span>Calc.</span>';
				entriesMarkup +=			'</div>';
				entriesMarkup +=		'</div>'; 
				entriesMarkup += 	'</div>';
				entriesMarkup += '</div>';
			}
			$('#entries').html(entriesMarkup).promise().done(function() {

				finishedLoadingEntries = true;

				// scroll to bottom
				// scrollToBottom();
				// loop through entries, adding paid classes
				var budgetId = parseInt($('#budgets .budget.active').attr('data-id'));
				$('#entries .entry').each(function(index) {
					var $this = $(this);
					var entryId = parseInt($this.attr('data-id'));
					// set a class if the item is paid
					/*(function(budgetId, entryId){
						$.when(balance.webdb.isPaid(budgetId, entryId)).done(function(result) {
							if (result === 'true') {
								$this.addClass('paid');
								$this.find('.option.unpaid').removeClass('unpaid').addClass('paid');
								$this.find('.icon-unpaid').removeClass('icon-unpaid').addClass('icon-paid');
								// when last item has been marked as paid
								if (index === ($('#entries .entry').length - 1)) {
									calculateIncomeAndBalance();
								}
							}
						});
					}(budgetId, entryId));*/

					// add the date if there is one
					/*(function(budgetId, entryId){
						$.when(balance.webdb.getDate(budgetId, entryId)).done(function(date) {
							if (date > 0) {
								unixDate = unixToDate(date);
								$this.find('.entry-date').val(unixDate);
								// when last date has been added
								if (index === ($('#entries .entry').length - 1)) {
									calculateIncomeAndBalance();
								}
							}
						});
					}(budgetId, entryId));*/
				});

				setTimeout(function(){
					calculateIncomeAndBalance();
					// find out if there are any starred entries
					$.when(balance.webdb.hasStarredEntries()).done(function(result) {
						// if there are starred items...
						if (result === 'true') {
							// .. and if this budget is empty, ask if user wants to add starred items
							if (rs.rows.length === 0) {
	
								// confirm add starred items
								nativeConfirm(
									'Add your Starred items to this budget?',	// message
									addStarredConfirm,					        // callback
									'Add Starred items?',						// title
									['No', 'Yes'],							    // button labels
									null,									    // fallback message
									2										    // fallback - ok pressed
								);

								// confirm add starred items callback
								function addStarredConfirm(buttonIndex) {
									// yes pressed
									if (buttonIndex === 2) {
										// add Starred items
										balance.webdb.addPinnedEntriesToBudget(budgetId);
									}
								}

							}
						}
					});

				}, 750);
			});

		}
		
		
		
	/*
		>> export budget
	*/
	
		function exportBudget(tx, rs) {
			showLoadingScreen();
			var csvText = '';
			var amounts = new Array(); // array to keep the amounts
			// get the title of the budget
			var budgetTitle = $('.budget.showing-options,.budget.active').eq(0).find('textarea.budget-title').val();
			// remove punctuation marks from  title
			budgetTitle = budgetTitle.replace(/[\.,-\/#!$%\^&\*;:{}=\-_`~()]/g,"");
			console.log('rs', rs);
			// get all the titles and amounts
			for (var i=0; i < rs.rows.length; i++) {
				var id = rs.rows.item(i).id;
				var title = rs.rows.item(i).title;
				var titleCleaned = title.replace(/"/g, '""');
				var amount = rs.rows.item(i).amount;
				var amountFixed = parseFloat(amount).toFixed(2);

				// push amount to array
				amounts.push(amount);

				// get date
				var budgetId = rs.rows.item(i).budget_id;
				var entryId = rs.rows.item(i).entry_id;

				(function(i, budgetId, entryId, titleCleaned, amountFixed){
					var dateNice;
					// var date = balance.webdb.getDate(budgetId, entryId);
					$.when(balance.webdb.getDate(budgetId, entryId)).done(function(date) {
						dateNice = unixToNiceDate(date);
						// create csv text
						csvText += '"' + titleCleaned + '","' + amountFixed + '","' + dateNice + '"\n';
					});
				}(i, budgetId, entryId, titleCleaned, amountFixed));


			}
			setTimeout(function(){
				
				// calculate balance and add to csv text
				var balanceCalculated = amounts.reduce(add, 0);
				var balanceFixed = parseFloat(balanceCalculated).toFixed(2);
				function add(a, b) {
				    return a + b;
				}
				csvText += '"BALANCE",' + '"' + balanceFixed + '"';
				console.log('csvText: ', csvText);

				// base64 encode csv text
				encodedCsvText = Base64.encode(csvText);

				// do the share
				window.plugins.socialsharing.shareViaEmail(
				   null, 
				   'Fudget - ' + budgetTitle + ' budget export',
				   null, null, null, 
				   ['data:' + budgetTitle + '.csv;text/csv;base64,' + encodedCsvText]
				   // ['data:image/png;base64,R0lGODlhDAAMALMBAP8AAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUKAAEALAAAAAAMAAwAQAQZMMhJK7iY4p3nlZ8XgmNlnibXdVqolmhcRQA7']
				);

				hideLoadingScreen();
			}, 1250);

		}
	
		
	/*
		>> add id to budget markup	
	*/
	
		function addIdToBudgetMarkup($budgetMarkup, id) {
			$budgetMarkup.attr('data-id', id);
		}
		
		
	/*
		>> add id to entry markup
	*/
	 
		function addIdToEntryMarkup($entryMarkup, id) {
			$entryMarkup.attr('data-id', id);
		}
		

	/*
		>> update count of entries made - show 'rate this app' every 50 entries & 'rate this app' button after first 50
	*/
	
		function updateEntriesMade() {
			if (!localStorage.entriesMade) {
				localStorage.entriesMade = 0;
			}
			localStorage.entriesMade ++;
			if (localStorage.entriesMade >= showRateThisAppPopupAfterEntries) {
				localStorage.showRateThisAppButton = true;
			}
		}


	/*
		>> do login
	*/

		function doLogin() {
 
			// show splash screen
			navigator.splashscreen.show();

			setTimeout(function() {
				// if touch id login enabled, show touch id login
				if (localStorage.getItem('touchIdLogin') === 'true') {
					// attempt touch id login
					touchid.authenticate(touchIdSuccess, touchIdFailure, 'Unlock fudget');
					function touchIdSuccess() { 
						// hide splash screen
						navigator.splashscreen.hide();
						setupAdmob();
					}
					function touchIdFailure() {
						// prompt for pin code to log in
						promptForPinCodeLogin("Enter passcode");
					}  
				}
				else {
					// prompt for pin code to log in
					promptForPinCodeLogin("Enter passcode"); 
				}
		    }, 200);

			function promptForPinCodeLogin(title) {

				// if user has entered an email address, show the forgot password button as well as ok
				if (localStorage.emailAddress && localStorage.emailAddress !== '' && title === 'Incorrect passcode') {
					pinPromptButtons = ["Ok", "Forgot password"];
				}
				else {
					pinPromptButtons = ["Ok"];
				}

				// show the dialog
				window.plugins.pinDialog.prompt(
					"Please enter your passcode to log in.",
					checkPin,
					title,
					pinPromptButtons
				);
			}

			function checkPin(results) {
				// clicked Ok
				if(results.buttonIndex == 1) {
					// pin correct, login
					if (results.input1 === localStorage.pinCode) {
						// hide splash screen
						navigator.splashscreen.hide();
						setupAdmob();
					}
					else {
						promptForPinCodeLogin("Incorrect passcode");
					}
				}
				// clicked Forgot password
				else if (results.buttonIndex == 2) {
					/// emailjs.send("gmail","fudget_passcode_reminder",{to: localStorage.emailAddress, content: "Your passcode is: " + localStorage.pinCode});

					// send email using mailgun.dconnell.co.uk
					$.ajax({
						url: 'http://mailgun.dconnell.co.uk',
						method: 'GET',
						dataType: 'json',
						data: {
							'from' : 'fudget@dconnell.co.uk',
							'from_name' : 'Fudget',
							'to' : localStorage.emailAddress,
							'subject' : 'Fudget passcode reminder',
							'text' : 'Your Fudget passcode is: ' + localStorage.pinCode,
						},
						success: function(data){
							console.log(data);
							var statusCode = data.http_response_code;
							var message = data.http_response_body.message;

							if (statusCode === 200) {
								nativeAlert(
									'Your passcode will shortly be emailed to ' + localStorage.emailAddress,
									null,
									'Passcode reminder'
								);
							}
							else {
								nativeAlert(
									'Sorry, your passcode could not be sent: ' + message,
									null,
									'Error'
								);
							}
						}
					});


				}
			}	

		}


	/* 
		>> log
	*/
		
		var logEnabled = false;
		
		function log(label, message) {
			if (logEnabled) {

				// sort out parameters
				if (typeof(message) === 'undefined') {
					message = label;
					label = '';
				}

				// add the log markup
				if ($('.log').length <= 0) {
					$('<div class="log"><pre></pre></div>').appendTo('body');
				}

				// do console.log too
				if (label !== '') {
					console.log(label, message);
				}
				else {
					console.log(message);
				}

				// if its an object
				if (typeof(message) === 'object') {
					message = JSON.stringify(message, null, 4);
				}

				// add log text to markup
				logText += '<div class="log-line">' + label + message + '</div>';
				$('.log pre').html(logText);

				// scroll to bottom 
				$('.log pre').scrollTop(1E10);

				// setup click events
				$('body').on('click', '.log', function (e) {
					if (!$('.log').hasClass('clicked')) {
						$('.log').addClass('clicked');
					}
					$('.log').toggleClass('hide');
				});

			}
		}
		
		function clearLog() {
			logText = '';
		}
		
	/*
		>> show pro upgrade banner
	*/
	
		var proUpgradeBannerTimer;
	
		function showProUpgradeBanner() {
			
			proUpgradeBannerTimer = setTimeout(function(){
				$('.pro-upgrade-banner-slides').slick('slickGoTo', 0, false);
				$proUpgradeBanner.removeClass('off-bottom');
			}, 1500);
			
		}
		
	/*
		>> hide pro upgrade banner
	*/
	
		function hideProUpgradeBanner() {
			clearTimeout(proUpgradeBannerTimer);
			$proUpgradeBanner.addClass('off-bottom');
		}
		
	/*
		>> enable pro version
	*/

		function enableProVersion() {
			// add pro class to body
			$('body').addClass('pro');
			// hide ads
			try {
				if (AdMob) {
					AdMob.hideBanner();
				}
			}
			catch (e) {}
			// hide house ads
			$('.house-ad-iframe').remove();
			// hide pro popups
			$('.pro-upgrade-feature-popup').hide().transition({y: '100%'});
			// close pro upgrade popup
			$('#pro-upgrade-popup').hide().transition( {y: '100%'});
			// set variables
			freeVersion = false;
			proVersion = true;
			// local storage
			localStorage['IAPfudgetProUpgrade'] = true;
		}

	/*
		>> disable pro version
	*/

		function disableProVersion() {
			// remove pro class from body
			$('body').removeClass('pro');
			// show pro popups
			$('.pro-upgrade-feature-popup').show();
			// turn off dropbox save & restore
			localStorage.dropboxSaveAndRestore = false;
			// hide dropbox options
			$('.dropbox-options').addClass('hidden');
			// set variables
			freeVersion = true;
			proVersion = false;
			// local storage
			localStorage.removeItem('IAPfudgetProUpgrade');	
		}

	/*
		>> show already upgraded popup
	*/

		function showAlreadyUpgradedPopup() {
			nativeAlert(
				'You can now enjoy:\n\r\n\rDropbox Save & Restore: Enable on the Settings page, then save or restore your data at anytime from the Settings page or Options menu\n\r\n\rThemes: Go to Settings > Themes\n\r\n\rExport: Swipe left on a budget & tap Export\n\r\n\rCalculator: Swipe left on an expense or income & tap Calculator\n\r\n\rNo ads: Enjoy Fudget ad-free',
				null,
				'Thanks for upgrading!'
			);
		}


	/*
		>> show & hide review icon
	*/

		function showReviewIconAndHint() {
			$('.show-feedback-module').removeClass('off-screen');
			$('.feedback-icon-hint').removeClass('hidden');
			setTimeout(function(){
				$('.feedback-icon-hint').removeClass('fade-out');
				setTimeout(function(){
					$('.feedback-icon-hint').addClass('fade-out');
				}, 4000);
			}, 500);
			localStorage.tappedLater = true;
		}

		function showReviewIcon() {
			$('.show-feedback-module').removeClass('off-screen');
		}

		function hideReviewIcon() {
			$('.show-feedback-module').addClass('off-screen');
		}

	/*
		>> prompt for feedback, review, email
	*/

		function promptForFeedback() {

			// if user has previously reviewed, show different text
			if (localStorage.userReviewed) {
				$('.user-has-reviewed').removeClass('hidden');
				$('.user-not-reviewed').addClass('hidden');
			}

			// show feedback module
			$('.feedback-module').removeClass('hidden');
			setTimeout(function(){
				$('body').addClass('show-feedback-module');
			}, 100);

			// show close button after a delay
			// setTimeout(function(){
			// 	$('.feedback-module .icon-delete').removeClass('hidden');
			// }, 2500);

			// GA - track feedback - prompt - show prompt
			gaTrackEvent('Feedback', 'Show feedback prompt', null);

			// happy
			$('.happy').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - tapped "happy"
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped "Happy"', null);
				// hide prompt for feedback pane
				$('.prompt-for-feedback').addClass('off-left');
				// prompt for review
				promptForReview();
				// remove click event
				$(this).unbind('click');
			});

			// not happy
			$('.not-happy').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - tapped "not happy"
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped "Not Happy"', null);
				// hide prompt for feedback pane
				$('.prompt-for-feedback').addClass('off-left');
				// prompt for email
				promptForEmail();
				// remove click event
				$(this).unbind('click');
			});

			// close feedback module
			$('.close-feedback-module').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - closed feedback module
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped close button', null);
				// hide feedback module
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);

				// stop showing the review icon
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');

				// remove click event
				$(this).unbind('click');

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 1000);
			});
		}

		function promptForReview() {

			// show prompt for review pane
			$('.prompt-for-review').removeClass('off-right');

			// review this app
			$('.prompt-for-review .review-this-app').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "Ok"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "Ok"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				localStorage.userReviewed = true;
				// hide review icon
				hideReviewIcon();
				// open review link
				setTimeout(function(){
					// android
					if (platform === 'Android') {
						try {
						    window.open(appReviewUrl, '_system'); 
						}
						catch(err) {
						    window.open(appReviewUrlFallback, '_system'); 
						}
					}
					// ios
					else {
						window.open(appReviewUrl, '_system'); 
					}
				}, 250);
				// remove click event
				$(this).unbind('click');
			});

			// later
			$('.prompt-for-review .later').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "later"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "Later"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				// remove click event
				$(this).unbind('click');

				// show review icon and hint
				showReviewIconAndHint();

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 1000);
			});

			// no thanks
			$('.prompt-for-review .no-thanks').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "no thanks"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "No thanks"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');
			});

		}

		function promptForEmail() {

			// show prompt for email pane
			$('.prompt-for-email').removeClass('off-right');

			// send message
			$('.prompt-for-email .send-message').click(function (e) {
				e.preventDefault();
				// GA - track feedback - send feedback? - tapped "Ok"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "Ok"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// open email link
				setTimeout(function(){
					window.open(feedbackUrl, '_system');
				}, 250);
				// remove click event
				$(this).unbind('click');
			});

			// later
			$('.prompt-for-email .later').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "later"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "Later"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				// remove click event
				$(this).unbind('click');

				// show review icon and hint
				showReviewIconAndHint();

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 2000);
			});

			// no thanks
			$('.prompt-for-email .no-thanks').click(function (e) {
				e.preventDefault();
				// GA - track feedback - send feedback? - tapped "No thanks"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "No thanks"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');
			});

		}

		function promptResetStyles() {
			// reset styles
			$('.prompt-for-feedback').removeClass('off-left');
			$('.prompt-for-review, .prompt-for-email').addClass('off-right');
		}


	/*
		>> admob or house ads
	*/

		function setupAdmob() {
			if (!localStorage['IAPfudgetProUpgrade']) {

				// ios
				if (platform === 'iOS') {

					// try for a house ad
					$.ajax({
						url: houseAdUrl,
						success: function(data) {
							var $iframe = $('<iframe class="house-ad-iframe" src="' + houseAdUrl + '" frameborder="0" width="320" height="50"></iframe>');
							$iframe.appendTo('body');
						},
						// couldn't find house ad, load admob ad
						error: function(XMLHttpRequest, textStatus) { 
							bannerAdId = 'ca-app-pub-6346367103336512/8283337185';
							createBanner();
						}
					});	

				}
				// android
				else if (platform === 'Android') {
					// bannerAdId = 'ca-app-pub-6346367103336512/3434114382'; // old fudget app id
					bannerAdId = 'ca-app-pub-6346367103336512/4661068785';
					createBanner();
				}

				function createBanner() {

					if (platform === 'iOS') {
						bannerOptions = {
							adId: bannerAdId, 
							position: AdMob.AD_POSITION.BOTTOM_CENTER, 
							// position: AdMob.AD_POSITION.POS_XY, x:100, y:200, 
							autoShow: true,
							overlap: true
						}
					}
					else {

						if ($(window).width() < 600) {
							bannerHeight = 50
						}
						else {
							bannerHeight = 100;
						}

						bannerOptions = {
							adId: bannerAdId, 
							position: AdMob.AD_POSITION.BOTTOM_CENTER, 
							adSize: 'CUSTOM',
							height: bannerHeight,
							width: Math.min($(window).width(), $(window).height()),
							autoShow: true,
							overlap: true
						}
					}

					if(AdMob) AdMob.createBanner( 
						bannerOptions
					);
				}

			}

		}

		function refreshBanner() {
			setTimeout(function(){
				if (freeVersion) {
					AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER); 
				}
			}, 1000);	
		}

   	/*
   		>> check pro trial expired
   	*/

   		function checkProTrialExpired() {
			var proTrialExpiryDate = localStorage['proTrialExpiryDate'];
			var currentDate = new Date().getTime(); 
			// pro trial has expired
			if (proTrialExpiryDate < currentDate) {
				// disable 'try pro' button
 				gaTrackEvent('Upgrade Popup', 'Upgrade Popup > Try Pro > Pro Trial Expired', null);
				$('.try-pro').addClass('disabled');
				if (!localStorage['seenProTrialExpiredPopup']) {
					// disable pro version
					disableProVersion();

	       			// pro trial expired confirm
	       			nativeConfirm(
	       				'Did you enjoy the Pro features?\n\rIf so, please upgrade to Fudget Pro now!',	// message
	       				proTrialExpiredCallback,					                                    // callback (with tapped button index as parameter)
	       				'Thanks for trying Fudget Pro!',						                        // title
	       				['Close', 'Upgrade now'],							                        	// button labels
	       				null,									                                        // fallback (null if confirm fallback needed, string or function)
	       				2										                                        // fallback - ok pressed (button index to fire - omit if no confirm required)
	       			);

	       			// pro trial expired confirm callback
	       			function proTrialExpiredCallback(buttonIndex) {
	       				if (buttonIndex === 2) {
	       					// show pro upgrade popup
	       					$('.show-pro-upgrade-popup').first().trigger('click');
	       				}
	       			}
	       			// add seenProTrialExpiredPopup localStorage entry 
	       			localStorage['seenProTrialExpiredPopup'] = true;
				}
			}
   		}

   	/*
   		>> show & hide loading screen
   	*/

   		function showLoadingScreen(message) {
   			if (typeof message !== 'undefined') {
   				$('#loading .text').text(message);
   			}
   			else {
   				$('#loading .text').text('');
   			}
   			$('#loading').removeClass('hidden');
   		}

   		function hideLoadingScreen() {
   			$('#loading').addClass('hidden');
   		}




	/*
		>> ga - track view (page)
	*/

		function gaTrackView(view) {
			if(window.cordova && typeof window.analytics !== undefined) {
				try {
					window.analytics.trackView(view);
				}
				catch(err) {
					console.log('Google Analytics error: ' + err);
				}  
			}
		}


	/*
		>> ga - track event
	*/

		function gaTrackEvent(category, action, label) {
			if(window.cordova && typeof window.analytics !== undefined) {
				try {
					window.analytics.trackEvent(category, action, label);
					// log(category + ', ' + action + ', ' + label);
				}
				catch(err) {
					console.log('Google Analytics error: ' + err);
				}   
			}
		}


   	/*
   		>> show new version popup
   	*/

   		function showNewVersionPopup() {

			nativeAlert(
				newVersionMessage,
				null,
				'New in Fudget version ' + versionNumber,
				'Ok'
			);

			// update localStorage
			localStorage['seenNewVersionPopup'] = true;		
   		}

   	/*
   		>> show notification
   		this will show a notification at the bottom, use it like: showNotification('This is the message', 'error');
   		2nd parameter specifies the type of notification to show, and can be 'error', 'warning', 'success' or 'notice'
   	*/

   		function showNotification(message, type, time) {
   			var $notification = $('.notification')
   			// add the message to the notification
   			$notification.find('.message').text(message);
   			// add correct classes
   			$notification.removeClass('error warning success notice');
   			$notification.addClass(type);
   			// show it
   			$notification.addClass('show');
   			// setup click event to close it
   			$notification.click(function (e) {
   				$notification.removeClass('show');
   				$notification.unbind('click');
   			});
   			// hide after ms if time specified
   			if (typeof time !== 'undefined') {
   				setTimeout(function(){
   					$notification.trigger('click');
   				}, time);
   			}
   		}

   	/*
   		>> native alert
   		show a native alert, or a browser alert as a fallback
   	*/

   		window.nativeAlert = function (message, callback, title, button) {
   		    if(typeof callback === 'undefined')callback = null;
   		    title = (title != undefined) ? title : 'Alert';
   		    button = (button != undefined) ? button : 'Ok';

   		    if (navigator.notification) {
   		        navigator.notification.alert(
   		            message, // message
   		            callback, //callback method... 
   		            title, // title
   		            button // buttonName
   		        );
   		    } else {
   		    	// if only a title was specified, use that as the message
   		    	if (message === null) {
   		    		message = title;
   		    	}
   		        alert(message);
   		        if(typeof callback === "function") callback();
   		    }
   		};


   	/*
   		>> native confirm
   		show a native confirm, or a browser confirm as a fallback
   		if fallback is provided, if string, alert will be shown, if function, function will be fired
   		if fallbackOkButtonIndex is not provided, then no fallback confirm will be shown
   	*/

   		window.nativeConfirm = function (message, callback, title, buttonLabels, fallback, fallbackOkButtonIndex, fallbackCancelButtonIndex) {
   		    title = (title != undefined) ? title : 'Confirm';

   		    // native confirm
   		    if (navigator.notification) {
   		        navigator.notification.confirm(
   		            message, // message
   		            callback, //callback method...
   		            title, // title
   		            buttonLabels // button labels (e.g. ['No', 'Yes'])
   		        );
   		    }
   		    // browser fallback (alert or function)
   		    else if (fallback !== null) {
   		    	// if string provided, alert the string
   		    	if (typeof fallback === 'string') {
	   		    	alert(fallback);
   		    	}
   		    	// else if function provided, fire it
   		    	else if (typeof fallback === 'function') {
   		    		fallback();
   		    	}
   		    }
   		    // browser fallback ok/cancel button index (fire the standard callback with these buttonIndex's)
   		    else if (fallbackOkButtonIndex !== undefined) {
   		    	var browserConfirm = confirm(message);
   		    	if (browserConfirm === true && fallbackOkButtonIndex !== undefined) {
   		    	    callback(fallbackOkButtonIndex);
   		    	}
   		    	else if (browserConfirm === false && fallbackCancelButtonIndex !== undefined) {
   		    		callback(fallbackCancelButtonIndex);
   		    	}
   		    }
   		};
   		

   	/*
   		>> native prompt
   	*/

   		window.nativePrompt = function (message, callback, title, buttonLabels, defaultText, fallbackFunction, fallbackOkButtonIndex) {
   		    title = (title != undefined) ? title : 'Prompt';

   		    if (navigator.notification) {
   		        navigator.notification.prompt(
   		            message,      // message
   		            callback,     //callback method...
   		            title,        // title
   		            buttonLabels, // button labels (e.g. ['No', 'Yes'])
   		            defaultText   // default text in field
   		        );
   		    }
   		    else if (fallbackFunction !== undefined && fallbackFunction !== null) {
   		    	fallbackFunction();
   		    }
   		    else {
   		    	var browserPrompt = prompt(message, defaultText);
   		    	if (browserPrompt !== null) {
   		    		var result = {};
   		    		result.buttonIndex = fallbackOkButtonIndex || 1;
   		    		result.input1 = browserPrompt;
   		    	    callback(result);
   		    	}
   		    }
   		};


   	/*
   		>> date to unix timestamp
   	*/

   		function dateToUnix(date) {
   			var dateArray = date.split('-'),
   			year = parseInt(dateArray[0]),
   			month = parseInt(dateArray[1]) - 1,
   			day = parseInt(dateArray[2]),
   			dateObject = new Date(year, month, day),
   			dateUnix = dateObject.getTime();

   			return dateUnix;
   		}


   	/*
   		>> unix timestamp to date
   	*/

   		function unixToDate(dateUnix) {
   			var dateObject = new Date(dateUnix),
   			year = dateObject.getFullYear(),
   			month = zeroPad(dateObject.getMonth() + 1,2),
   			day = zeroPad(dateObject.getDate(),2),
   			date = year + '-' + month + '-' + day;

   			return date;
   		}


   	/*
   		>> unix timestamp to nice date
   	*/

   		function unixToNiceDate(dateUnix) {

   			console.log('dateUnix: ', dateUnix);

   			if (dateUnix === 0 || dateUnix === null || dateUnix === undefined) {
   				date = '';
   			}
   			else {
	   			var dateObject = new Date(dateUnix),
	   			year = dateObject.getFullYear(),
	   			months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
	   			month = dateObject.getMonth(),
	   			niceMonth = months[month],
	   			day = dateObject.getDate();

	   			var date = niceMonth + ' ' + day + ' ' + year;
	   		}

   			return date;
   		}


   	/*
   		>> zero padding
   	*/

   		function zeroPad(num,count) {
   			var numZeropad = num + '';
   			while(numZeropad.length < count) {
   				numZeropad = "0" + numZeropad;
   			}
   			return numZeropad;
   		}

	/*
		>> get android version
	*/

		function getAndroidVersion(ua) {
		    ua = (ua || navigator.userAgent).toLowerCase(); 
		    var match = ua.match(/android\s([0-9\.]*)/);
		    return match ? match[1] : false;
		}


	/*
		>> enable emergency mode
	*/

		function enableEmergencyMode() {
			localStorage.emergencyMode = true;
			localStorage.seenNewVersionPopup = true;
			localStorage.firstRunTutorialDisplayed = true;	
			$('.emergency-options').removeClass('hidden');
		}

	/*
		>> disable emergency mode
	*/

		function disableEmergencyMode() {
			localStorage.removeItem('emergencyMode');
			localStorage.emergencyModeDisabled = true;
			$('.emergency-options').addClass('hidden');

			// save data to persistent storage
			persistent.saveDatabase();
		}


