// @koala-append "variables.js"
// @koala-append "device-models.js"
// @koala-append "database.js"
// @koala-append "database-sync.js"
// @koala-append "persistent-sync.js"
// @koala-append "global.js"
// @koala-append "functions.js"
// @koala-append "tutorial.js"

/* -----------------------------------------------------------------------------------
	> global variables
--------------------------------------------------------------------------------------- */

	versionNumber = '1.5.3'; // MAKE SURE YOU UPDATE THIS EVERY VERSION!
	// IOS: newVersionMessage = 'Dates - you can now add dates to all of your items! Enable the Date Column via the menu or Settings page';
	newVersionMessage = '- Dropbox Save & Restore - save your data to Dropbox and restore to any mobile device - even share with a loved one!\n\r - Dates - you can now add dates to all of your items! Enable the Date Column via the menu or Settings page\n\r - You can now toggle between "overall balance" and "paid balance" - just tap in the balance area';
	var logText = '';
	itemHeightDefault = 49;
	freeVersion = false;
	proVersion = true;
	demoMode = true; // demo mode will not connect to iaps and will unlock any iaps immediately
	hasHistory = false;
    localStorage['IAPfudgetProUpgrade'] = true;

	showRateThisAppPopupAfterEntries = 25;
	// showRateThisAppPopupAfterEntries = 5;

	pageTransitionLength = 300;
	animateTutorialSlides = true;

	platform = 'Browser';

	// input type for number entry
	numberInputType = 'number';

	appWebsiteUrl = 'http://fudget.dconnell.co.uk/';

	// dropbox sync variables
	dropboxZipMode = true; // whether or not user data should be stored zipped on dropbox
	sawCouldntCheckForChangesOnDropbox = false; // whether user has seen the 'couldn't check for changes on Dropbox' notification
	tryDropboxAgainTimeout = 10000; // how long to wait before trying to connect to dropbox again after a failed attempt
	currentlyCheckingForChangesOnDropbox = false;
	gettingRevisions = false; // whether we are in the process of grabbing dropbox revisions for data file

	// house ads
	houseAdUrl = 'http://fudget.dconnell.co.uk/assets/house-ad/index.html';

	// books url
	booksUrl = 'http://fudget.dconnell.co.uk/books'

	// pickadate options
	var datePicker;
	pickadateOptions = {
		container: '.datepicker-container',
		format: 'mmm dd yyyy',
		onSet: function(result) {
			var $inputElement = $(this.$node[0]);
			var $entry = $inputElement.parent().parent();

			var date = result.select;
			var budgetId = parseInt($('#budgets .budget.active').attr('data-id'));
			var entryId = parseInt($entry.attr('data-id'));

			// add date to database
			balance.webdb.editDate(budgetId, entryId, date);
		}
	}

deviceModels = {
	'iPad1,1'  : 'iPad 1',
	'iPad2,1'  : 'iPad 2',
	'iPad2,2'  : 'iPad 2',
	'iPad2,3'  : 'iPad 2',
	'iPad2,4'  : 'iPad 2',
	'iPad3,1'  : 'iPad 3',
	'iPad3,2'  : 'iPad 3',
	'iPad3,3'  : 'iPad 3',
	'iPad3,4'  : 'iPad 4',
	'iPad3,5'  : 'iPad 4',
	'iPad3,6'  : 'iPad 4',
	'iPad4,1'  : 'iPad Air 1',
	'iPad4,2'  : 'iPad Air 1',
	'iPad4,3'  : 'iPad Air 1',
	'iPad5,3'  : 'iPad Air 2',
	'iPad5,4'  : 'iPad Air 2',
	'iPad6,7'  : 'iPad Pro (12.9 inch)',
	'iPad6,8'  : 'iPad Pro (12.9 inch)',
	'iPad6,3'  : 'iPad Pro (9.7 inch)',
	'iPad6,4'  : 'iPad Pro (9.7 inch)',

	'iPad2,5'  : 'iPad mini 1',
	'iPad2,6'  : 'iPad mini 1',
	'iPad2,7'  : 'iPad mini 1',
	'iPad4,4'  : 'iPad mini 2',
	'iPad4,5'  : 'iPad mini 2',
	'iPad4,6'  : 'iPad mini 2',
	'iPad4,7'  : 'iPad mini 3',
	'iPad4,8'  : 'iPad mini 3',
	'iPad4,9'  : 'iPad mini 3',
	'iPad5,1'  : 'iPad mini 4',
	'iPad5,2'  : 'iPad mini 4',

	'iPhone1,1': 'iPhone 1',
	'iPhone1,2': 'iPhone 3G',
	'iPhone2,1': 'iPhone 3GS',
	'iPhone3,1': 'iPhone 4',
	'iPhone3,2': 'iPhone 4',
	'iPhone3,3': 'iPhone 4',
	'iPhone4,1': 'iPhone 4S',
	'iPhone5,1': 'iPhone 5',
	'iPhone5,2': 'iPhone 5',
	'iPhone5,3': 'iPhone 5c',
	'iPhone5,4': 'iPhone 5c',
	'iPhone6,1': 'iPhone 5s',
	'iPhone6,2': 'iPhone 5s',
	'iPhone7,2': 'iPhone 6',
	'iPhone7,1': 'iPhone 6 Plus',
	'iPhone8,1': 'iPhone 6s',
	'iPhone8,2': 'iPhone 6s Plus',
	'iPhone8,4': 'iPhone SE',
	'iPhone9,1': 'iPhone 7',
	'iPhone9,3': 'iPhone 7',
	'iPhone9,2': 'iPhone 7 Plus',
	'iPhone9,4': 'iPhone 7 Plus',

	'iPod1,1'  : 'iPod touch 1',
	'iPod2,1'  : 'iPod touch 2G',
	'iPod3,1'  : 'iPod touch 3G',
	'iPod4,1'  : 'iPod touch 4G',
	'iPod5,1'  : 'iPod touch 5G',
	'iPod7,1'  : 'iPod touch 6G'
}





/*
* database.js
*
* CONTENTS
*
* open the database
* delete the database
* create tables
* check for errors
* database opened successfully
* get all budgets
* add budget
* edit budget
* update budget order number
* delete budget
* get all entries
* add entry
* edit entry
* update entry order number
* delete entry
* pin entry
* unpin entry
*/

	var balance = {};
	balance.webdb = {};
	balance.webdb.db = null;
	
	/*
		> open the database
	*/
		
		balance.webdb.open = function() {
			var dbSize = 1024 * 1024 * 5; // 5MB
			balance.webdb.db = openDatabase('Balance', '1.0', 'Balance iPhone App', dbSize);
		}
		

	/*
		> delete the database
	*/

		balance.webdb.deleteDatabase = function() {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				tx.executeSql("DROP TABLE budgets", [], null, balance.webdb.onError);
				tx.executeSql("DROP TABLE entries", [], null, balance.webdb.onError);
				tx.executeSql("DROP TABLE budgets_entries", [], null, balance.webdb.onError);
				tx.executeSql("DROP TABLE paid", [], null, balance.webdb.onError);
			});
		}


	/*
		> create tables
	*/
	
		balance.webdb.createTables = function() {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				// budgets
				tx.executeSql('CREATE TABLE IF NOT EXISTS budgets(id INTEGER PRIMARY KEY ASC AUTOINCREMENT, title TEXT, order_number INTEGER, date_created DATETIME)', [], null, balance.webdb.onError);
				// entries
				tx.executeSql('CREATE TABLE IF NOT EXISTS entries(id INTEGER PRIMARY KEY ASC AUTOINCREMENT, title TEXT, amount FLOAT, pinned INTEGER DEFAULT 0, isexpense INTEGER DEFAULT 0, date_created DATETIME)', [], null, balance.webdb.onError);
				// budgets_entries
				tx.executeSql('CREATE TABLE IF NOT EXISTS budgets_entries(id INTEGER PRIMARY KEY ASC AUTOINCREMENT, budget_id INTEGER, entry_id INTEGER, order_number INTEGER)', [], null, balance.webdb.onError);
				// paid
				tx.executeSql('CREATE TABLE IF NOT EXISTS paid(id INTEGER PRIMARY KEY ASC AUTOINCREMENT, budgets_entries_id INTEGER)', [], null, balance.webdb.onError);
				// dates
				tx.executeSql('CREATE TABLE IF NOT EXISTS dates(id INTEGER PRIMARY KEY ASC AUTOINCREMENT, budgets_entries_id INTEGER, date)', [], null, balance.webdb.onError);
			});	
			// check if database deleted by iOS
			if (platform !== 'Browser') {
				// only if user has not disabled emergency mode
				if (!localStorage.emergencyModeDisabled) {
					persistent.checkIfDatabaseDeletedByIOS(balance.webdb.getAllBudgets);
				}
			}
		}
		
	/*
		> check for errors
	*/ 
	
		balance.webdb.onError = function(tx, error){
			hideLoadingScreen();
			// alert('There has been an error: ' + error.message);	
			console.log('There has been an error:');
			console.dir(error);	
			nativeAlert('There has been an error: ' + error.message, null, 'Error', null);
		}
	
		
	/*
		> database opened successfully
	*/
		
		balance.webdb.onSuccess = function(tx, r) {

		}
		
		
	/*
		> get all budgets
	*/
	
		balance.webdb.getAllBudgets = function() {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				tx.executeSql('SELECT * FROM budgets ORDER BY order_number', [], loadAllBudgets, balance.webdb.onError);
			});	
		}
		
	/*
		> add budget
	*/
	
		balance.webdb.addBudget = function(orderNumber, $budgetMarkup) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				var title = '';
				var dateCreated = new Date();
				
				// get id of previous budget from 'budgets' 
				var previousBudgetId;
				tx.executeSql('SELECT id FROM budgets ORDER BY id DESC LIMIT 1', [],
					function(tx, results) {
						try {
							previousBudgetId = results.rows.item(0).id;
						}
						catch (e) {
							previousBudgetId = 0;	
						}

						// insert new budget into 'budgets'
						tx.executeSql('INSERT INTO budgets(title, order_number, date_created) VALUES (?,?,?)', [title, orderNumber, dateCreated], 
							function(tx, results) {
								// get id of new budget
								newBudgetId = results.insertId;
								
								// add the budget markup
								addIdToBudgetMarkup($budgetMarkup, newBudgetId);

								// save data to persistent storage
								persistent.saveDatabase();

								localChanges = true;
							},
							balance.webdb.onError);

					},
					balance.webdb.onError);
				
			});
		}
		
	/*
		> edit budget
	*/
	
		balance.webdb.editBudget = function(id, title) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {				
				tx.executeSql("UPDATE budgets SET title = ? WHERE id = ?", [title, id], function(tx, rs) {

					// save data to persistent storage
					persistent.saveDatabase();

					localChanges = true;

				}, balance.webdb.onError);
			});
		}
		
		
	/*
		> update budget order numbers
	*/		
	
		balance.webdb.updateBudgetOrderNumbers = function(budgetIds, orderNumbers) {
			var noRows = budgetIds.length;
			var doneRows = 0;
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				for (i=0; i<budgetIds.length; i++) {
					tx.executeSql("UPDATE budgets SET order_number = ? WHERE id = ?", [orderNumbers[i], budgetIds[i]], function(tx, rs) {
						doneRows++;
					}, balance.webdb.onError);
				}
			});
			// wait til all rows have been updated before saving database to dropbox
			var checkDone = setInterval(function(){
				if (doneRows === noRows) {
					clearInterval(checkDone);

					// save data to persistent storage
					persistent.saveDatabase();

					localChanges = true;
				}
			}, 100);
		}
		
		
	/*
		> delete budget
	*/
	
		balance.webdb.deleteBudget = function(id) {
			var db = balance.webdb.db;
			db.transaction(function(tx){
				// budgets_entries - create array of entry_id's where budget_id = id (e.g. 4, 5, 6)
				entryIds = new Array;
				tx.executeSql('SELECT entry_id FROM budgets_entries WHERE budget_id = ?', [id], 
					function(tx, rs) {
						// create array of entry id's (but not first one)
						for (i=0; i < rs.rows.length; i++) {
							entryIds.push(rs.rows.item(i).entry_id);
						}
						var noEntryIds = entryIds.length;
						var noEntriesDeleted = 0;
						// entries - using array, delete where id like array value and pinned != 1
						for (j = 0; j < entryIds.length; j++) {
							currentEntryId = entryIds[j];
							tx.executeSql('DELETE FROM entries WHERE id=? AND pinned=0', [currentEntryId], function(tx, rs) {
								noEntriesDeleted++;
							}, balance.webdb.onError);
						}

						// wait til all entries have been deleted before deleting from budgets_entries and budgets
						var checkEntriesDeletedDone = setInterval(function(){
							if (noEntriesDeleted === noEntryIds) {
								clearInterval(checkEntriesDeletedDone);
								db.transaction(function(tx) {
									// budgets_entries - delete * from budgets_entries where budget_id = id
									tx.executeSql('DELETE FROM budgets_entries WHERE budget_id=?', [id], function(tx, rs) {
										// budgets - delete from budgets where id = id
										tx.executeSql('DELETE FROM budgets WHERE ID=?', [id], function(tx, rs) {
											// save data to persistent storage
											persistent.saveDatabase();

											localChanges = true;
										}, balance.webdb.onError);
									}, balance.webdb.onError);
								});
							}
						}, 100);
						
				}, balance.webdb.onError);
				
			});	
		}
	
	/*
		> add pinned entries to budget
	*/

		balance.webdb.addPinnedEntriesToBudget = function(budgetId) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				// get all ids of pinned entries from 'entries' into an array - e.g. 1, 2
				var pinnedEntryIds = new Array;
				tx.executeSql('SELECT id FROM entries WHERE pinned = ?', [1], 
					function(tx, results) {
						for (var i=0; i < results.rows.length; i++) {
							pinnedEntryIds.push(results.rows.item(i).id);
						}
						// get order_number of each pinned entry based on previousBudgetId and 'entry_id' into an array - e.g. 1, 2
						q = '';
						for (var i in pinnedEntryIds) {
							q += (q == "" ? "" : ", ") + "?";
						}
						var noRows = 0;
						var doneRows = 0;
						tx.executeSql('SELECT entry_id, order_number FROM budgets_entries WHERE entry_id IN (' + q + ') GROUP BY entry_id ORDER BY order_number', pinnedEntryIds,
							function(tx, results) {
								noRows = results.rows.length;
								for (var i=0; i < results.rows.length; i++) {
									
									// insert pinned entries and order numbers to budgets_entries with id of new budget id
									var entryId = results.rows.item(i).entry_id;
									// var orderNumber = results.rows.item(i).order_number;
									tx.executeSql('INSERT INTO budgets_entries(budget_id, entry_id, order_number) VALUES (?,?,?)', [budgetId, entryId, i+1], function() {
										doneRows++;
									}, balance.webdb.onError); // NOTE: changed orderNumber to i+1
									
								}
								
							}, null,
						balance.webdb.onError);

						// wait til all rows have been updated before saving database to dropbox
						var checkDone = setInterval(function(){
							if (doneRows === noRows) {
								clearInterval(checkDone);

								// save data to persistent storage
								persistent.saveDatabase();

								localChanges = true;
								balance.webdb.getAllEntries(budgetId, loadAllEntries);
							}
						}, 100);
						
					},
					balance.webdb.onError);

			});
		} 

	/*
		> get all entries
	*/
	
		balance.webdb.getAllEntries = function(id, callback) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				// check if budget exists
				tx.executeSql('SELECT budgets.id FROM budgets WHERE budgets.id = ?', [id], function(tx, rs) {
					// if budget exists
					if (rs.rows.length > 0) {
						// get entry id's from budgets_entries
						tx.executeSql('SELECT entry_id FROM budgets_entries WHERE budget_id=?', [id], function(tx, rs) {
							var entryIds = new Array();
							for (var i=0; i < rs.rows.length; i++) {
								entryIds.push(rs.rows.item(i).entry_id);
							}
							// get entries from entries
							q = '';
							for (var i in entryIds) {
								q += (q == "" ? "" : ", ") + "?";
							}
							tx.executeSql('SELECT DISTINCT entries.*, budgets_entries.*, paid.budgets_entries_id AS paid, dates.date FROM entries JOIN budgets_entries ON entries.id = budgets_entries.entry_id LEFT JOIN paid ON budgets_entries.id = paid.budgets_entries_id LEFT JOIN dates ON budgets_entries.id = dates.budgets_entries_id WHERE entries.id IN (' + q + ') AND budgets_entries.budget_id = ' + id + ' ORDER BY budgets_entries.order_number', entryIds, callback, balance.webdb.onError);
						}, balance.webdb.onError);
					}
					// else budget doesn't exist
					else {
						// go back to budgets
						$('.back-to-budgets').trigger('click');
						// hide info
						setTimeout(function(){
							$('#info').addClass('off-bottom');
						}, 500);
					}
				}, balance.webdb.onError)


			});
		}
		
	/*
		> add entry
	*/
	
		balance.webdb.addEntry = function(budgetId, orderNumber, isExpense, $entryMarkup) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				var title = '';
				var dateCreated = new Date();
				// add to entries
				tx.executeSql('INSERT INTO entries(title, isexpense, date_created) VALUES (?,?,?)', [title, isExpense, dateCreated], 
					function(tx, results) {
						entryId = results.insertId;
						// add to budgets_entries
						tx.executeSql('INSERT INTO budgets_entries(budget_id, entry_id, order_number) VALUES (?,?,?)', [budgetId, entryId, orderNumber], 
							function(tx, results) {
								addIdToEntryMarkup($entryMarkup, entryId);
								// save data to persistent storage
								persistent.saveDatabase();

								localChanges = true;
							},
							balance.webdb.onError);
					},
					balance.webdb.onError);
			});
		}
		
	/*
		> edit entry
	*/
	
		balance.webdb.editEntry = function(id, title, amount, pinned, isexpense) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {				
				tx.executeSql("UPDATE entries SET title = ?, amount = ?, pinned = ?, isexpense = ? WHERE id = ?", [title, amount, pinned, isexpense, id], function() {
					// save data to persistent storage
					persistent.saveDatabase();

					localChanges = true;
				}, balance.webdb.onError);
			});
		}
	
		
	/*
		> update entry order numbers
	*/
	
		balance.webdb.updateEntryOrderNumbers = function(entryIds, orderNumbers, budgetIds) {
			var noRows = entryIds.length;
			var doneRows = 0;
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				for (i=0; i<entryIds.length; i++) {
					tx.executeSql("UPDATE budgets_entries SET order_number = ? WHERE entry_id = ? AND budget_id = ?", [orderNumbers[i], entryIds[i], budgetIds[i]], function(tx, rs) {
						doneRows++;
					}, balance.webdb.onError);
				}
			});
			// wait til all rows have been updated before saving database to dropbox
			var checkDone = setInterval(function(){
				if (doneRows === noRows) {
					clearInterval(checkDone);
					// save data to persistent storage
					persistent.saveDatabase();

					localChanges = true;
				}
			}, 100);
		}
				
		
	/*
		> delete entry
	*/
	
		balance.webdb.deleteEntry = function(entryId, budgetId) {
			var db = balance.webdb.db;
			var numberOfEntries = 0;
			db.transaction(function(tx){
				tx.executeSql('SELECT COUNT(*) AS mycount FROM budgets_entries WHERE entry_id=?', [entryId],
					function(tx, rs) {
						numberOfEntries = rs.rows.item(0).mycount; // if this count is only 1, we should delete the entry from 'entries' too
						tx.executeSql('DELETE FROM budgets_entries WHERE entry_id=? AND budget_id=? ', [entryId, budgetId],
							function(tx, rs) {
								if (numberOfEntries == 1) {
									tx.executeSql('DELETE FROM entries WHERE ID=?', [entryId], function() {
										// save data to persistent storage
										persistent.saveDatabase();

										localChanges = true;
									}, balance.webdb.onError);
								}
							},
						balance.webdb.onError);
					},
				balance.webdb.onError);
			});	
		}
		
		
	/*
		> pin entry
	*/
	
		balance.webdb.pinEntry = function(entryId) {
			var db = balance.webdb.db;
			db.transaction(function(tx){
				tx.executeSql("UPDATE entries SET pinned = ? WHERE id = ?", [1, entryId], function() {
					// save data to persistent storage
					persistent.saveDatabase();

					localChanges = true;
				}, balance.webdb.onError);
			});	
		}
		
		
	/*
		> unpin entry
	*/
	
		// make all pinned entries that get unpinned into unique entries
		balance.webdb.unpinEntry = function(unpinnedEntryId, currentlyViewedBudgetId) {
			var db = balance.webdb.db;
			// get entry id, title and amount of unpinned entry and set pinned to 0 in entries
			var unpinnedEntryTitle;
			var unpinnedEntryAmount;
			var isexpense;
			db.transaction(function(tx){
				tx.executeSql("SELECT amount, title, isexpense FROM entries WHERE id = ?", [unpinnedEntryId], function(tx, rs) {
					unpinnedEntryTitle = rs.rows.item(0).title;
					unpinnedEntryAmount = rs.rows.item(0).amount;
					isexpense = rs.rows.item(0).isexpense;
					tx.executeSql("UPDATE entries SET pinned = ? WHERE id = ?", [0, unpinnedEntryId], function(tx, rs) {
						// get id's of all entries in budgets_entries where entry_id is unpinned entry id (into array)
						budgetsEntriesIds = new Array;
						newIds = new Array;
						tx.executeSql('SELECT id FROM budgets_entries WHERE entry_id = ?', [unpinnedEntryId], 
							function(tx, rs) {
								// create array of entry id's (but not first one)
								for (i=0; i < rs.rows.length; i++) {
									if (i > 0) {
										budgetsEntriesIds.push(rs.rows.item(i).id);
									}
								}

								var noRows = budgetsEntriesIds.length;
								var doneRows = 0;

								// for every item in array 
								for (j = 0; j < budgetsEntriesIds.length; j++) {
									    
									// create a new entry in entries
									var dateCreated = new Date();
									tx.executeSql('INSERT INTO entries(title, amount, isexpense, date_created) VALUES(?,?,?,?)', [unpinnedEntryTitle, unpinnedEntryAmount, isexpense, dateCreated], null, balance.webdb.onError);
									
									// grab new id from entries
									tx.executeSql('SELECT id FROM entries ORDER BY id DESC LIMIT 1', [],
										function(tx, results) {
											newId = results.rows.item(0).id;
											newIds.push(newId);
											doneRows++;
										}
									, balance.webdb.onError)

								}
								
								// wait til all rows have been updated before saving database to dropbox
								var checkDone = setInterval(function(){
									if (doneRows === noRows) {
										clearInterval(checkDone);
										
										// update budgets_entries once the above is complete
										var noRows2 = newIds.length;
										var doneRows2 = 0;
										db.transaction(function(tx){
											for (k=0; k < newIds.length; k++) {
												id = newIds[k];
												entryId = budgetsEntriesIds[k];
												tx.executeSql('UPDATE budgets_entries SET entry_id = ? WHERE id = ?', [id, entryId], function() {
													doneRows2++;
												}, balance.webdb.onError)
											}
										});

										var checkDone2 = setInterval(function(){
											if (doneRows2 === noRows2) {
												clearInterval(checkDone2);
												console.log('all done');

												// save data to persistent storage
												persistent.saveDatabase();

												localChanges = true;
												balance.webdb.getAllEntries(currentlyViewedBudgetId, loadAllEntries);
											}
										}, 100);

									}
								}, 100);

								
						}, balance.webdb.onError);
						 
					}, balance.webdb.onError);
				}, balance.webdb.onError);
			});
				
		}


	/*
		> mark as paid
	*/
	
		balance.webdb.markAsPaid = function(budgetId, entryId) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {

				// get budgets_entries id
				tx.executeSql('SELECT id FROM budgets_entries WHERE budget_id=? AND entry_id=?', [budgetId, entryId], function(tx, rs) {
					var budgetsEntriesId = rs.rows.item(0).id;

					// add to 'paid' table
					tx.executeSql('INSERT INTO paid(budgets_entries_id) VALUES (?)', [budgetsEntriesId], function() {
						// save data to persistent storage
						persistent.saveDatabase();

						localChanges = true;
					}, balance.webdb.onError);

				}, balance.webdb.onError);

			});
		}

	/*
		> mark as unpaid
	*/
	
		balance.webdb.markAsUnpaid = function(budgetId, entryId) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {

				// get budgets_entries id
				tx.executeSql('SELECT id FROM budgets_entries WHERE budget_id=? AND entry_id=?', [budgetId, entryId], function(tx, rs) {
					var budgetsEntriesId = rs.rows.item(0).id;

					// remove from 'paid' table
					tx.executeSql('DELETE FROM paid WHERE budgets_entries_id=?', [budgetsEntriesId], function() {
						// save data to persistent storage
						persistent.saveDatabase();
						
						localChanges = true;
					}, balance.webdb.onError);

				}, balance.webdb.onError);

			});
		}

	/*
		> edit date
	*/
	
		balance.webdb.editDate = function(budgetId, entryId, date) {
			var db = balance.webdb.db;
			db.transaction(function(tx) {

				// get budgets_entries id
				tx.executeSql('SELECT id FROM budgets_entries WHERE budget_id=? AND entry_id=?', [budgetId, entryId], function(tx, rs) {
					var budgetsEntriesId = rs.rows.item(0).id;

					// check if budgets_entries_id already exists in table...
					tx.executeSql('SELECT * FROM dates WHERE budgets_entries_id = ?', [budgetsEntriesId], function(tx, rs) {
						// doesn't exist, so insert it anew
						if (rs.rows.length === 0) {
							tx.executeSql('INSERT INTO dates(budgets_entries_id,date) VALUES (?,?)', [budgetsEntriesId,date], function() {
								// save data to persistent storage
								persistent.saveDatabase();

								localChanges = true;
							}, balance.webdb.onError);
						}
						// does exist, so update it
						else {
							tx.executeSql("UPDATE dates SET date = ? WHERE budgets_entries_id = ?", [date, budgetsEntriesId], function() {
								// save data to persistent storage
								persistent.saveDatabase();

								localChanges = true;
							});							
						}
					})

				}, balance.webdb.onError);

			});
		}

	/*
		> get date - get the date of an entry
	*/

		balance.webdb.getDate = function(budgetId, entryId) {

			var dfrd = $.Deferred();
			var db = balance.webdb.db;
			db.transaction(function(tx) {

				// get budgets_entries id
				tx.executeSql('SELECT id FROM budgets_entries WHERE budget_id=? AND entry_id=?', [budgetId, entryId], function(tx, rs) {

					if (rs.rows.length > 0) {

						var budgetsEntriesId = rs.rows.item(0).id;

						// look for item in 'dates'
						tx.executeSql('SELECT date FROM dates WHERE budgets_entries_id=?', [budgetsEntriesId], function(tx, rs) {
							if (rs.rows.length > 0) {
								dfrd.resolve(rs.rows.item(0).date);
							}
							else {
								dfrd.resolve(0);
							}
						}, balance.webdb.onError);

					}

				}, balance.webdb.onError);

			});

			return dfrd.promise();
		}

	/*
		> is paid - find out if an entry is paid
	*/

		balance.webdb.isPaid = function(budgetId, entryId) {
			// var isPaid = false;
			var dfrd = $.Deferred();
			var db = balance.webdb.db;
			db.transaction(function(tx) {

				// get budgets_entries id
				tx.executeSql('SELECT id FROM budgets_entries WHERE budget_id=? AND entry_id=?', [budgetId, entryId], function(tx, rs) {

					if (rs.rows.length > 0) {

						var budgetsEntriesId = rs.rows.item(0).id;

						// look for item in 'paid'
						tx.executeSql('SELECT * FROM paid WHERE budgets_entries_id=?', [budgetsEntriesId], function(tx, rs) {
							if (rs.rows.length > 0) {
								dfrd.resolve('true');
							}
							else {
								dfrd.resolve('false');
							}
						}, balance.webdb.onError);

					}


				}, balance.webdb.onError);

			});

			return dfrd.promise();
		}

	/*
		> has starred entries - find out if user has some starred entries that are attached to an existing budget
	*/

		// grab id's of all pinned entries in 'entries'
		// check if any of these id's are present in budgets_entries in 'entry_id' column
		balance.webdb.hasStarredEntries = function(budgetId) {
			var dfrd = $.Deferred();
			var db = balance.webdb.db;
			db.transaction(function(tx) {
				// get all ids of pinned entries from 'entries' into an array - e.g. 1, 2
				var pinnedEntryIds = new Array;
				tx.executeSql('SELECT id FROM entries WHERE pinned = ?', [1], 
					function(tx, results) {
						for (var i=0; i < results.rows.length; i++) {
							pinnedEntryIds.push(results.rows.item(i).id);
						}
						// get order_number of each pinned entry based on previousBudgetId and 'entry_id' into an array - e.g. 1, 2
						q = '';
						for (var i in pinnedEntryIds) {
							q += (q == "" ? "" : ", ") + "?";
						}
						tx.executeSql('SELECT entry_id, order_number FROM budgets_entries WHERE entry_id IN (' + q + ') GROUP BY entry_id ORDER BY order_number', pinnedEntryIds,
							function(tx, results) {
								for (var i=0; i < results.rows.length; i++) {
									
									if (results.rows.length > 0) {
										dfrd.resolve('true');
									}
									else {
										dfrd.resolve('false');
									}
									
								}
								
							}, null,
							balance.webdb.onError);
						
					},
					balance.webdb.onError);

			});

			return dfrd.promise();
		} 


/*
* database-sync.js
*/

/*
* CONTENTS
*
* check for data
* check if dropbox data newer
* save database
*    fn: doSave
*    backup all tables
*    serialize data
*    save to dropbox file
*    fn: backup a table to json
*    fn: save serialized db to dropbox
* restore database
*    open file from dropbox
*    fn: confirmRestore
*    fn: doRestore
*    get link to db
*    delete all of the table rows
*    restore all of the tables
*    fn: delete table
*    fn: restore table
* get revisions
*    fn: format revision date nicely
* restore revision
* generic functions
*    fn: generate sync id
*/
		
	
	/*
		> check for data
		  see if there is already data on Dropbox first time user logs in
	*/

		balance.webdb.checkForData = function(callback) {

			console.log('checkForData');

			// arguments
            var args = JSON.stringify({
            	'path': '/Fudget.data'
			});

            $.ajax({
                url: 'https://api.dropboxapi.com/2/files/get_metadata',
                type: 'POST',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('Authorization', 'Bearer ' + localStorage.access_token);
                    xhr.setRequestHeader('Content-Type', 'application/json');
                },
                data: args,
                // data found on dropbox
                success: function( response ) {
                	console.log('Data found on Dropbox');

                	// confirm download dropbox data
		       		nativeConfirm(
		       			'Download the Dropbox data to this device? \n\r Note: this will replace the data already on this device',	// message
		       			downloadDropboxDataConfirmCallback,					                                                        // callback
		       			'Data found on Dropbox',						                                                            // title
		       			['Yes, download Dropbox data', 'No, use data from this device'],							                // button labels
		       			null,									                                                                    // fallback message
		       			1,										                                                                    // fallback - ok pressed
		       			2										                                                                    // fallback - cancel pressed
		       		);

		       		// confirm download dropbox data callback
		       		function downloadDropboxDataConfirmCallback(buttonIndex) {
		       			// yes pressed
		       			if (buttonIndex === 1) {
		       				balance.webdb.restoreDatabase(balance.webdb.getAllBudgets);	
		       			}
		       			// no pressed
		       			else if (buttonIndex === 2) {
		       				balance.webdb.saveDatabase();
		       			}
		       		}
	       			
                },
                // no data found on dropbox
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					var responseText = XMLHttpRequest.responseText;
					// if no file found, save the user's current data to dropbox and start checking for changes
					if (responseText.indexOf('not_found') > -1) {
						console.log('No data on dropbox');
						// startCheckingForChanges();
					}
				}
            });

		}


	/*
		> check if dropbox data newer
	*/

		balance.webdb.checkIfDropboxDataNewer = function(callback) {

			balance.webdb.restoreDatabase(balance.webdb.getAllBudgets, true);

		}


	/*
		> save database
	*/
	
		var data = {};

		balance.webdb.saveDatabase = function(callback) {

			// only if dropbox save & restore enabled
			if (localStorage.dropboxSaveAndRestore === 'true') {

				// confirm save
        		nativeConfirm(
        			'Save data to Dropbox? (This will overwrite data on Dropbox)',	// message
        			confirmSaveCallback,					                        // callback
        			'Save to Dropbox?',						                        // title
        			['No', 'Yes'],							                        // button labels
        			null,									                        // fallback message
        			2										                        // fallback - ok pressed
        		);

        		// confirm save callback
        		function confirmSaveCallback(buttonIndex) {
        			// yes pressed
    		     	if (buttonIndex === 2) {
    		     		doSave(callback);
    		     	}
        		}

			}

		}

		// >> fn: doSave
		function doSave(callback) {

			data = {};

			showLoadingScreen('Saving to Dropbox...');

			// >> backup all tables
			$.when(
			    backup('budgets'), 
			    backup('entries'),
			    backup('budgets_entries'),
			    backup('paid'),
			    backup('dates')
			).then(function(jsonData) {
				// console.log(jsonData);
				// add a random sync id to the json
				var newSyncId = generateSyncId();
				jsonData['syncId'] = newSyncId;
				// add the sync date to the json (milliseconds since epoch)
				var newSyncDate = new Date().getTime();
				jsonData['syncDate'] = newSyncDate;
			    // >> serialize data
			    var serializedData = JSON.stringify(jsonData);
			    // >> save to dropbox file
			    saveSerializedDbToDropbox(serializedData, newSyncId, newSyncDate, callback);
			});

		}

		// >> fn: backup a table to json
		function backup(table) {
			var db = balance.webdb.db;
		    var def = new $.Deferred();
		    data[table] = [];
		    db.transaction(function(tx) {
		    	// select everything from table
		        tx.executeSql("select * from "+table, [], function(tx,results) {
		        	for (var i=0; i < results.rows.length; i++) {
		        		// loop through each key in the row and push only the value to an array
		        		var rowArray = [];
		        		for (var key in results.rows.item(i)) {
		        		  rowArray.push(results.rows.item(i)[key]);
		        		}
		        		// push the array of only values to the data object
		        		data[table].push(rowArray);
		        	}
		            // var data = results;
		            def.resolve(data);
		        });
		    }, balance.webdb.onError);

		    return def;
		}

		// >> fn: save serialized db to dropbox
		function saveSerializedDbToDropbox(serializedData, newSyncId, newSyncDate, callback) {

			// if zipping is enabled, zip the data first
			if (dropboxZipMode) {
				console.log('dropboxZipMode enabled');
				// zip the serialized data
				var compression_mode = 9,
				    zip = LZMA; /// lzma_worker.js creates a global LZMA object.

			    /// First, let's compress it.
			    zip.compress(serializedData, compression_mode, function on_compress_complete(result) {

			    	var data = JSON.stringify(result);
			    	console.log(data);
			    	uploadToDropbox(data);

			    }, null);
			}
			// else don't zip the data
			else {
				uploadToDropbox(serializedData);
			}

		    // fn: upload to dropbox
		    function uploadToDropbox(result) {
		    	console.log('result', result);
				// arguments
	            var args = JSON.stringify({
	            	'path': '/Fudget.data',
				    'mode': 'overwrite', // add, overwrite, update
				    'autorename': false,
				    'mute': false
				});
				// upload to dropbox
	            $.ajax({
	                url: 'https://content.dropboxapi.com/2/files/upload',
	                type: 'POST',
	                beforeSend: function (xhr) {
	                    xhr.setRequestHeader('Authorization', 'Bearer ' + localStorage.access_token);
	                    xhr.setRequestHeader('Content-Type', 'application/octet-stream');
	                    xhr.setRequestHeader('Dropbox-API-Arg', args);
	                },
	                data: result,
	                success: function( response ) {
	                    // alert('response' + response);
	                    log('Database saved to Dropbox!');
	                    console.log('Database saved to Dropbox!');
	                    hideLoadingScreen();
						showNotification('Data saved to Dropbox', 'success', 2000);
	                    // save the syncId to localStorage
	                    localStorage.syncId = newSyncId;
	                    // save the syncDate to localStorage
	                    localStorage.syncDate = newSyncDate;
	                    // start checking for changes locallly
	                    // startCheckingForChangesLocally();
	                    if (callback) {
	                    	callback();
	                    }

	                },
					error: function(XMLHttpRequest, textStatus, errorThrown) {
						console.dir(XMLHttpRequest);
						console.log(XMLHttpRequest.responseText);
						hideLoadingScreen();

						// notify user we couldn't save to Dropbox
			       		nativeAlert(
			       			'Could not save to Dropbox. Please check your internet and try again.',
			       			null,
			       			'Couldn\'t save to Dropbox'
			       		);
					}
	            });				    	
		    }

		}


	/*
		> restore database
	*/

		balance.webdb.restoreDatabase = function(callback, startup, skipConfirm) {

			// only if dropbox save & restore enabled
			if (localStorage.dropboxSaveAndRestore === 'true') {

				console.log('Start getting data from Dropbox');

				showLoadingScreen('Connecting to Dropbox...');

				// arguments
	            var args = JSON.stringify({
	            	'path': '/Fudget.data'
				});
				// >> open file from dropbox
	            $.ajax({
	                url: 'https://content.dropboxapi.com/2/files/download',
	                type: 'POST',
	                beforeSend: function (xhr) {
	                    xhr.setRequestHeader('Authorization', 'Bearer ' + localStorage.access_token);
	                    xhr.setRequestHeader('Dropbox-API-Arg', args);
	                },
	                success: function( response ) {

	                	// if zipping is enabled, unzip the data first
	                	if (dropboxZipMode) {

		                	var zipArray = JSON.parse(response);

		                	/// unzip the zipped code
		                	zip = LZMA; /// lzma_worker.js creates a global LZMA object.
		                	zip.decompress(zipArray, function on_decompress_complete(result) {

		                		confirmRestore(result);

		                	}, null);

	                	}
	                	// else don't unzip the data
	                	else {
	                		confirmRestore(response);
	                	}

	                	// >> fn: confirmRestore
	                	function confirmRestore(data) {

	                		// if checking for new data on app startup
	                		if (startup) {

	                			// get json from data string
	                			var jsonData = JSON.parse(data);

	                			// get dropbox sync id
	                			var syncId = jsonData.syncId;

	                			// if dropbox sync id does not match local sync id
	                			if (syncId !== localStorage.syncId) {
	                				console.log('Dropbox data is newer');
	                				showConfirm('New data found on Dropbox. Restore and overwrite data on this device?');
	                			}
	                			// else data on dropbox is same, hide loading screen
	                			else {
	                				hideLoadingScreen();
	                			}
	                		}

	                		else {
	                			showConfirm('Restore data from Dropbox? (This will overwrite data on this device)');
	                		}

	                		function showConfirm(message) {

		                		hideLoadingScreen();

		                		// if we're skipping confirm, skip it
		                		if (skipConfirm) {
		                			doRestore(data);
		                		}
		                		// otherwise show the confirm
		                		else {

			                		// confirm restore data
			                		nativeConfirm(
			                			message,	                // message
			                			confirmRestoreCallback,	    // callback
			                			'Restore from Dropbox?',	// title
			                			['No', 'Yes'],	            // button labels
			                			null,	                    // fallback message
			                			2	                        // fallback - ok pressed
			                		);

			                		// confirm restore data callback
			                		function confirmRestoreCallback(buttonIndex) {
			                			// yes pressed
										if (buttonIndex === 2) {
											doRestore(data);
										}
			                		}

			                	}

	                		}

	                	} 

	                	// >> fn: doRestore
	                	function doRestore(data) {

	                		showLoadingScreen('Restoring from Dropbox...');

		                    var jsonString = data;
		                    var jsonData = JSON.parse(jsonString);

                   			// >> get link to db
                   			var db = balance.webdb.db;

                   		    // >> delete all of the table rows
                   		    $.when(
                   		        deleteTable('budgets', db), 
                   		        deleteTable('entries', db),
                   		        deleteTable('budgets_entries', db),
                   		        deleteTable('paid', db),
                   		        deleteTable('dates', db)
                   		    ).then(function() {
                   		    	// >> restore all of the tables
                   		    	$.when(
                   		    		restoreTable('budgets', db, jsonData),
                   		    		restoreTable('entries', db, jsonData),
                   		    		restoreTable('budgets_entries', db, jsonData),
                   		    		restoreTable('paid', db, jsonData),
                   		    		restoreTable('dates', db, jsonData)
                   		    	).then(function(){
                   		    		// restore syncId
                   		    		localStorage.syncId = jsonData['syncId'];
                   		    		// restore syncDate
                   		    		localStorage.syncDate = jsonData['syncDate'];
                   		    		// flag to show if user has restored a database 
                   		    		// at least once
                   		    		localStorage.previouslyRestored = true;
                   		    		log('Database restored!');
                   		    		console.log('Database restored!');

                   		    		hideLoadingScreen();

                   		    		// show notification
                   		    		showNotification('Data restored from Dropbox!', 'success', 3000);
                   		    		// fire the callback if there is one
                   		    		if (callback) {
                   		    			callback();
                   		    		}
                   		    	});

                   		    });
	                	}


	                },
					error: function(XMLHttpRequest, textStatus, errorThrown) {

						console.log('could not restore');

						hideLoadingScreen();

						console.dir(XMLHttpRequest);
						console.log(XMLHttpRequest.responseText);

						// notify user we couldn't restore from Dropbox
			       		nativeAlert(
			       			'Could not restore from Dropbox. Please check your internet and try again.',
			       			null,
			       			'Couldn\'t restore from Dropbox'
			       		);

			       		// fire callback if there is one
						if (callback) {
							callback();
						}
					}
	            });		

			}

			// else go straight to the callback (if there is one)
			else if (callback) {
				callback();
			}

		}

		// >> fn: delete table
		function deleteTable(table, db) {
			var def = new $.Deferred();
		    db.transaction(function(tx) {
		        tx.executeSql("DELETE FROM " + table, [], function(tx,results) {
		            def.resolve(results);
		        });
		    }, function() {console.log('delete table error');});

		    return def;	
		}

		// >> fn: restore table
		function restoreTable(table, db, jsonData) {
			db.transaction(function(tx) {
        		// build up the question marks part of the query based on the number of columns e.g. ?, ?, ?
        		q = '';
        		for (var j in jsonData[table][0]) {
        			q += (q == "" ? "" : ", ") + "?";
        		}
        		
        		// for each row of this table
        		for (var i=0; i < jsonData[table].length; i++) {
        			var query = 'INSERT OR IGNORE INTO ' + table + ' VALUES (' + q + ')';
					tx.executeSql(query, jsonData[table][i], null, balance.webdb.onError);
				}

			});
		}


	/*
		> get revisions
	*/

		balance.webdb.getRevisions = function() {

			console.log('getRevisions');

			showLoadingScreen('Getting revision history...');

			// arguments
            var args = JSON.stringify({
            	'path': '/Fudget.data',
            	'limit': 40
			});

            $.ajax({
                url: 'https://api.dropboxapi.com/2/files/list_revisions',
                type: 'POST',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('Authorization', 'Bearer ' + localStorage.access_token);
                    xhr.setRequestHeader('Content-Type', 'application/json');
                },
                data: args,
                // revisions found
                success: function( response ) {
                	console.log('response: ', response);

                	// get revision entries
                	var revisionEntries = response.entries;

                	// populate dropdown
                	var revisionEntriesMarkup = '<option value="">Choose a revision to restore</option>';
                	for (i = 0; i < revisionEntries.length; i++) {
	                	// add tick to first item (to show current revision)
	                	if (i === 0 && !response.is_deleted) {
	                		var tick = ' &#10004;';
	                	}
	                	else {
	                		var tick = '';
	                	}
                		revisionEntriesMarkup += '<option value="' + revisionEntries[i].rev + '">' + niceRevisionDate(revisionEntries[i].client_modified) + tick + '</option>';
                	}
                	$('#choose-revision').html(revisionEntriesMarkup);

                	// show restore from revision item
                	$('.restore-data-from-revision').removeClass('hidden');

                	gettingRevisions = false;

                	// hide loading screen
                	hideLoadingScreen();
                },
                // no revisions found
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					var responseText = XMLHttpRequest.responseText;
					console.log('responseText: ', responseText);
				}
            });			
		}

		// >> fn: format revision date nicely
		function niceRevisionDate(dateString, count) {
			// get date object
			var formattedDate = new Date(dateString);

			// get all the variables we need
			var date = formattedDate.getDate();
			var dayNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
			var day = formattedDate.getDay();
			var monthNames = [
			  'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'
			];
			var month =  formattedDate.getMonth();
			var year = formattedDate.getFullYear();
			var hour = formattedDate.getHours();
			var minute = formattedDate.getMinutes();
			var seconds = formattedDate.getSeconds();

			// add zero padding
			if (hour < 10) {
				hour = '0' + hour;
			}
			if (minute < 10) {
				minute = '0' + minute;
			}
			if (seconds < 10) {
				seconds = '0' + seconds;
			}

			// create the full string
			var outputDate = dayNames[day] + ', ' + monthNames[month] + ' ' + date + ' @ ' + hour + ':' + minute + ':' + seconds;

			return outputDate; 
		}


	/*
		> restore revision
	*/

		balance.webdb.restoreRevision = function(rev) {

			showLoadingScreen('Restoring revision...');

			// arguments
            var args = JSON.stringify({
            	'path': '/Fudget.data',
            	'rev': rev
			});

            $.ajax({
                url: 'https://api.dropboxapi.com/2/files/restore',
                type: 'POST',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('Authorization', 'Bearer ' + localStorage.access_token);
                    xhr.setRequestHeader('Content-Type', 'application/json');
                },
                data: args,
                // revisions found
                success: function( response ) {
                	console.log('response: ', response);

                	// hide loading screen
                	hideLoadingScreen();

                	// hide 'restore from revision' option
                	$('.restore-data-from-revision').addClass('hidden');

                	// file is restored, now restore data from that file
                	balance.webdb.restoreDatabase(balance.webdb.getAllBudgets, false, true);

                },
                // couldn't restore
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					var responseText = XMLHttpRequest.responseText;
					shout('Could not restore revision: ' + responseText);
				}
            });			

		}


	/*
		> generic functions
	*/

		// >> fn: generate sync id
		function generateSyncId() {
		    var text = "";
		    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

		    for( var i=0; i < 15; i++ )
		        text += possible.charAt(Math.floor(Math.random() * possible.length));

		    return text;
		}

/*
* CONTENTS
*
* setup
* save database
*   backup all tables
*   serialize data
*   save to persistent storage
*   fn: backup a table to json
*   fn: save serialized db to persistent storage
* restore database
* check if database deleted by ios
*   get number of budgets in persistent storage database backup
* stop asking
* fn: do restore
*   get link to db
*   delete all of the table rows
*   restore all of the tables
*/

	/*
		> setup
	*/

		var persistent = {};
		var fileName = 'Fudget.data';

		// enable emergency mode on load if we're in emergency mode
		if (localStorage.emergencyMode) {
			enableEmergencyMode();
		}

	/*
		> save database
	*/

		var data = {};

		persistent.saveDatabase = function() {

			if (isNative && !localStorage.emergencyMode) {

				data = {};

				// >> backup all tables
				$.when(
				    backup('budgets'), 
				    backup('entries'),
				    backup('budgets_entries'),
				    backup('paid')
				).then(function(jsonData) {
					// get number of budgets from web sql db
					var numberOfBudgets = jsonData.budgets.length;

					// log('* numberOfBudgets: ', numberOfBudgets);

					// if there's at least 1 budget, save to persistent storage
					if (numberOfBudgets > 0) {
					    // >> serialize data
					    var serializedData = JSON.stringify(jsonData);
					    // >> save to persistent storage
					    saveSerializedDbToPersistentStorage(serializedData);
					}

				});

			}

		}

		// >> fn: backup a table to json
		function backup(table) {
			var db = balance.webdb.db;
		    var def = new $.Deferred();
		    data[table] = [];
		    db.transaction(function(tx) {
		    	// select everything from table
		        tx.executeSql("select * from "+table, [], function(tx,results) {
		        	for (var i=0; i < results.rows.length; i++) {
		        		// loop through each key in the row and push only the value to an array
		        		var rowArray = [];
		        		for (var key in results.rows.item(i)) {
		        		  rowArray.push(results.rows.item(i)[key]);
		        		}
		        		// push the array of only values to the data object
		        		data[table].push(rowArray);
		        	}
		            // var data = results;
		            def.resolve(data);
		        });
		    }, persistent.onError);

		    return def;
		}

		// >> fn: save serialized db to persistent storage
		function saveSerializedDbToPersistentStorage(serializedData) {

	    	// log('saveSerializedDbToPersistentStorage()');

    		// request persistent storage
    		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
    			// log('file system open: ' + fs.name);

    			// Creates a new file or returns the file if it already exists.
    		    fs.root.getFile(fileName, {create: true, exclusive: false}, function(fileEntry) {
    		        writeFile(fileEntry, serializedData);
    		    }, function() {
    		    	// log('Error creating file');
    		    });

    		}, function(error) {
    			alert('error - file system not loaded');
    		});

    	    // fn: write file
    	    function writeFile(fileEntry, dataObj) {

    	        // Create a FileWriter object for our FileEntry (log.txt).
    	        fileEntry.createWriter(function (fileWriter) {

    	            fileWriter.onwriteend = function() {
    	                // log("Successful file write...");
    	            };

    	            fileWriter.onerror = function (e) {
    	                // log("Failed file write: " + e.toString());
    	            };

    	            fileWriter.write(dataObj);

    	        });
    	    }

		}


	/*
		> restore database 
	*/

		persistent.restoreDatabase = function(callback) {

			if (isNative) {

				// request persistent storage
				window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
					// log('file system open: ' + fs.name);

					// Creates a new file or returns the file if it already exists.
				    fs.root.getFile(fileName, {create: true, exclusive: false}, function(fileEntry) {
				        readFile(fileEntry);
				    }, function() {
				    	// error
				    });

				}, function(error) {
					alert('error - file system not loaded');
				});				

			    // fn: read file
			    function readFile(fileEntry) {
			        fileEntry.file(function (file) {
			            var reader = new FileReader();

			            // succesfully loaded file
			            reader.onloadend = function() {
			                // log("Successful file read: " + this.result);

			                var result = this.result;

			                nativeConfirm(
			                	'Attempt to restore your lost data?',	    // message
			                	restoreLostDataConfirmCallback,	            // callback (with tapped button index as parameter)
			                	'Restore your lost data',		            // title
			                	['Yes', 'Not now', 'Stop asking'],			// button labels
			                	'Not supported in browser'				    // fallback (null if confirm fallback needed, string or function)
			                );

			                function restoreLostDataConfirmCallback(buttonIndex) {
			                	if (buttonIndex === 1) {
					                // do the restore
					                doRestore(result, callback);
			                	}
			                	else if (buttonIndex === 3) {
			                		// prompt to stop asking
			                		persistent.stopAsking();
			                	}
			                }

			            };

			            reader.readAsText(file);

			        }, function() {

			        });
			    }

			}

		}


	/*
		> check if database deleted by ios
	*/

		persistent.checkIfDatabaseDeletedByIOS = function(callback) {

			if (isNative) {

				// get number of budgets in database
				var db = balance.webdb.db;
				db.transaction(function(tx) {
					tx.executeSql('SELECT * FROM budgets', [], function(tx,rs) {

						// number of budgets in database
						var numberOfDbBudgets = rs.rows.length;

						/*
							>> get number of budgets in persistent storage database backup
						*/

							// request persistent storage
							window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
								// log('file system open: ' + fs.name);

								// Creates a new file or returns the file if it already exists.
							    fs.root.getFile(fileName, {create: true, exclusive: false}, function(fileEntry) {
							        readFile(fileEntry);
							    }, function() {
							    	// error
							    });

							}, function(error) {
								alert('error - file system not loaded');
							});				

						    // fn: read file
						    function readFile(fileEntry) {
						        fileEntry.file(function (file) {
						            var reader = new FileReader();

						            // succesfully loaded file
						            reader.onloadend = function() {
						            	var stringResult = this.result; 
						            	var jsonResult = JSON.parse(stringResult);

						                // number of budgets in persistent storage db
						            	var numberOfPersistentStorageBudgets = jsonResult.budgets.length; 

						            	// log('numberOfDbBudgets: ', numberOfDbBudgets);
						                // log("numberOfPersistentStorageBudgets: " + numberOfPersistentStorageBudgets);

						                // if there are more budgets in persistent storage than in the db,
						                // warn user and offer to restore
						                if (numberOfDbBudgets === 0 && numberOfPersistentStorageBudgets > numberOfDbBudgets) {

						                	// enable emergency mode
						                	enableEmergencyMode();

						                	nativeAlert(
						                		'Your data may have been deleted by iOS. If you have lost your data, please go to Settings and tap "Restore my lost data".',		// message
						                		function() {	// callback
						                		},		
						                		'Possible data loss!',		// title
						                		'OK'			// button label
						                	);

						                }

						            };

						            reader.readAsText(file);

						        }, function() {

						        });
						    }


					}, null);
				});	

			}

		}


	/*
		> stop asking
	*/

		persistent.stopAsking = function() {

			nativeConfirm(
				"Are you sure you want me to stop asking? You won't get another chance to restore lost data.",	// message
				stopAskingCallback,					// callback (with tapped button index as parameter)
				'Really stop asking?',						// title
				['Yes, stop asking', 'No'],							// button labels
				null,									// fallback (null if confirm fallback needed, string or function)
				1,										// fallback - ok pressed (button index to fire - omit if no confirm required)
				2										// fallback - cancel pressed (button index to fire)
			);

			function stopAskingCallback(buttonIndex) {
				if (buttonIndex === 1) {
					disableEmergencyMode();
				}
			}


		}


	/*
		> fn: do restore 
	*/

    	function doRestore(data, callback) {

            var jsonString = data;
            var jsonData = JSON.parse(jsonString);

            // log(jsonData);

   			// >> get link to db
   			var db = balance.webdb.db;

   		    // >> delete all of the table rows
   		    $.when(
   		        deleteTable('budgets', db), 
   		        deleteTable('entries', db),
   		        deleteTable('budgets_entries', db),
   		        deleteTable('paid', db)
   		    ).then(function() {
   		    	// >> restore all of the tables
   		    	$.when(
   		    		restoreTable('budgets', db, jsonData),
   		    		restoreTable('entries', db, jsonData),
   		    		restoreTable('budgets_entries', db, jsonData),
   		    		restoreTable('paid', db, jsonData)
   		    	).then(function(){

   		    		// log('Database restored!');

   		    		// show notification
   		    		showNotification('Data restored from persistent storage!', 'success', 3000);

   		    		// disable emergency mode
   		    		disableEmergencyMode();

   		    		// fire the callback if there is one
   		    		if (callback) {
   		    			callback();
   		    		}
   		    	});

   		    });
    	}

/*
* global.js
*/

/*
* CONTENTS
*
* window load
*    native or browser?
* onDeviceReady
*    device detection
*    google analytics
*    version number check
*    setup pro version (if purchased) & check if pro trial expired
*    fastclick - makes taps fire quicker on mobile
*    initial login
*    database setup
*    global variables
*    instructions
*    settings - switches
*    settings - set or change currency
*    settings - pin code lock
*    settings - touch id login
*    settings - email address
*    settings - theme submenu
*      show theme submenu
*      back to settings from theme submenu
*      change theme
*      set theme on page load
*    settings - click 'tell a friend'
*    settings - click rate this app
*    settings - click email me
*    settings - click more apps
*    settings - books
*    settings - click clear data
*    touch feedback
*    initializations
*    sortable
*    show budget list on swipe right
*    show settings on swipe right
*    show budgets on swipe left
*    tap budget - show entry list
*    autogrow textareas
*    pro upgrade banner
*    tap or blur entry title
*    tap or blur entry amount
*    blur entry (update)
*    change entry date
*    calculator
*    calculate total income
*    tap add entry
*    swipe left - show options
*    tap delete entry
*    mark as paid & unpaid
*    star or unstar entry
*    tap add budget
*    tap delete budget
*    tap rename budget
*    tap export budget
*    blur budget (update)
*    toggle total income or expenses
*    toggle balance or paid
*    disable unwanted key presses
*    tutorial
*      show or hide tutorial
*    popups
*      pro upgrade popup
*    in-app purchases
*    tap title bar - scroll to top
*    show options menu
*    join newsletter
*    charts
*    toggle entry date column
*    tap show review icon
*    android back button
*    dropbox save & restore setup
*    check data on dropbox
*    dropbox save database
*    dropbox restore database
*    persistent storage - restore
*    persistent storage - stop asking
*    persistent storage - save
*    persistent storage - check if database deleted by ios
* onAppPaused
* onAppResumed
*/


/* -----------------------------------------------------------------------------------
	> window load
--------------------------------------------------------------------------------------- */

	$(window).load(function(){

	    /*
	    	>> native or browser?
	    */
	    
		    // isNative = (document.URL.indexOf("http://") === -1 && document.URL.indexOf("https://") === -1);

		    // isNative = (document.URL.indexOf('file:///private') > -1)

		    if (window.cordova) {
		    	isNative = true;
		    }
		    else {
		    	isNative = false;
		    }

		    if( isNative ) {
		        document.addEventListener("deviceready", onDeviceReady, false);
		        document.addEventListener("pause", onAppPaused, false);
		        document.addEventListener("resume", onAppResumed, false);
		    } else {  
		        onDeviceReady();
		    }

			
	});

/* -----------------------------------------------------------------------------------
	> onDeviceReady
--------------------------------------------------------------------------------------- */

	function onDeviceReady() {

		/*
			>> device detection
		*/

			if (isNative) {
				platform = device.platform; // 'iOS' / 'Android'
				if (platform === 'iOS') {
					$('body').addClass('ios');

					// variables 
					appReviewUrl = 'http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?pageNumber=0&sortOrdering=1&type=Purple+Software&mt=8&id=897849266';
					moreAppsUrl = 'itms-apps://itunes.com/apps/dannyconnell/';
					feedbackUrl = 'mailto:fudget@dconnell.co.uk?subject=Fudget - iOS - Feedback&body=' + getIosDeviceInfoForEmail();

					function getIosDeviceInfoForEmail() {

						if (window.cordova) {
							try {
								var deviceInfo = 	'\n\n';
									deviceInfo +=	'-- Please write message above this line --'
									deviceInfo +=	'\n\n';
									deviceInfo +=	'Platform: ' + device.platform + '\n';
									deviceInfo +=	'Platform version: ' + device.version + '\n';	
									deviceInfo +=	'Device model: ' + deviceModels[device.model] + ' (' + device.model + ') ' + '\n';	
									deviceInfo +=	'Fudget version: ' + versionNumber;	

								var deviceInfoEncoded = encodeURI(deviceInfo);
							}
							catch(error) {
								var deviceInfoEncoded = '';
							}
						}
						else {
							deviceInfoEncoded = '';
						}
						
						return deviceInfoEncoded;
					}
				}
				if (platform === 'Android') {
					$('body').addClass('android');

					// individual versions
					var androidVersion = parseFloat(getAndroidVersion());
					if (androidVersion < 4.4) {
						$('body').addClass('android-lt-4-4'); // less than android 4.4
					}

					// variables
					numberInputType = 'text'; // don't use number input on android
					// appReviewUrl = 'https://play.google.com/store/apps/details?id=com.dannyconnell.android.fudget';
					appReviewUrl = 'market://details?id=com.dannyconnell.android.fudget';
					appReviewUrlFallback = 'https://play.google.com/store/apps/details?id=com.dannyconnell.android.fudget';
					moreAppsUrl = 'market://search?q=pub:Danny+Connell';
					moreAppsUrlFallback = 'https://play.google.com/store/apps/developer?id=Danny+Connell';
					feedbackUrl = 'mailto:fudget@dconnell.co.uk?subject=Fudget - Android - Feedback&body=' + getAndroidDeviceInfoForEmail();
					pageTransitionLength = 30;
					animateTutorialSlides = false;

					function getAndroidDeviceInfoForEmail() {

						if (window.cordova) {
							try {
								var deviceInfo = 	'\n\n';
									deviceInfo +=	'-- Please write message above this line --'
									deviceInfo +=	'\n\n';
									deviceInfo +=	'Platform: ' + device.platform + '\n';
									deviceInfo +=	'Platform version: ' + device.version + '\n';	
									deviceInfo +=	'Device model: ' + device.model + '\n';	
									deviceInfo +=	'Fudget version: ' + versionNumber;	

								var deviceInfoEncoded = encodeURI(deviceInfo);
							}
							catch(error) {
								var deviceInfoEncoded = '';
							}
						}
						else {
							deviceInfoEncoded = '';
						}
						
						return deviceInfoEncoded;
					}
				}

			}

		/*
			>> google analytics
		*/

			if(window.cordova && typeof window.analytics !== undefined) {
				window.analytics.startTrackerWithId("UA-71053803-3");
				// window.analytics.debugMode();
			} else {
				console.log("Google Analytics Unavailable");
			}

		/* 
			>> version number check 
		*/

			if (!localStorage['versionNumber']) {
				localStorage['versionNumber'] = versionNumber;
			}
			// if user has updated (new version)
			if (versionNumber != localStorage['versionNumber']) {
				// allow user to be prompted for feedback again
				localStorage.removeItem('stopAsking');
				localStorage.removeItem('tappedLater');
				// reset number of entries made
				localStorage.entriesMade = 0;
				localStorage['versionNumber'] = versionNumber;
				// allow user to be shown new version popup
				localStorage.removeItem('seenNewVersionPopup');
			}

			// add version number to settings page
			$('.version-number').text(versionNumber);

		/*
			>> setup pro version (if purchased) & check if pro trial expired
		*/

			// enableProVersion(); // DELETE

			if (localStorage['IAPfudgetProUpgrade']) {
				enableProVersion();
			}

			checkProTrialExpired();

		/* 
			>> fastclick - makes taps fire quicker on mobile
		*/

			FastClick.attach(document.body);
			
		/*
			>> initial login
		*/

			touchIdSupported = false;

			// check for touch id support
			if (isNative && platform == 'iOS') {
				touchid.checkSupport(
					function() {
						//touch id supported
						touchIdSupported = true;
					}
				);
			}

			// if there's a pin code in local storage
			if (isNative) {
				if (localStorage.pinCode !== undefined && localStorage.pinCode.length > 0) {
					doLogin();
				}
				// else, just hide the splash screen and get started
				else {
					setTimeout(function() {
				        navigator.splashscreen.hide();
				        setupAdmob();
				    }, 1000);
				}
			}


		/* 
			>> database setup
		*/
		
			balance.webdb.open();
			balance.webdb.createTables();
			// balance.webdb.restoreDatabase(balance.webdb.getAllBudgets);
			balance.webdb.getAllBudgets();
			balance.webdb.checkIfDropboxDataNewer();
			
	
		/*
			>> global variables
		*/
		
			currencySymbol = '$';
			if (localStorage.getItem('lastPage') === null) {
				localStorage.setItem('lastPage', 'budgets');
			}
			$info = $('#info');
			$proUpgradeBanner = $('.pro-upgrade-banner');
			$addEntry = $('#add-entry');
			$entriesTitleBarTitle = $('#entries-container .title-bar .title');
			$houseAdIframe = $('.house-ad-iframe');
			animating = false;
						
			
		/*
			>> instructions
		*/
		
			// if user has not swiped to settings yet, show 'settings this way' instruction
			if (localStorage.getItem('swipedToSettings') === null) {
				var $settingsThisWay = $('<p class="instruction">Settings this way <br> (swipe right)</p>');
				$settingsThisWay.prependTo('#budgets-container');				
			}
			
			// if user has not swiped to budgets yet, show 'budgets this way' instruction
			if (localStorage.getItem('swipedToMyFudgets') === null) {
				var $budgetsThisWay = $('<p class="instruction">Budgets this way <br> (swipe right)</p>');
				$budgetsThisWay.prependTo('#entries-container');				
			}


		/*
			>> settings - switches
		*/

			var labelSwitchEvent = (platform == 'Browser' ? 'click' : 'touchstart')

			$('.label-switch').on(labelSwitchEvent, function (e) {

				var $this = $(this);
				var $checkbox = $this.find('input[type=checkbox]');

				if (!$checkbox.is(':checked')) {
					$checkbox.attr('checked', 'checked');
				}
				else {
					$checkbox.removeAttr('checked');
				}

				setTimeout(function(){
					$checkbox.trigger('change');
				}, 100);

			});



			
		/*
			>> settings - set or change currency
		*/
		
			// if currency has already been set
			if (localStorage.getItem('currencySymbol') !== null) {
				currencySymbol = localStorage.getItem('currencySymbol');
			}
			// currency not yet set, set to dollar
			else {
				localStorage.setItem('currencySymbol', '$');
			}
			// select correct option in dropdown
			$('#currency-symbol option[value="' + currencySymbol + '"]').attr('selected', 'selected');
			currencySymbol = localStorage.getItem('currencySymbol');
			$('#currency-symbol-fake').text(currencySymbol);
		
			// user changes currency symbol drop down
			$('#currency-symbol').change(function (e) {
				e.preventDefault();
				var $this = $(this);
				var symbol = $this.val();
				defaultText = $('#currency-symbol-fake').text();
				// if user chose custom, show popup
				if (symbol === 'custom') {

					// prompt for currency symbol
					nativePrompt(
						'Enter your currency symbol',   // message
						customCurrencySymbolEntered,	// callback
						'Custom currency symbol',	    // title
						['Ok'],	                        // button labels (optional)
						defaultText		                // default text (optional)
					);

					// prompt for currency symbol callback
					function customCurrencySymbolEntered(result) {
						symbol = result.input1;
						$('#currency-symbol-fake').text(symbol);
						currencySymbol = symbol;
						localStorage.setItem('currencySymbol', currencySymbol);
						// set select box to blank option
						$('#currency-symbol').val('');
					}

				}
				// otherwise just set the symbol as selected
				else {
					$('#currency-symbol-fake').text(symbol);
					currencySymbol = symbol; 
					localStorage.setItem('currencySymbol', currencySymbol);	
				}


			});
			
			// disable ghost tap
			$('#currency-symbol').on('touchstart', function (e) {
				var $this = $(this);
				var $thisItem = $this.parents('.item');
				$thisItem.addClass('click-fixer');
				setTimeout(function(){
					$thisItem.removeClass('click-fixer');
				}, 1000);
			});

		/*
			>> settings - pin code lock
		*/

			// if there's a pinCode in localStorage, set PIN code setting to On
			if (localStorage.pinCode !== undefined && localStorage.pinCode.length > 0) {
				$('#pin-code-lock').attr('checked', 'checked');
			}

			// user changes pin code lock option
			$('#pin-code-lock').change(function (e) {
				// update option text
				if ($(this).is(':checked')) {
					promptForNewPinCode();
					function promptForNewPinCode() {
						window.plugins.pinDialog.prompt(
							"Please enter a passcode with at least 4 digits.",
							newPinEntered,
							"Enter passcode",
							["Cancel","OK"]
						);
					}
					function newPinEntered(results) {
						// OK clicked
					    if(results.buttonIndex === 2) {
					    	// if pin of 4 digits or more entered
					    	if (results.input1.length >= 4) {
					    		// enable touch id option
					    		$('#setting-touch-id-login').removeClass('disabled');
					    		// set pinCode localStorage value to entered pin
					    		localStorage.setItem('pinCode', results.input1);
					    		if (localStorage.emailAddress === undefined || localStorage.emailAddress === '') {
						    		$('#setting-email-address').trigger('click');
					    		}
					    	}
					    	// else prompt again
					    	else {
					    		promptForNewPinCode();
					    	}

					    }
					    // cancel clicked
					    if(results.buttonIndex === 1) {
					        // set select back to off
					        $('#pin-code-lock').removeAttr('checked');
					    }
					}
				}
				// if 'off', remove password from localStorage
				else {
					promptForPinCodeToDisable('Disable passcode lock');
					function promptForPinCodeToDisable(title) {
						window.plugins.pinDialog.prompt(
							"Please enter your passcode to disable passcode lock", 
							disablePinCodeLock, 
							title, 
							["Cancel","OK"]);
					}

					function disablePinCodeLock(results) {
						// if ok button clicked
						if(results.buttonIndex === 2) {
							// if entered pin matches stored pin
							if (localStorage.pinCode === results.input1) {
								localStorage.removeItem('pinCode');
								// disable touch id option
								$('#setting-touch-id-login').addClass('disabled');
								$('#touch-id-login').removeAttr('checked');
								localStorage.setItem('touchIdLogin', 'false');
							}
							// incorrect pin
							else {
								promptForPinCodeToDisable('Incorrect passcode');
							}
						}
						// cancel clicked - set option back to on
						else {
							$('#pin-code-lock').attr('checked', 'checked');
						}
					}
				}

			});


		/*
			>> settings - touch id login
		*/
		
			// if there's a touchIdLogin in localStorage, set touch id login setting to On
			if (localStorage.getItem('touchIdLogin') === 'true') {
				// $('#touch-id-login').val('On');
				$('#touch-id-login').attr('checked', 'checked');
				// $('#setting-touch-id-login .setting-option').text('On');
			}

			// show touch id login setting if supported
			setTimeout(function(){
				if (touchIdSupported) {		
					$('#setting-touch-id-login').removeClass('hidden');
				}
			}, 1000);

			// enable touch id login setting if there is a pin code set
			if (localStorage.pinCode !== undefined && localStorage.pinCode.length > 0) {
				$('#setting-touch-id-login').removeClass('disabled');
			}

			// user changes touch id login option
			$('#touch-id-login').change(function (e) {

				// if option disabled, warn user
				if ($(this).parent().parent().hasClass('disabled')) {
					e.preventDefault();
					nativeAlert(null, null, 'Please set a passcode first.');
					$(this).removeAttr('checked');
				}
				// else update
				else {			
					// if 'on', set localStorage value
					if ($(this).is(':checked')) {
						localStorage.setItem('touchIdLogin', 'true');
					}
					// else 'off', set localStorage value to false
					else {
						localStorage.setItem('touchIdLogin', 'false');
					}
				}

			});

		
		/*
			>> settings - email address
		*/

			// set on page load
			if (localStorage.emailAddress) {
				$('#setting-email-address .setting-option').text(localStorage.emailAddress);
			}

			// user clicks setting
			$('#setting-email-address').click(function (e) {

				// get users email address if already stored
				defaultText = localStorage.emailAddress || '';

				// prompt for email address
				nativePrompt(
					'Enter an email address in case you forget your passcode?',	// message
					emailPromptCallback,	                                    // callback
					'Enter email address',	                                    // title
					['Cancel', 'Ok'],	                                        // button labels (optional)
					defaultText,	                                            // default text (optional)
					null,                                                       // fallback function (optional)
					2                                                           // fallback ok button index (optional)
				);

				// prompt for email address callback
				function emailPromptCallback(result) {
					// ok
					if (result.buttonIndex === 2) {
						localStorage.emailAddress = result.input1
						$('#setting-email-address .setting-option').text(result.input1);
					}
				}

			});

			// if a passcode has been previously set, but user has never been prompted for an email address (cos they set passcode on previous version), prompt for email
			if (localStorage.pinCode !== undefined && localStorage.emailAddress === undefined) {
				$('#setting-email-address').trigger('click');
			}


		/*
			>> settings - theme submenu
		*/
		
			/* >>> show theme submenu */
			// this speeds up animations when the app first starts (adding budgets)
			$('.theme-submenu').transition({
				x: '100%'
			}, 200);
			$('.show-theme-submenu').click(function (e) {
				e.preventDefault();
				
				if (freeVersion) {
					e.preventDefault();
					// if nothing is animating
					if (animating === false) {
						animating = true;
						$('#no-ads-themes-popup').show().transition( {y: '0%'}, 300, function() {
							animating = false;
						});
					}
				}
				else {
					if (bodyDragging === false && animating === false) {
						animating = true;
						// scroll and offset
						scrollAndOffset('#settings-container');

						// move settings slightly to the left (ios7 parallax)
						$('#settings-container').transition({
							x: '-90px'
						}, 300);
						
						// show theme submenu
						$('.theme-submenu').show().transition({
							x: '0%'
						}, 300, function() {
							$('#settings-container').hide().css('top', '0px');
							$('.title-bar a.touch').removeClass('touch');
							animating = false;
						});
					}
				}
							
			});
			
			/* >>> back to settings from theme submenu */
			$('.theme-submenu').on('swiperight', function (e) {
				if (bodyDragging === false) {
					// scroll to top of the page, then offset budgets container so it doesn't suddenly 'jump'
					scrollAndOffset('.theme-submenu');
					// show settings
					$('#settings-container').show().transition({
						x: '0%'
					}, 300);
					// slide out budgets
					$('.theme-submenu').transition({
						x: '100%'
					}, 300, function() {
						$('.theme-submenu').hide().css('top', '0px');
						$('.title-bar a.touch').removeClass('touch');
					});
				}
			});	
			$('.theme-submenu .back-to-settings').click(function (e) {
				e.preventDefault();
				$('.theme-submenu').trigger('swiperight');
			});
			
			/* >>> change theme */
			$('.theme-submenu .item').click(function (e) {
				e.preventDefault();
				var $this = $(this);
				// get theme name/class
				var theme = $this.attr('data-theme');
				var themeTitle = $this.find('.theme-color').text();
				
				// change html class
				$('html').removeClass().addClass(theme);
				
				// set active item
				$('.theme-submenu .item.active').removeClass('active');
				$this.addClass('active');
				
				// update settings option
				$('.show-theme-submenu .setting-option').text(themeTitle);
				
				// add to localstorage
				localStorage.setItem('theme', theme);
			});
			
			/* >>> set theme on page load */
			if (localStorage.theme !== undefined) {
				// set active theme setting
				$('.theme-submenu .item.active').removeClass('active');
				$('.theme-submenu .item[data-theme=' + localStorage.theme + ']').addClass('active');
				// update settings option
				var themeTitle = $('.theme-submenu .item.active').find('.theme-color').text();
				$('.show-theme-submenu .setting-option').text(themeTitle);
			}
			

		/*
			>> settings - click 'tell a friend'
		*/

			$('.tell-a-friend').click(function (e) {

				// variables
				var message = 'Check out this app Fudget I\'ve been using to manage my money!';
				var subject = 'Fudget for iOS and Android. ';
				var imageUrl = 'http://fudget.dconnell.co.uk/assets/images/fudget-action-shot.png';

				gaTrackEvent('Settings', 'Settings > Tapped Tell a friend', null);

				// prompt for facebook, twitter, instagram or other
				nativeConfirm(
					'Share Fudget on...',	                            // message
					tellAFriendCallback,	                            // callback
					'Tell a friend about Fudget',	                	// title
					['Facebook', 'Twitter', 'Email, Message etc...'],	// button labels
					'Sharing only supported on native device.'	        // fallback message
				);

				// prompt callback
				function tellAFriendCallback(buttonIndex) {
			     	// facebook pressed
			     	if (buttonIndex == 1) {
			     		// share on facebook
			     		window.plugins.socialsharing.shareViaFacebook(
			     			'Fudget - fast, simple money management',
			     			null,
			     			appWebsiteUrl, // url
			     			function() {
			     				nativeAlert('Thanks for sharing!', null, 'Thanks!');
			     				gaTrackEvent('Settings', 'Settings > Tapped Tell a friend > Shared on Facebook', null);
			     			},
			     			function(errormsg){
			     			},
			     			null
			     		);						     		
			     	}
			     	// twitter pressed
			     	if (buttonIndex == 2) {
			     		// share on twitter
				     	window.plugins.socialsharing.shareViaTwitter(
				     		message + ' ' + appWebsiteUrl, 
				     		imageUrl /* img */, 
				     		null,
				     		function() {
				     			nativeAlert('Thanks for sharing!', null, 'Thanks!');
				     			gaTrackEvent('Settings', 'Settings > Tapped Tell a friend > Shared on Twitter', null);
				     		}, 
				     		function(errormsg){
				     		},
				     		null
				     	);
			     	}
			     	// other pressed
			     	if (buttonIndex == 3) {
			     		window.plugins.socialsharing.share(
			     			message + ' ' + appWebsiteUrl, 
			     			subject, 
			     			imageUrl,
			     			function() {
			     				nativeAlert('Thanks for sharing!', null, 'Thanks!');
			     				gaTrackEvent('Settings', 'Settings > Tapped Tell a friend > Shared on Email or Other', null);
			     			}, 
			     			function(errormsg){
			     			},
			     			null
			     		);
			     	}
				}



			});

		/*
			>> settings - click rate this app
		*/

			$('.rate-this-app').click(function(e) {
				e.preventDefault();
				// GA - track event
				gaTrackEvent('Settings', 'Settings > Tapped Write a review', null);
				// android
				if (platform === 'Android') {
					try {
					    window.open(appReviewUrl, '_system'); 
					}
					catch(err) {
					    window.open(appReviewUrlFallback, '_system'); 
					}
				}
				// ios
				else {
					window.open(appReviewUrl, '_system'); 
				}
			});

		/*
			>> settings - click email me
		*/

			$('.send-feedback').click(function(e) {
				e.preventDefault();
				// GA - track event
				gaTrackEvent('Settings', 'Settings > Tapped Email me', null);
				window.open(feedbackUrl, '_system'); 
			});

		/*
			>> settings - click more apps
		*/

			$('.more-apps').click(function(e) {
				e.preventDefault();
				// GA - track event
				gaTrackEvent('Settings', 'Settings > Tapped More apps', null);
				// android
				if (platform === 'Android') {
					try {
					    window.open(moreAppsUrl, '_system'); 
					}
					catch(err) {
					    window.open(moreAppsUrlFallback, '_system'); 
					}
				}
				// ios
				else {
					window.open(moreAppsUrl, '_system'); 
				}
			});

		/*
			>> settings - books
		*/

			$('.books').click(function(e) {
				e.preventDefault();
				// GA - track event
				gaTrackEvent('Settings', 'Settings > Tapped Books', null);
			    window.open(booksUrl, '_system'); 
			});

		/*
			>> settings - click clear data
		*/

			$('.clear-data').click(function(e) {
				e.preventDefault();

				// confirm before deleting localStorage and database
				nativeConfirm(
					'Are you sure you want to clear all data? This cannot be undone.',	// message
					confirmClearData,					                                // callback
					'Clear all data?',						                            // title
					['Clear data','Cancel'],							                // button labels
					null,									                            // fallback message 
					1,										                            // fallback - ok pressed
					2										                            // fallback - cancel pressed
				);

				function confirmClearData(buttonIndex) {
					// clear pressed
					if (buttonIndex === 1) {
						// clear localStorage
						localStorage.clear();
						// clear database
						balance.webdb.deleteDatabase();
					}
				}
			});


		/*
			>> touch feedback
		*/
		
			$('#settings .item, .settings .item, .button, .popup-close').on('touchstart', function (e) {
				var $this = $(this);
				$this.addClass('touch');
				if (platform === 'Android') {
					setTimeout(function(){
						$this.removeClass('touch');
					}, 1000);
				}
			});

			$('#settings .item, .settings .item, .button, .popup-close').on('touchend mouseleave', function (e) {
				var $this = $(this);
				$this.removeClass('touch');
			});


		/*
			>> initializations
		*/

			// hammer.js
			dragMinDistance = 1;

			// different hammer options for each platform
			if (platform === 'iOS') {
				hammerOptions = {
					drag_block_horizontal: true,
					drag_min_distance: dragMinDistance,
					drag_lock_to_axis: true,
					slow_touches: false
				}
			}
			else if (platform === 'Android') {
				hammerOptions = {
					drag_block_horizontal: true,
					drag_min_distance: dragMinDistance,
					// drag_lock_to_axis: true,
					slow_touches: false
				}
			}
			else {
				hammerOptions = {
					drag_block_horizontal: true,
					drag_min_distance: dragMinDistance,
					drag_lock_to_axis: true,
					slow_touches: false
				}
			}

			$("#container").hammer(hammerOptions);
			

			
			// dragging detection for iOS only
			bodyDragging = false; // for android & browser
			if (platform === 'iOS') {

				// check if body (viewport) is being dragged
				var bodyDragging = false;
				$('#entries-container, #budgets-container, #settings-container').live('dragup dragdown', function (ev) {
					bodyDragging = true;
				});
				$('#entries-container, #budgets-container, #settings-container').live('dragend', function (ev) {
					var t = setTimeout(function(){
						bodyDragging = false;
					}, 200);
				});

			}

					
		/*
			>> sortable
		*/

			sortable('#entries .entry');
			sortable('#budgets .budget');

			function sortable(element) {
				
				// tap and hold entry
				var originalOffset;
				var placeholderHeight;
				var $placeholder;

				var topCutOff = 0;
				var bottomCutOff = $(window).height() - $('#info').height() - 47 - 47;
				
				$(element + ':not(.editing)').live("hold", function(ev) {
					// only allow dragging if no options are showing
					if ($(element + '.showing-options').length < 1) {
						var $this = $(this);
						// create a placeholder
						placeholderHeight = $this.height();
						$placeholder = $('<div class="placeholder" style="height: ' + placeholderHeight + 'px"></div>');
						$this.after($placeholder);
						// get original y offset of entry
						originalOffset = $this.position().top;
						// add dragging class and pull out of the page
						$this.addClass('dragging').transit({scale: 1.05}).css('top', originalOffset + 'px');
						
					}
				});
				
				// drag entry
				var previousDraggedEntryOffsetY = 0;
				// cut off points for automatic scrolling (when user drags an entry near the top or bottom of the viewport)
				$(element).live("drag", function(ev) {
					$draggedEntry = $(this);
					draggedEntryHeight = $draggedEntry.height();
					// only if dragging class added by tap hold
					if ($draggedEntry.hasClass('dragging')) {
						ev.gesture.preventDefault();
						draggedEntryOffsetY = originalOffset + ev.gesture.deltaY;
						// determine drag direction
						if (draggedEntryOffsetY <= previousDraggedEntryOffsetY) {
							direction = 'up';
						}
						else {
							direction = 'down';
						}
						previousDraggedEntryOffsetY = draggedEntryOffsetY;
						// move entry to cursor / touch position
						$draggedEntry.css({
							top: draggedEntryOffsetY
						});
						// compare position with the position of every entry
						$(element).not($draggedEntry).each(function(index) {
							$compareEntry = $(this);
							compareEntryOffset = $compareEntry.position().top;
							// if dragged entry is 'near' another entry, swap their places
							if (draggedEntryOffsetY > (compareEntryOffset - ((draggedEntryHeight / 2) - 10)) && draggedEntryOffsetY < (compareEntryOffset + ((draggedEntryHeight / 2) - 10)) ) {
								if (direction === 'up') {
									$placeholder.insertBefore( $compareEntry );
								}
								else {
									$placeholder.insertAfter( $compareEntry );
								}
							}
						});
						
						// scroll viewport up or down if user near the top or bottom
						var currentScrollTop = $(window).scrollTop(); // how far down the page the viewport is from the top
						var currentDragPosition = draggedEntryOffsetY - currentScrollTop; // y position of the dragged entry in relation to viewport
						if (currentDragPosition < topCutOff) {
							$("html,body").scrollTop(currentScrollTop - 5);
						}
						if (currentDragPosition > bottomCutOff) {
							$("html,body").scrollTop(currentScrollTop + 5);
						}
						
					}
				// user lets go of dragged entry
				}).live("release", function(ev) {
					var $droppedEntry = $(this);
					if ($droppedEntry.hasClass('dragging')) {
						// get position of placeholder
						placeholderY = $placeholder.position().top;
						// animate dropped entry to placeholder position
						$droppedEntry.animate({
							top: placeholderY
						}, 100, function() {
							// scale back down
							$droppedEntry.transit({
								scale: 1
							}, 100, function() {
								$droppedEntry.removeClass('dragging');
								$droppedEntry.insertAfter($placeholder);
								$droppedEntry.removeAttr('style');
								$placeholder.remove();

								// update entry order numbers (if an entry was released)								
								if (element === '#entries .entry') {
									// update order numbers for this particular budget - create arrays of budgetIds, entryIds and orderNumbers
									var entryIds = [],
										orderNumbers = [],
										budgetIds = [];
									$(element).each(function(index) {
										entryId = $(this).attr('data-id');
										entryIds.push(entryId);
										orderNumber = index+1;
										orderNumbers.push(orderNumber);
										budgetId = $('.budget.active').attr('data-id');
										budgetIds.push(budgetId);
										
										balance.webdb.updateEntryOrderNumbers(entryIds, orderNumbers, budgetIds);
									});
								}
								
								// update budget order numbers (if a budget was released)								
								if (element === '#budgets .budget') {
									// update budget order numbers - create arrays of budgetIds and orderNumbers
									var budgetIds = [],
										orderNumbers = []
									$(element).each(function(index) {
										budgetId = parseInt($(this).attr('data-id'));
										budgetIds.push(budgetId);
										orderNumber = index+1;
										orderNumbers.push(orderNumber);
									});
									balance.webdb.updateBudgetOrderNumbers(budgetIds, orderNumbers);
								}
								
								
							});
						});
					}
					
				});
				
			}


		/*
			>> show budget list on swipe right
		*/
		
			$('#entries-container').on('swiperight', function (e) {
				showBudgetsList();
			});
			
			// click back button
			$('.back-to-budgets').on('click', function (e) {
				e.preventDefault();
				showBudgetsList();
			});

			function showBudgetsList() {
				hasHistory = true;
				var $this = $('#entries-container');
				
				if (!$('#entries .entry.showing-options').length > 0 && !$('#entries .entry.editing').length > 0 && bodyDragging === false) {

					// GA - track page
					gaTrackView('Budgets');

					$info.addClass('off-bottom');

					// scroll to top of the page, then offset entries container so it doesn't suddenly 'jump'
					scrollAndOffset('#entries-container');
					
					// show budgets container
					$('#budgets-container').show().transition({
						x: '0%'
					}, pageTransitionLength);
					
					// slide out the entries container
					$('#entries-container').transition({
						x: '100%'
					}, pageTransitionLength, function() {
						$('#entries-container').hide().css('top', '0px');
						$('#entries').html('');
						$('.title-bar a.touch').removeClass('touch');
						localStorage.setItem('lastPage', 'budgets');
						// remove styles from #budgets-container
						$('#budgets-container').attr('style', 'display: block;');
						// show pro upgrade banner
						showProUpgradeBanner();
						// hide 'my fudgets this way' instruction forever
						if (localStorage.getItem('swipedToMyFudgets') === null) {
							$budgetsThisWay.remove();
							localStorage.swipedToMyFudgets = true;
						}
						// hide feedback module if visible
						if ($('body').hasClass('show-feedback-module')) {
							$('body').removeClass('show-feedback-module');
						}
					});
				}				
			}
		
			
		/*
			>> show settings on swipe right
		*/
			
			// this speeds up animations when the app first starts (adding budgets)
			$('#budgets-container').transition({
				x: '0%'
			}, 200);
			
			$('#budgets-container').on('swiperight', function (e) {
				
				if (!$('#budgets .budget.showing-options').length > 0 && !$('#budgets .budget.editing').length > 0 && bodyDragging === false) {
					hasHistory = true;
					// GA - track page
					gaTrackView('Settings');
					// hide pro upgrade banner
					hideProUpgradeBanner();
					// scroll to top of the page, then offset budgets container so it doesn't suddenly 'jump'
					scrollAndOffset('#budgets-container');
					// show settings
					$('#settings-container').show().transition({
						x: '0%'
					}, pageTransitionLength);
					// slide out budgets
					$('#budgets-container').transition({
						x: '100%'
					}, pageTransitionLength, function() {
						$('#budgets-container').hide().css('top', '0px');
						localStorage.setItem('lastPage', 'settings');
						$('.title-bar a.touch').removeClass('touch');
						// remove styles from settings container to prevent loss
						// of sticky title bar on android
						$('#settings-container').removeAttr('style');
						// hide 'settings this way' instruction forever
						if (localStorage.getItem('swipedToSettings') === null) {
							$settingsThisWay.remove();
							localStorage.swipedToSettings = true;
						}
					});
				}
						
			});	
			
			$('#budgets-container .back-to-settings').on('click', function (e) {
				e.preventDefault();
				$('#budgets-container').trigger('swiperight');
			});
			
		/*
			>> show budgets on swipe left
		*/
		
			$('#settings-container').on('swipeleft', function (e) {
				
				if (bodyDragging === false && animating === false) {
					animating = true;

					hasHistory = true;

					// GA - track page
					gaTrackView('Budgets');

					// scroll to top of the page, then offset budgets container so it doesn't suddenly 'jump'
					scrollAndOffset('#settings-container');

					// move settings slightly to the left (ios7 parallax)
					$(this).transition({
						x: '-90px'
					}, pageTransitionLength);
					
					// show budgets container
					$('#budgets-container').show().transition({
						x: '0%'
					}, pageTransitionLength, function() {
						$('#settings-container').hide().css('top', '0px');
						localStorage.setItem('lastPage', 'budgets');
						$('.title-bar a.touch').removeClass('touch');
						// show pro upgrade banner
						showProUpgradeBanner();
						// remove styles from #budgets-container
						$('#budgets-container').attr('style', 'display: block;');
						animating = false;
					});
				}
						
			});
			
			$('#show-budgets-container, .forward-to-budgets').on('click', function (e) {
				e.preventDefault();
				var $this = $(this);
				$('#settings-container').trigger('swipeleft');
			});
			

			
		/*
			>> tap budget - show entry list
		*/
		
			$('#budgets .budget:not(.editing,.showing-options) .budget-details').live('click', function (e, isTriggered) {
				e.preventDefault();
				hasHistory = true;
				// GA - track page
				gaTrackView('Entries');
				// if no budget options are showing, and nothing is animating, and item not being dragged, show entry list
				if ($('#budgets .budget.showing-options').length < 1 && animating === false && !$(this).parent().hasClass('dragging')) {
					animating = true;
					var $this = $(this);
					var $thisBudget = $this.parent();
					// touch feedback
					$thisBudget.addClass('touch');
					$('#budgets .budget.active').removeClass('active');
					$this.parent().addClass('active');
					var budgetId = $this.parent().attr('data-id');
					var budgetTitle = $this.find('textarea').val();
					var $entriesContainer = $('#entries-container');
					var $budgetsContainer = $('#budgets-container');
					
					// hide pro upgrade banner
					hideProUpgradeBanner();
					
					// scroll to top of the page, then offset budgets container so it doesn't suddenly 'jump'
					/// scrollAndOffset('#budgets-container');
					
					finishedLoadingEntries = false;

					balance.webdb.getAllEntries(budgetId, loadAllEntries);

					// wait for entries to load into markup
					var waitForEntries = setInterval(function(){
						if (finishedLoadingEntries) {
							displayEntries();
							clearInterval(waitForEntries);
						}
					}, 100);

					function displayEntries() {
						
						// setup textareas
						$('#entries .entry textarea').each(function(index) {
							initializeAutogrowTextarea($(this));
						});
						$entriesTitleBarTitle.text(budgetTitle);
						// if event was triggered by javascript (not a human) fade entries in instead of slide in
						if (isTriggered) {
						    $entriesContainer.hide().transition({x: '0%'});
						    $entriesContainer.fadeIn();
						    transitionTime = 0;
						}
						else {
							$entriesContainer.show();
							transitionTime = 300;
						}

						// prompt for feedback if created over x entries
						if (localStorage.entriesMade >= showRateThisAppPopupAfterEntries && !localStorage.stopAsking) {
							// if user tapped Later, just show the review icon
							if (localStorage.tappedLater) {
								showReviewIcon();
							}
							// else prompt for feedback
							else {
								setTimeout(function(){
									promptForFeedback();
								}, 1000);
							}
						}

						// hide #budgets
						$('#budgets, #budgets-container .buttons, #budgets-container .title-bar').addClass('hidden');

						setTimeout(function(){
							
							// scroll to bottom
							scrollToBottom();

							// ios - fancy transition
							if (platform === 'iOS') {

								// move budgets container just a little (ios 7 style)
								$budgetsContainer.transition({
									x: '-90px'
								}, 0);

								// slide in entries container
								$entriesContainer.transition({
									x: '0%'
								}, transitionTime, function() {
									finishBudgetsToEntriesTransition();
								});

							}
							// android - simple transition
							else {
								finishBudgetsToEntriesTransition();
							}

						}, 200);


						function finishBudgetsToEntriesTransition() {
							// show & reset #budgets
							$('#budgets, #budgets-container .buttons, #budgets-container .title-bar').removeClass('hidden');
							$budgetsContainer.hide().css('top', '0px');
							$thisBudget.removeClass('touch');

							// show #info
							$info.removeClass('off-bottom');

							// remove styles from #entries-container
							$('#entries-container').attr('style', 'display: block;');

							animating = false;
							localStorage.setItem('lastPage', 'entries');
							localStorage.setItem('lastBudgetId', budgetId);
						}

					}
					
				}
				
			});


	    /* 
	    	>> autogrow textareas
	    */
	    
			$('#entries textarea.entry-title').each(function(index) {
				textarea = $(this);
				initializeAutogrowTextarea(textarea);
			});				
				

		/*
			>> pro upgrade banner
		*/
		
			// setup pro upgrade banner
			$('.pro-upgrade-banner-slides').slick({
				autoplay: true,
				autoplaySpeed: 4500,
				dots: true,
				arrows: false
			});
		
			// close pro upgrade banner
			$('.pro-upgrade-banner .icon-delete').click(function (e) {
				e.preventDefault();
				e.stopPropagation();
				hideProUpgradeBanner();
				setTimeout(function(){
					$proUpgradeBanner.addClass('hidden');
				}, 300);
			});
	    /* 
	    	>> tap or blur entry title
	    */
	    
			$('#entries p.entry-title').live('click', function(e) { 
				var $this = $(this);
				// don't allow if options are showing
				if ($('#entries .entry.showing-options').length < 1) {
					
					// add focus class to entry
					$this.parent().parent().addClass('focus-left');
					
			    	$this.addClass('invisible');
			    	$this.parent().find('textarea.entry-title').removeClass('off-page').select();
			    }
			});
		    $('#entries textarea.entry-title').live('blur', function (e) {
		    	var $this = $(this);
		    	var $entry = $this.parent().parent();
		    	
		    	// show info box and title bar
		    	setTimeout(function(){
		    		if ($('#entries-container .focus-left, #entries-container .focus-right, #entries-container .focus-all').length === 0) {
				    	$info.removeClass('off-bottom');
				    	// change position of title bar back to fixed
				    	$('#entries-container .title-bar').removeClass('pos-absolute');
				    	$('#entries').removeClass('padding-top-50');
				    }
		    	}, 200);
		    	
		    	// remove focus class from entry
		    	$this.parent().parent().removeClass('focus-left');
		    	
				// $addEntry.removeClass('disabled');
		    	$this.addClass('off-page');
		    	$this.parent().find('p.entry-title').removeClass('invisible');
		    	$entry.removeClass('editing');

		    	$houseAdIframe.removeClass('hidden');
		    });
		    $('#entries textarea.entry-title').live('focus', function (e) {
				var $this = $(this);
				
				// select all text
				/*this.selectionStart = 0;
				this.selectionEnd = 999;*/
				
				// add focus class to entry
				$this.parent().parent().addClass('focus-left');
				
				// hide info box
				$info.addClass('off-bottom');
				
				// change title bar position to absolute 
				$('#entries-container .title-bar').addClass('pos-absolute');
				$('#entries').addClass('padding-top-50');
				
		    	$this.removeClass('off-page');
		    	$this.parent().find('p.entry-title').addClass('invisible');		    	
		    	$this.parent().parent().addClass('editing');

		    	$houseAdIframe.addClass('hidden');
		    });
		    $('#entries textarea.entry-title').live('keyup', function (e) {
		    	var $this = $(this);
		    	var titleText = $this.val();
		    	$this.parent().find('p.entry-title').text(titleText);
		    });
		    
	 
	    /* 
	    	>> tap or blur entry amount
	    */
	    
		    $('#entries p.amount').live('click', function (e) {
		    	var $this = $(this);
		    	var $entry = $this.parent().parent();
		    	var $entryDetails = $entry.find('.entry-details');
				// don't allow if options are showing
				if ($('#entries .entry.showing-options').length < 1 && $entry.css('translate') !== null && !$entry.hasClass('dragging-x')) {
					
					// add focus class to entry
					$this.parent().parent().addClass('focus-right');
			    	
			    	$this.addClass('hidden');
			    	var $inputAmount = $this.parent().find('input.amount');
			    	// if the value is zero, empty input, rather than having '0' which the user would then have to delete
			    	if ($inputAmount.val() === 0) {
			    		$inputAmount.val('');
			    	}
			    	$inputAmount.removeClass('invisible').select();
			    }
		    });    	
			$('#entries input.amount').live('blur', function (e) {
		    	$this = $(this);
		    	// remove focus class from entry
		    	$this.parent().parent().removeClass('focus-right');
		    	
		    	// show info box and title bar
		    	setTimeout(function(){
		    		if ($('#entries-container .focus-left, #entries-container .focus-right, #entries-container .focus-all').length === 0) {
				    	$info.removeClass('off-bottom');
				    	// change position of title bar back to fixed
				    	$('#entries-container .title-bar').removeClass('pos-absolute');
				    	$('#entries').removeClass('padding-top-50');
				    }
		    	}, 200);
		    	
		    	$this.addClass('invisible');
		    	
		    	// update 'fake' input
		    	fakeInput = $this.parent().find('p.amount');
		    	fakeInput.removeClass('hidden');
		    	if (isNaN($this.val()) || $this.val() === '') {
		    		$this.val(0);
		    	}
		    	fakeInputText = $this.val();
		    	fakeInputText = currencify(fakeInputText);
		    	
		    	// add plus or minus
		    	var modifier;
		    	if ($this.parent().parent().hasClass('income')) {
		    		modifier = '+';
		    	}
		    	else {
		    		modifier = '-';	
		    	}
		    	fakeInputText = modifier +  ' ' + fakeInputText;
		    	fakeInput.find('span').html(fakeInputText);
		    	$this.parent().parent().removeClass('editing');

		    	$houseAdIframe.removeClass('hidden');
		    });
			$('#entries input.amount').live('focus', function (e) {
		    	var $this = $(this);
		    	
		    	// add focus class to entry
		    	$this.parent().parent().addClass('focus-right');
		    	
				// hide info box
				$info.addClass('off-bottom');
				
				// change title bar position to absolute 
				$('#entries-container .title-bar').addClass('pos-absolute');
				$('#entries').addClass('padding-top-50');
				
		    	$this.removeClass('invisible');
		    	$this.parent().find('p.amount').addClass('hidden');
		    	$this.parent().parent().addClass('editing');

		    	$houseAdIframe.addClass('hidden');
		    });
		    
		    
	    /* 
	    	>> blur entry (update)
	    */
	    
	    	// get original value on focus
	    	var originalValue = '';
	    	$('#entries textarea.entry-title, #entries input.amount').live('focus', function (e) {
	    		originalValue = $(this).val();
	    	});

	    	$('#entries textarea.entry-title, #entries input.amount').live('blur', function (e) {
		    	// update entry in database
		    	var $this = $(this);
		    	var $entry = $this.parent().parent();
		    	var entryIndex = $entry.index() + 1;
		    	var title = $entry.find('textarea.entry-title').val();
		    	var amount = $entry.find('input.amount').val();
		    	var isexpense = 0;
		    	var blurredValue = $(this).val();
		    	var pinned;
		    	var checkForEntryId;
		    	var entryId;

				// if data-id attribute is empty (because we're still waiting for entry to be added to db - and attribute to be updated) then wait for a data-id attribute
				if ($entry.attr('data-id') === '') {
					var checkForEntryIdCount = 0;
					checkForEntryId = setInterval(function(){
						checkForEntryIdCount++;
						if (checkForEntryIdCount === 50) {
							clearInterval(checkForEntryId);
						}
						else if ($entry.attr('data-id') !== '') {
							clearInterval(checkForEntryId);
							entryId = $entry.attr('data-id');
							finishUpdatingEntry(entryId, title);
						}
					}, 100);
				}
				else {
					entryId = $entry.attr('data-id');
					finishUpdatingEntry(entryId, title);
				}

				function finishUpdatingEntry() {

			    	// if amount is null or NaN, set it to 0
			    	if (isNaN(amount) || amount === '') {
			    		amount = 0;
			    	}
			    	var currentlyViewedBudgetId = $('#budgets .budget.active').attr('data-id');
			    	// if its an expense, make positive number negative and set isexpense value
			    	if ($entry.hasClass('expense')) {
			    		amount = amount * -1; // make positive number negative
			    		isexpense = 1;
			    	}	
			    	// entry NOT pinned, just update it
			    	if (!$entry.hasClass('pinned')) {
			    		pinned = 0;
			    		// update entry
				    	balance.webdb.editEntry(entryId, title, amount, pinned, isexpense);
					}
			    	// entry IS pinned: unpin first, then update that
			    	else if (blurredValue !== originalValue) { // only if value has changed
			    		pinned = 1;
			    		// show loading screen
			    		showLoadingScreen();
			    		// unpin entry
			    		balance.webdb.unpinEntry(entryId, currentlyViewedBudgetId);
			    		// update entry
			    		var t = setTimeout(function(){
			    			$entry = $('#entries .entry:nth-child(' + entryIndex + ')');
			    			// add pinned class
			    			$entry.addClass('pinned');
			    			$entry.find('.pin').addClass('unpin').removeClass('pin');
			    			// update entry
					    	var entryId = $entry.attr('data-id');
					    	// update title elements
					    	$entry.find('.entry-title').text(title);
					    	// update amount elements
					    	$inputAmount = $entry.find('input.amount');
					    	// make sure value that gets added to input value attribute is positive
					    	if (amount < 0) {
					    		inputValueAmount = amount * -1;	
					    	}
					    	else {
					    		inputValueAmount = amount;
					    	}
					    	$inputAmount.val(inputValueAmount);
					    	fakeInput = $inputAmount.parent().find('p.amount');
					    	fakeInputText = $inputAmount.val();
					    	fakeInputText = Math.abs(fakeInputText);
					    	fakeInputText = currencify(fakeInputText);
					    	
					    	// add plus or minus
					    	var modifier;
					    	if ($inputAmount.parent().parent().hasClass('income')) {
					    		modifier = '+';
					    	}
					    	else {
					    		modifier = '-';
					    	}
					    	fakeInputText = modifier +  ' ' + fakeInputText;
					    	fakeInput.html(fakeInputText);
					    	
					    	// update entry in database
					    	balance.webdb.editEntry(entryId, title, amount, pinned, isexpense);
					    	
					    	// update income and balance
					    	calculateIncomeAndBalance();
					    	
					    	// hide loading screen
					    	hideLoadingScreen();

			    	    	// android - scroll to bottom
			    	    	// if (platform === 'Android') {
			    	    	// 	setTimeout(function(){
			    	    	// 		scrollToBottom();
			    	    	// 	}, 400);
			    	    	// }
			    		// }, 250);
			    		}, 500);
			    	}

			    	// if android, refresh banner
			    	if (platform === 'Android') {
			    		refreshBanner();
			    	}

			    }

			});
			

		/*
			>> change entry date
		*/

			$('.entry-date').live('blur', function() {

				var $this = $(this),
					$entry = $this.parent().parent(),
					budgetId = parseInt($('#budgets .budget.active').attr('data-id')),
					entryId = parseInt($entry.attr('data-id')),

					// get unix date from date input value
					date = $this.val(),
					dateUnix = dateToUnix(date);

				// add date to database
				balance.webdb.editDate(budgetId, entryId, dateUnix);

				// change position of title bar back to fixed
				$('#entries-container .title-bar').removeClass('pos-absolute');
				$('#entries').removeClass('padding-top-50');

			})

			$('.entry-date').live('focus', function() {

				var $this = $(this);

				// remove placeholder
				$this.removeAttr('placeholder');

				// change title bar position to absolute 
				$('#entries-container .title-bar').addClass('pos-absolute');
				$('#entries').addClass('padding-top-50');
			})

			$('.entry-date').live('change', function() {

				var $this = $(this);
				$this.trigger('blur');

			})


		
		/*
			>> calculator
		*/
		
			// show calculator
			$('.entry-options .calculator').live('click', function (e) {
				e.preventDefault();
				var $this = $(this);

				// if locked, show calculator upgrade popup
				if (freeVersion) {
					$('#calculator-popup').show().transition( {y: '0%'}, 300, function() {
		 				animating = false;
		 			});
				}
				// else show calculator
				else {
					var $entry = $this.parents('.entry');
					var $amount = $entry.find('input.amount');
					var startingValue = parseFloat($amount.val());
					$amount.addClass('using-calc');
					
					initCalculator(startingValue);
					$('.calculator-container').removeClass('hidden');
					setTimeout(function(){
						$('.calculator-container').addClass('show');
					}, 100);
				}
			});
			
			// close calculator
			$('.close-calculator').live('click', function (e) {
				e.preventDefault();
				$('.calculator-container').removeClass('show');
				// destroy calculator
				setTimeout(function(){
					$('.calculator-container .calculator').calculator('destroy');
					$('.using-calc').removeClass('using-calc');
					$('.calculator-container').addClass('hidden');
				}, 350);
			});
			
			// touch feedback
			$('button').live('click', function (e) {
				var $this = $(this);
				$this.addClass('touch');
				setTimeout(function(){
					$this.removeClass('touch');
				}, 500);
			});
		
			function initCalculator(value) {
			
				$('.calculator-container .calculator').calculator({
					onClose: useValue,
					layout: ['_7_8_9_/',
							'_4_5_6_*',
							'_1_2_3_-',
							'_0_._+',
							'@XCABS@U_='],
					clearText: '<i class="icon-bin"></i>',
					backspaceText: '<i class="icon-backspace"></i>',
					useText: '<i class="icon-tick"></i>',
					value: value,
					precision: 5,
					onButton: function(label, value, inst) { 
				        switch (label) {
				        	case '/':
				        		activateCalcButton('.calculator-divide');
				        		break;
				        	case '*':
				        		activateCalcButton('.calculator-multiply');
				        		break;
				        	case '-':
				        		activateCalcButton('.calculator-subtract');
				        		break;
				        	case '+':
				        		activateCalcButton('.calculator-add');
				        		break;
				        	default:
				        		break;
				        }
				        function activateCalcButton(selector) {
	                		setTimeout(function(){
	        	        		$(selector).addClass('active');
	                		}, 25);
	                	}
				    }
				});
				function useValue(value, inst) { 
					// update value of entry amount and trigger blur so everything updates
				    var valueFixed = Math.abs(value.toFixed(2));
				    var $amount = $('.using-calc');
				    var $entry = $amount.parents('.entry');
				    $amount.val(valueFixed).trigger('blur');
				    // close the calculator
				    $('.close-calculator').trigger('click');
				    // hide the options
				    setTimeout(function(){
					    $entry.find('.entry-details').transition({
					    	x: '0'
					    }, 100, function() {
					    	$entry.removeClass('showing-options');
					    });
				    }, 300);
				}
			}	
			
		
		/* 
			>> calculate total income 
		*/
		
			calculateIncomeAndBalance();
			$('#entries input.amount').live('blur change', function (e) {
				setTimeout(function(){
					calculateIncomeAndBalance();
				}, 200);
			});
			
			
		/*
			>> tap add entry
		*/
		
			$('#add-income, #add-expense').on('click', function (e) {
				e.preventDefault();

				// figure out type of entry to add
				var $this = $(this);
				var entryType;
				if ($this.is('#add-income')) {
					entryType = 'income';
				}
				else {
					entryType = 'expense';	
				}
				
				// hide any showing entry options
				if ($('#entries .item.showing-options').length > 0) {
					$('#entries .item.showing-options .entry-details').transition({
						x: '0'
					}, 100, function() {
						$('#entries .item.showing-options').removeClass('showing-options');
						addNewEntryMarkup();
					});
				}
				else {
					addNewEntryMarkup();	
				}
				
				function addNewEntryMarkup() {
				
					// add markup
					var operator;
					var isExpense;
					if (entryType === 'expense') {
						operator = '-';
						isExpense = 1;
					}
					else {
						operator = '+';	
						isExpense = 0;
					}
					var placeholderText;
					if (entryType === 'expense') {
						placeholderText = 'E.g. Rent';
					}
					else {
						placeholderText = 'E.g. Salary';	
					}
					
					var entryMarkup = 	'<div class="entry ' + entryType + ' item clearfix clear" data-id="">';
					entryMarkup += 			'<div class="entry-details item-details clearfix theme-color theme-border">';
					entryMarkup += 				'<textarea class="entry-title item-title theme-color" rows="1" cols="20" autocapitalize="on" autocorrect="off" autocomplete="off" placeholder="' + placeholderText + '"></textarea>';
					entryMarkup += 				'<p class="entry-title item-title fake theme-color"></p>';
					entryMarkup += 				'<input class="amount item-title invisible theme-color" type="' + numberInputType + '" value="" autocapitalize="off" autocorrect="off" autocomplete="off">';
					entryMarkup += 				'<p class="amount item-title fake theme-color"><span>' + operator + ' ' + currencySymbol + ' 0.00</span></p>';
					entryMarkup +=				'<input type="date" class="entry-date theme-color" placeholder="Date">';
					entryMarkup += 			'</div>';
					entryMarkup += 			'<div class="entry-options item-options theme-bg theme-border">';
					entryMarkup += 				'<div class="delete option">';
					entryMarkup += 					'<div class="icon">';
					entryMarkup +=						'<i class="icon-bin"></i>';
					entryMarkup +=						'<span>Delete</span>';
					entryMarkup +=					'</div>';
					entryMarkup +=				'</div>';
					entryMarkup += 				'<div class="pin option">';
					entryMarkup += 					'<div class="icon">';
					entryMarkup +=						'<i class="icon-star"></i>';
					entryMarkup +=						'<span>Star</span>';
					entryMarkup +=					'</div>';
					entryMarkup +=				'</div>';
					entryMarkup += 				'<div class="unpaid option">';
					entryMarkup += 					'<div class="icon"><i class="icon-unpaid"></i>';
					entryMarkup += 					'<span>Paid</span></div>';
					entryMarkup += 				'</div>';
					entryMarkup += 				'<div class="calculator option disabled-on-free">';
					entryMarkup += 					'<div class="icon">';
					entryMarkup +=						'<i class="icon-calculator"></i>';
					entryMarkup +=						'<span>Calc.</span>';
					entryMarkup +=					'</div>';
					entryMarkup +=				'</div>';				
					entryMarkup += 			'</div>';
					entryMarkup += 		'</div>';
					$entryMarkup = $(entryMarkup);
					$entryMarkup.appendTo('#entries');
				
					// select and setup textarea
					var textarea = $entryMarkup.find('textarea.entry-title');
					textarea.select();
					initializeAutogrowTextarea(textarea);
					updateEntriesMade(); // update count of entries made, so we can ask user to rate app after 50		
					
					// $info.hide();
					$info.addClass('off-bottom');

					// setup date fields
					// datePicker = $entryMarkup.find('.entry-date').pickadate(pickadateOptions);
				
					// add entry to database
					var budgetId = $('#budgets .budget.active').attr('data-id');
					var orderNumber = parseInt($('#entries .entry').length, 10) + 1;
					balance.webdb.addEntry(budgetId, orderNumber, isExpense, $entryMarkup);

					// android - scroll down to bottom
					if (platform === 'Android') {
						setTimeout(function(){
							scrollToBottom();
						}, 400);
					}

				}
				
			});	
						

		/*
			>> swipe left - show options
		*/
			
			var draggedEntryOffsetX;

			// figure out at which point on the left drag we should allow swipe-to-delete
			var swipeToDeleteOffset = -220; // iPhone 4 + 5
			if ($(window).width() >= 375) {
				swipeToDeleteOffset = -275; // iPhone 6
			}
			if ($(window).width() >= 414) {
				swipeToDeleteOffset = -314; // iPhone 6 Plus
			}
			if ($(window).width() >= 768) {
				swipeToDeleteOffset = -384; // iPad portrait
			}

			// Android - item swipe events (drag events didn't work too well)
			/*if (platform === 'Android') {

				// swipe entry left
				$('#entries .entry:not(.editing), #budgets .budget:not(.editing)').live("swipeleft", function(ev) {
					var $this = $(this);
					var $entryDetails = $this.find('.entry-details, .budget-details');
					if ($('#entries .showing-options, #budgets .showing-options').length < 1 && $('#entries .editing, #budgets .editing').length < 1 && animating === false) {
						$entryDetails.transition({
							x: '-165'
						}, 100, function() {
							$this.addClass('showing-options');
						});
					}
				});

				// swipe entry right
				$('#entries .entry.showing-options:not(.editing), #budgets .budget.showing-options:not(.editing)').live("swiperight", function(ev) {
					var $this = $(this);
					var $entryDetails = $this.find('.entry-details, .budget-details');
					$entryDetails.css({x: 0});
					$this.removeClass('showing-options');
				});

			}*/

			// iOS - item drag events (more iOS style item drags)
			// if (platform === 'iOS') {

				// drag entry left
				$('#entries .entry:not(.editing), #budgets .budget:not(.editing)').live("dragleft", function(ev) {
					var $this = $(this);
					// log(ev.gesture.angle);
					// console.log(ev.gesture.angle);
					// only fire if user isn't swiping vertically quite a bit
					// if (ev.gesture.deltaY <= 30 && ev.gesture.deltaY >= -30) {
					// if (bodyDragging === false) {

						// if no entry or budget options are showing & nothing is being edited, drag the entry details along and uncover options
						if ($('#entries .showing-options, #budgets .showing-options').length < 1 && $('#entries .editing, #budgets .editing').length < 1 && bodyDragging === false && !$this.hasClass('dragging') && animating === false) {
							$this.addClass('dragging-x');
							var $entryDetails = $this.find('.entry-details, .budget-details');
							draggedEntryOffsetX = ev.gesture.deltaX;
							if (draggedEntryOffsetX > (swipeToDeleteOffset - 20)) {
								$entryDetails.css({x: draggedEntryOffsetX});
							}
							// swipe to delete
							if (draggedEntryOffsetX < swipeToDeleteOffset) {
								$this.addClass('swipe-to-delete');	
							}
							else {
								$this.removeClass('swipe-to-delete');	
							}
						}
					// }
				});
				
				// drag entry right
				$('#entries .entry.showing-options:not(.editing), #budgets .budget.showing-options:not(.editing)').live("dragright", function(ev) {
					var $this = $(this);
					// if nothing is being edited
					if ($('#entries .editing, #budgets .editing').length < 1 && bodyDragging === false && !$this.hasClass('dragging') && animating === false) {
						$this.addClass('dragging-x');
						var $entryDetails = $this.find('.entry-details, .budget-details');
						originalOffset = -181;
						draggedEntryOffsetX = originalOffset + ev.gesture.deltaX;
						if (draggedEntryOffsetX > -211 && draggedEntryOffsetX < 0) {
							$entryDetails.css({x: draggedEntryOffsetX});
						}
					}
				});
				
				// drag end
				$('#entries .entry.dragging-x:not(.editing), #budgets .budget.dragging-x:not(.editing)').live("dragend", function(ev) {
					var $this = $(this);
					var $entryDetails = $(this).find('.entry-details, .budget-details');
					// if no options are showing 
					if ($('#entries .showing-options, #budgets .showing-options').not(this).length < 1 && !$this.hasClass('dragging') && animating === false) {
						// if dragged enough to show delete button alone, delete entry
						if (draggedEntryOffsetX < swipeToDeleteOffset) {
							$this.addClass('swipe-to-delete');	
							$this.find('.delete').trigger('click');
						}
						// if dragged enough to reveal more than half of the options & no options are showing, show options
						else if (draggedEntryOffsetX < -88) {
							$this.removeClass('dragging-x');
							// disable buttons
							$entryDetails.transition({
								x: '-181'
							}, 100, function() {
								$this.addClass('showing-options');
								$this.removeClass('dragging-x');
							});
						}
						// else, slide it back (hide the options)
						else {
							$entryDetails.transition({
								x: '0'
							}, 100, function() {
								$this.removeClass('showing-options');
								$this.removeClass('dragging-x');
							});					
						}
					}
				});

			// }
			

		/*
			>> tap delete entry
		*/		
			
			$('#entries .entry .delete').live('click', function (e) {
				e.preventDefault();
				$entryToDelete = $(this).parent().parent();
				budgetId = $('.budget.active').attr('data-id');
				var entryId = $entryToDelete.attr('data-id');
				// if we're near the bottom (and not at the top) scroll user up a bit before deleting the entry to avoid rough animation
				var top = $('html').offset().top;
				if(nearBottom(84) && top !== 0) {
					$('html, body').animate({
						scrollTop: Math.abs(top + $entryToDelete.height())
					}, 100, function() {
						deleteEntry();
					});
				}
				else {
					deleteEntry();	
				}
				function deleteEntry() {
					$entryToDelete.transition({
						opacity: 0,
						x: '-100%'
					}, 200, function() {
						$entryToDelete.animate({
							height: '0'
						}, 150, function() {
							$entryToDelete.remove();
							// enable buttons
							calculateIncomeAndBalance();
							balance.webdb.deleteEntry(entryId, budgetId);
						});
					});
				}
			});
		

		/*
			>> mark as paid & unpaid
		*/

			$('#entries .option.unpaid').live('click', function (e) {
				e.preventDefault();

				// mark as paid
				var $this = $(this);
				var $entryToMark = $this.parent().parent();
				var $entryDetails = $entryToMark.find('.entry-details');
				var budgetId = parseInt($('#budgets .budget.active').attr('data-id'));
				var entryId = parseInt($entryToMark.attr('data-id'));

				$entryToMark.addClass('paid');
				$this.addClass('paid').removeClass('unpaid');
				$this.find('.icon-unpaid').removeClass('icon-unpaid').addClass('icon-paid');

				// mark as paid in db
				balance.webdb.markAsPaid(budgetId, entryId);

				// hide entry options
				$entryDetails.transition({
					x: '0'
				}, 200, function() {
					$entryToMark.removeClass('showing-options');
					showingOptions = false;
					calculateIncomeAndBalance();

					// show 'mark as paid' popup if not seen before
					if (!localStorage.seenMarkAsPaidPopup) {
					
						nativeAlert(
							'You just marked an item as Paid. Did you know you can toggle between overall Balance and Paid Balance by tapping once on your balance?', 
							null, 
							'Mark as Paid',
							'OK'
						);

						localStorage.seenMarkAsPaidPopup = true;
					}
				});

				
			});

			$('#entries .option.paid').live('click', function (e) {
				e.preventDefault();

				// mark as unpaid
				var $this = $(this);
				var $entryToMark = $this.parent().parent();
				var $entryDetails = $entryToMark.find('.entry-details');
				var budgetId = parseInt($('#budgets .budget.active').attr('data-id'));
				var entryId = parseInt($entryToMark.attr('data-id'));

				$entryToMark.removeClass('paid');
				$this.addClass('unpaid').removeClass('paid');
				$this.find('.icon-paid').removeClass('icon-paid').addClass('icon-unpaid');

				// mark as unpaid in db
				balance.webdb.markAsUnpaid(budgetId, entryId);

				// hide entry options
				$entryDetails.transition({
					x: '0'
				}, 200, function() {
					$entryToMark.removeClass('showing-options');
					showingOptions = false;
					calculateIncomeAndBalance();
				});

			});



					
		/*
			>> star or unstar entry
		*/		
			
			$('#entries .pin').live('click', function (e) {
				e.preventDefault();
				var $this = $(this);
				$entryToPin = $this.parent().parent();
				var $entryDetails = $entryToPin.find('.entry-details');
				
				$entryToPin.addClass('pinned');
				entryToPinId = $entryToPin.attr('data-id');
				balance.webdb.pinEntry(entryToPinId);
				$this.addClass('unpin').removeClass('pin');
				$this.find('.icon-star').removeClass('icon-star').addClass('icon-star-filled');
				$entryDetails.transition({
					x: '0'
				}, 200, function() {
					$entryToPin.removeClass('showing-options');
					showingOptions = false;
				});

			});
			
			$('#entries .unpin').live('click', function (e) {
				e.preventDefault();
				var $this = $(this);
				$entryToUnpin = $this.parent().parent();
				$entryToUnpin.removeClass('pinned');
				entryToUnpinId = $entryToUnpin.attr('data-id');
				currentlyViewedBudgetId = $('.budget.active').attr('data-id');
				balance.webdb.unpinEntry(entryToUnpinId, currentlyViewedBudgetId);
				$this.addClass('pin').removeClass('unpin');
				$this.find('.icon-star-filled').removeClass('icon-star-filled').addClass('icon-star');
				var $entryDetails = $entryToUnpin.find('.entry-details');
				$entryDetails.transition({
					x: '0'
				}, 200, function() {
					$entryToUnpin.removeClass('showing-options');
					showingOptions = false;
				});		
			});
			
			
		/*
			>> tap add budget
		*/
		
			$('#add-budget').on('click', function (e) {
				e.preventDefault();

				// hide any showing budget options
				if ($('#budgets .item.showing-options').length > 0) {
					$('#budgets .item.showing-options .budget-details').transition({
						x: '0'
					}, 100, function() {
						$('#budgets .item.showing-options').removeClass('showing-options');
						addNewBudgetMarkup();
					});
				}
				else {
					addNewBudgetMarkup();	
				}
				
				function addNewBudgetMarkup() {
				
					// add markup
					var budgetMarkup = '<div class="budget item clearfix clear" data-id="">';
					budgetMarkup +=			'<div class="budget-details item-details clearfix theme-border">';
					budgetMarkup +=				'<textarea class="budget-title item-title theme-color" rows="1" cols="20" placeholder="E.g. March" autocapitalize="on"></textarea>';
					budgetMarkup +=				'<p class="budget-title item-title fake hidden theme-color"></p>';
					budgetMarkup +=				'<i class="icon-arrow-right"></i> ';
					budgetMarkup +=			'</div>';
					budgetMarkup +=			'<div class="budget-options item-options theme-bg theme-border">';
					budgetMarkup +=				'<div class="delete option">'; 
					budgetMarkup +=					'<div class="icon">';
					budgetMarkup +=						'<i class="icon-bin"></i>';
					budgetMarkup +=						'<span>Delete</span>';
					budgetMarkup +=					'</div>';
					budgetMarkup +=				'</div>';
					budgetMarkup +=				'<div class="rename option">';
					budgetMarkup +=					'<div class="icon">';
					budgetMarkup +=						'<i class="icon-edit"></i>';
					budgetMarkup +=						'<span>Rename</span>';
					budgetMarkup +=					'</div>';
					budgetMarkup +=				'</div>';
					budgetMarkup +=				'<div class="export option disabled-on-free">';
					budgetMarkup +=					'<div class="icon">';
					budgetMarkup +=						'<i class="icon-export"></i>';
					budgetMarkup +=						'<span>Export</span>';
					budgetMarkup +=					'</div>';
					budgetMarkup +=				'</div>';					
					budgetMarkup +=			'</div>';
					budgetMarkup +=		'</div>';
					var $budgetMarkup = $(budgetMarkup);
					$budgetMarkup.appendTo('#budgets');
					
					// select textarea and setup autogrow
					textarea = $budgetMarkup.find('textarea.budget-title');
					textarea.select();

					// textarea.focus();
					initializeAutogrowTextarea(textarea);
					
					var orderNumber = parseInt($('#budgets .budget').length, 10) + 1;
					// add in database
					balance.webdb.addBudget(orderNumber, $budgetMarkup);

					// android - scroll down to bottom
					if (platform === 'Android') {
						setTimeout(function(){
							scrollToBottom();
						}, 400);
					}

				}
					
			});			
		
		/*
			>> tap delete budget
		*/
			
			$('#budgets .budget .delete').live('click', function (e) {
				e.preventDefault();
				$budgetToDelete = $(this).parent().parent();
				budgetId = $budgetToDelete.attr('data-id');
				// if we're near the bottom (but not at the top), scroll the user up a bit first
				var top = $('html').offset().top;
					
				if(nearBottom(42) && top !== 0 && platform === 'iOS') {
					$('html, body').animate({
						scrollTop: Math.abs(top + $budgetToDelete.height())
					}, 100, function() {
						deleteBudget();
					});
				}
				else {
					deleteBudget();	
				}
				
				function deleteBudget() {

					// confirm deletion
					nativeConfirm(
						'Are you sure you want to delete this Budget?',	// message
						confirmDelete,	                                // callback (with tapped button index as parameter)
						'Delete Budget?',	                            // title
						['Delete','Cancel'],	                        // button labels
						null,	                                        // fallback message 
						1,	                                            // fallback - ok pressed
						2	                                            // fallback - cancel pressed
					);

					// confirm deletion callback
					function confirmDelete(buttonIndex) {
						// delete pressed
						if (buttonIndex === 1) {
							setTimeout(function(){
								doDelete();
							}, 200);
						}
						// cancel pressed
						else {
							$budgetToDelete.find('.budget-details').transition({
								x: '0%'
							}, 200, function() {
								$budgetToDelete.removeClass('swipe-to-delete showing-options');
							});
						}
					}

					// do the delete
					function doDelete() {
						$budgetToDelete.transition({ 
							opacity: 0,
							x: '-100%'
						}, 200, function() {
							$budgetToDelete.animate({
								height: '0'
							}, 100, function() {
								$budgetToDelete.remove();
								// enable buttons
								balance.webdb.deleteBudget(budgetId);
							});
						});
					}
				}
			});			
			
			
		/*
			>> tap rename budget
		*/
		
			$('#budgets .budget .rename').live('click', function (e) {
				e.preventDefault();
				e.stopPropagation();
				var $this = $(this);
				$budgetToRename = $this.parent().parent();
				$budgetDetails = $budgetToRename.find('.budget-details');

				$textarea = $budgetToRename.find('textarea.budget-title');
				$fakeTextarea = $budgetToRename.find('p.budget-title').addClass('hidden');
				$textarea.removeClass('off-page').select();
				
				$budgetToRename.addClass('editing');
				$budgetDetails.css({x: 0});
				$budgetToRename.removeClass('showing-options');

				$houseAdIframe.addClass('hidden');

			});
			
			$('#budgets .budget:not(.editing) textarea.budget-title').live('touchstart', function (e) {
				e.preventDefault();
				$(this).blur();
			});
			
			$('#budgets .budget textarea.budget-title').live('blur', function (e) {
				var $this = $(this);
				var $budgetTitle = $this.val();
				$budget = $this.parent().parent();
				
				// remove focus class from budget
				$budget.removeClass('focus-all');
				
				// show pro upgrade banner
				$proUpgradeBanner.removeClass('off-bottom');
				
				// show title bar
		    	setTimeout(function(){
		    		if ($('#budgets-container .focus-left, #budgets-container .focus-right, #budgets-container .focus-all').length === 0) {
				    	// change position of title bar back to fixed
				    	$('#budgets-container .title-bar').removeClass('pos-absolute');
				    	$('#budgets').removeClass('padding-top-50');
				    }
		    	}, 100);

				$budget.removeClass('editing');
				$this.addClass('off-page');
				// update fake textarea
				$budget.find('p.budget-title').text($budgetTitle).removeClass('hidden');

				$houseAdIframe.removeClass('hidden');
			});
			
			$('#budgets .budget textarea.budget-title').live('focus', function (e) {
				var $this = $(this);
				$budget = $this.parent().parent();
				
				// add focus class to entry
				$this.parent().parent().addClass('focus-all');
				
				// hide pro upgrade banner
				$proUpgradeBanner.addClass('off-bottom');
				
				// change title bar position to absolute 
				$('#budgets-container .title-bar').addClass('pos-absolute');
				$('#budgets').addClass('padding-top-50');
				
				$budget.addClass('editing');

				$houseAdIframe.addClass('hidden');
			});


		/*
			>> tap export budget
		*/
		
			$('.export').live('click', function (e) {
				e.preventDefault();
				e.stopPropagation();
				var $this = $(this);
				if (freeVersion) {
					$('#export-popup').show().transition( {y: '0%'}, 300, function() {
						animating = false;
					});
				}
				else {
					// if tapped on the budgets page
					if ($this.hasClass('option')) {
						var budgetToExportId = $this.parents('.budget').attr('data-id');
					}
					// else if tapped on the entries page option menu
					else {
						var budgetToExportId = $('#budgets .budget.active').attr('data-id');

					}
					// export budget
					balance.webdb.getAllEntries(budgetToExportId, exportBudget);
				}
			});
		
			
		/*
			>> blur budget (update)
		*/
			
			$('#budgets .budget-title').live('blur', function (e) {
				e.preventDefault();
				var $this = $(this);
				var $budgetBlurred = $this.parent().parent();
				var title = $(this).val();
				var checkForBudgetId;
				var budgetId;

				$budgetBlurred.removeClass('editing');

				$houseAdIframe.removeClass('hidden');

				// if data-id attribute is empty (because we're still waiting for budget to be added to db - and attribute to be updated) then wait for a data-id attribute
				if ($budgetBlurred.attr('data-id') === '') {
					// console.log('NO FUCKING BUDGET ID!');
					var checkForBudgetIdCount = 0;
					checkForBudgetId = setInterval(function(){
						checkForBudgetIdCount++;
						if (checkForBudgetIdCount === 50) {
							clearInterval(checkForBudgetId);
						}
						else if ($budgetBlurred.attr('data-id') !== '') {
							clearInterval(checkForBudgetId);
							// console.log('BUDGET ID FUCKING ARRIVED, CONTINUE!');
							budgetId = $budgetBlurred.attr('data-id');
							finishUpdatingBudget();
						}
					}, 100);
				}
				else {
					budgetId = $budgetBlurred.attr('data-id');
					finishUpdatingBudget();
				}

				function finishUpdatingBudget() {
					// CHEAT - enable/disable pro version
					if (title === '+Pro') {
						enableProVersion();
					}
					if (title === '-Pro') {
						disableProVersion();
					}
					// update budget in database
					balance.webdb.editBudget(budgetId, title);

					// if android, refresh banner
					if (platform === 'Android') {
						refreshBanner();
					}
				}
			});
		

		/*
			>> toggle total income or expenses
		*/

			var $totalArrowBox = $('.total-income-expenses .arrow_box')

			var infoToggleSwitchEvent = (platform == 'Browser' ? 'click' : 'touchstart')

			// show expenses
			$('#total-income-container').on(infoToggleSwitchEvent, function (e) {
				showExpenses();
			});

			// show income
			$('#total-expenses-container').on(infoToggleSwitchEvent, function (e) {
				showIncome();
			});

			// load preference on session start
			if (localStorage.toggleIncomeExpenses == 'expenses') {
				showExpenses();
			}

			// click toggle arrow box prompt to hide it forever
			$totalArrowBox.click(function() {
				$totalArrowBox.remove();
				localStorage.seenTotalArrowBox = true;
			});

			// hide total arrow box prompt if already seen
			if (localStorage.seenTotalArrowBox) {
				$totalArrowBox.remove();
			}

			// fn: show expenses
			function showExpenses() {
				$('#total-income-container').addClass('hidden');
				$('#total-expenses-container').removeClass('hidden');
				localStorage.toggleIncomeExpenses = 'expenses';
				$totalArrowBox.trigger('click');
			}

			// fn: show income
			function showIncome() {
				$('#total-expenses-container').addClass('hidden');
				$('#total-income-container').removeClass('hidden');
				localStorage.toggleIncomeExpenses = 'income';
				$totalArrowBox.trigger('click');
			}


		/*
			>> toggle balance or paid
		*/

			var $balanceArrowBox = $('.balances .arrow_box')

			$('#remaining-balance-container').on(infoToggleSwitchEvent, function (e) {
				showPaid();
			});

			$('#remaining-paid-container').on(infoToggleSwitchEvent, function (e) {
				showBalance();
			});

			// load preference on session start
			if (localStorage.toggleBalancePaid == 'paid') {
				showPaid();
			}

			// click toggle arrow box prompt to hide it forever
			$balanceArrowBox.click(function() {
				$balanceArrowBox.remove();
				localStorage.seenBalanceArrowBox = true;
			});

			// hide total arrow box prompt if already seen
			if (localStorage.seenBalanceArrowBox) {
				$balanceArrowBox.remove();
			}

			// fn: show paid
			function showPaid() {
				$('#remaining-balance-container').addClass('hidden');
				$('#remaining-paid-container').removeClass('hidden');
				localStorage.toggleBalancePaid = 'paid';
				$balanceArrowBox.trigger('click');
			}

			// fn: show balance
			function showBalance() {
				$('#remaining-paid-container').addClass('hidden');
				$('#remaining-balance-container').removeClass('hidden');
				localStorage.toggleBalancePaid = 'balance';
				$balanceArrowBox.trigger('click');
			}


		/*
			>> disable unwanted key presses
		*/
		
			/* make enter key on budget title and entry title blur the field */
			$('#budgets textarea.budget-title, #entries textarea.entry-title').live('keydown', function (e){
				var $this = $(this);

				// if enter pressed, blur field
				if (e.keyCode === 13) {
					document.activeElement.blur();
					$this.blur();
				}
			});
			
			/* 
				[1] disable all except numbers, decimal point, backspace, and delete on number fields
			   	[2] disable 2nd decimal points 
			*/
			
				$('#entries input.amount').live('keypress', function (e){
					var inputValue = $(this).val();
					
					var keyPressed = String.fromCharCode( e.which );
					var allowedKeyPresses = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.'];
					
					// if enter pressed, blur field
					if (e.keyCode === 13) {
						document.activeElement.blur();
						$this.blur();
					}

					// if a disallowed key was pressed, return false
					if ($.inArray( keyPressed, allowedKeyPresses ) === -1) {
						e.preventDefault();
					}
					// else, if '.' was pressed, return false if there is already a '.' in the field
					else {
						if ((keyPressed === '.' && inputValue.indexOf(keyPressed) >= 0) || keyPressed === '.' && inputValue === '') {
							e.preventDefault();
						}
					}
				});			

		/*
			>> tutorial
		*/
		
			/*
				>>> show or hide tutorial
			*/
				
				// show tutorial
				$('#show-tutorial').on('click', function (e) {
					e.preventDefault();
					// if nothing is animating
					if (animating === false) {
						animating = true;
						$('#tutorial').show().transition( {y: '0%'}, 300, function() {
							var lastPage = localStorage.getItem('lastPage');
							if (lastPage === 'budgets') {
								$('#budgets-container').addClass('hidden');
							}
							else if (lastPage === 'entries') {
								$('#entries-container').addClass('hidden');
							}
							animating = false;
						});
						stopTutorialAnimation[currentNav] = false;
						tutorialAnimation(currentNav);
						carousel.init();
					}
					
				});
				
				// hide tutorial
				$('#tutorial-close').on('click', function (e) {
					e.preventDefault();
					// unlock scrolling (show entries / budgets)
					var lastPage = localStorage.getItem('lastPage');
					if (lastPage === 'budgets') {
						$('#budgets-container').removeClass('hidden');
					}
					else if (lastPage === 'entries') {
						$('#entries-container').removeClass('hidden');
					}
					$('#tutorial').transition( {y: '100%'}, 300, function() {
						$(this).hide();
					});
					stopTutorialAnimation[currentNav] = true;
					tutorialAnimation(currentNav, 'reset');
					localStorage.firstRunTutorialDisplayed = true;
				});
				
				
		/*
			>> popups
		*/
		
				
			/*
				>>> pro upgrade popup
			*/
			
				// show pro upgrade popup
				$('.show-pro-upgrade-popup').on('click', function (e) {
					e.preventDefault();
					// ga - track event
					if ($(this).hasClass('pro-upgrade-banner')) {
						gaTrackEvent('Pro Upgrade Banner', 'Pro Upgrade Banner > Tapped Pro Upgrade Banner', null);
					}
					else {
						gaTrackEvent('Settings', 'Settings > Fudget Pro Upgrade', null);
					}
					if (freeVersion) {
						// if nothing is animating
						if (animating === false) {
							animating = true;
							// hide any pro upgrade feature popups
							$('.pro-upgrade-feature-popup').transition({y: '100%'}, 300, function() {
								$(this).hide();
							});
							// show pro upgrade popup
							$('#pro-upgrade-popup').show().transition( {y: '0%'}, 300, function() {
								animating = false;
							});
						} 
					}
					else {
						showAlreadyUpgradedPopup();
					}
				});
		 
		 		// close pro upgrade popup
		 		$('#pro-upgrade-popup .popup-close').click(function (e) {
		 			e.preventDefault();
			 		$('#pro-upgrade-popup').transition( {y: '100%'}, 200, function() {
			 			$(this).hide();
			 		});
		 		});

		 		// mark as paid popup
		 		$('.show-dropbox-save-and-restore-popup').click(function (e) {
		 			e.preventDefault();
		 			$('#dropbox-save-and-restore-popup').show().transition( {y: '0%'}, 300, function() {
		 				animating = false;
		 			});
		 		});
		 		
		 		// no-ads-themes popup
		 		$('.show-no-ads-themes-popup').click(function (e) {
		 			e.preventDefault();
		 			$('#no-ads-themes-popup').show().transition( {y: '0%'}, 300, function() {
		 				animating = false;
		 			});
		 		});
		 		
		 		// calculator popup
		 		$('.show-calculator-popup').click(function (e) {
		 			e.preventDefault();
		 			$('#calculator-popup').show().transition( {y: '0%'}, 300, function() {
		 				animating = false;
		 			});
		 		});
		 		
		 		// export popup
		 		$('.show-export-popup').click(function (e) {
		 			e.preventDefault();
		 			$('#export-popup').show().transition( {y: '0%'}, 300, function() {
		 				animating = false;
		 			});
		 		});

		 		// close pro upgrade feature popup
		 		$('.pro-upgrade-feature-popup .popup-close').click(function (e) {
		 			$(this).parent().transition({y: '100%'}, 300, function() {
		 				$(this).hide();
		 			});
		 		});

 				// upgrade popup - click try pro
 				$('.try-pro').click(function (e) {
 		       		if (!$(this).hasClass('disabled')) {

 		       			// variables
 		       			var message = 'Check out this app Fudget I\'ve been using to manage my money!';
 		       			var subject = 'Fudget for iOS and Android. ';
 		       			var imageUrl = 'http://fudget.dconnell.co.uk/assets/images/fudget-action-shot.png';

 		       			gaTrackEvent('Upgrade Popup', 'Upgrade Popup > Try Pro', null);

 		       			// confirm share to start pro trial
 		       			nativeConfirm(
 		       				'To unlock Fudget Pro for 14 days, simply share this app on Facebook or Twitter',	// message
 		       				tryProConfirmCallback,					                                            // callback
 		       				'Try Fudget Pro!',						                                            // title
 		       				['Share on Facebook', 'Share on Twitter', 'Close'],							        // button labels
 		       				null,									                                            // fallback message
 		       				4										                                            // fallback - ok pressed
 		       			);

 		       			// confirm share callback
 		       			function tryProConfirmCallback(buttonIndex) {
		       		     	// Share on Facebook & try pro pressed
		       		     	if (buttonIndex == 1) {
		       		     		// share on facebook
					     		window.plugins.socialsharing.shareViaFacebook(
					     			'Fudget - fast, simple money management',
					     			null,
					     			appWebsiteUrl, // url
					     			function() {
					     				startProTrial();
					     				gaTrackEvent('Upgrade Popup', 'Upgrade Popup > Try Pro > Shared on Facebook and Tried Pro', null);
					     			}, function(errormsg){
					     			},
					     			null
					     		);	
		       		     	}
		       		     	// Share on Twitter & try pro pressed
		       		     	if (buttonIndex == 2) {
					     		// share on twitter
						     	window.plugins.socialsharing.shareViaTwitter(
						     		message + ' ' + appWebsiteUrl, 
						     		imageUrl /* img */, 
						     		null,
						     		function() {
						     			startProTrial();
					     				gaTrackEvent('Upgrade Popup', 'Upgrade Popup > Try Pro > Shared on Twitter and Tried Pro', null);
						     		}, 
						     		function(errormsg){
						     		},
						     		null
						     	);
		       		     	}
		       		     	// browser fallback
		       		     	if (buttonIndex === 4) {
		       		     		startProTrial();
		       		     	}
	       		     		function startProTrial() {
		       		     		// unlock pro version
		       		     		enableProVersion();
		       		     		// add pro trial expiry date to localStorage
		       		     		var currentDate = new Date().getTime();
		       		     		// add 14 days to expiry date    
		       		     		proTrialExpiryDate = currentDate + (14*24*60*60*1000); // temp - add 14 days (in milliseconds)
		       		     		// proTrialExpiryDate = currentDate + (60*2000); // temp - add 1 minute (in milliseconds)
		       		     		// add expiry date to localStorage
		       		     		localStorage['proTrialExpiryDate'] = proTrialExpiryDate;

		       		     		// alert user that they are now on pro version
								nativeAlert(
									'Thanks for the share! You have 14 days to try Fudget Pro!',
									null,
									'Thanks!',
									'OK'
								);
	       		     		}
 		       			}


 		       		}				
 				});
		 		

		/*
			>> in-app purchases
		*/

			var iapId = 'fudget.pro.upgrade',
			// var iapId = 'android.test.purchased',
				iapAlias = 'Fudget Pro Upgrade',
				anyBuyButtonPressed = false;

			// real in-app purchases
			if (isNative && !demoMode) {

				function initializeStore() {

					// if there's an internet connection
					if(navigator.network.connection.type !== Connection.NONE){

						var userTappedRestore = false;

						if (!window.store) {
						    /// log('Store not available');
						    return;
						}
						else {
							/// log('Store avaiable');
						}

					    // Let's set a pretty high verbosity level, so that we see a lot of stuff
					    // in the console (reassuring us that something is happening).
					    store.verbosity = store.INFO;

					    // register pro upgrade iap
					    store.register({
					        id:    iapId,
					        alias: iapAlias,
					        type:  store.NON_CONSUMABLE
					    });

					    // When any product gets updated, refresh the HTML.
					    store.when("product").updated(function (p) {
					        /// log('refresh IAPs');
					    });

					    // when fudget.pro.upgrade is updated, add price to button
					    // product attributes - product.owned, loaded, valid, alias, title, description, id, price
					    store.when(iapId).updated(function (product) {
					    	/// log(product.price);
					    	$('.pro-upgrade-price').text(product.price);
					    });

					    // when purchase of fudget.pro.upgrade is approved, enable pro version
					    store.when(iapId).approved(function (order) {
					        // finish order
					        order.finish();
					        /// log('approved');
					    });

					    // finished transaction of fudget.pro.upgrade
					    store.when(iapId).finished(function (order) {
					    	// thank the user if they've not already upgraded
					    	if (!localStorage['IAPfudgetProUpgrade']) {
					    		// if user is restoring purchases, show generic message
					    		if (userTappedRestore) {
					    			nativeAlert(
					    				'Thanks! Your purchases have been restored!',
					    				null,
					    				'Thanks'
					    			);
					    		}
					    		// else show specific message
					    		else {
					    			showAlreadyUpgradedPopup();
					    		}
					    	}
					    	// enable pro version
					    	enableProVersion();
					    	// GA - track event
					    	gaTrackEvent('Get Pro Upgrade', 'Get Pro Upgrade > Purchase successful', null)
					    });


					    // report all errors
					    store.error(function(error) {

					    	// only show error message and log error if any buy button was pressed

					    	if (anyBuyButtonPressed) {
						        nativeAlert(error.message, null, 'Error');
						        // GA - track event
						        gaTrackEvent('Get Pro Upgrade', 'Get Pro Upgrade > Error > ' + error.message, null)
					    	}

					    });

					    // When every goes as expected, it's time to celebrate!
					    // The "ready" event should be welcomed with music and fireworks,
					    // go ask your boss about it! (just in case)
					    store.ready(function() {
					       	/// log("\\o/ STORE READY \\o/");

					       	// enable store related buttons
					       	$('.get-pro-upgrade, .restore-purchases').removeClass('disabled').unbind('click');

					       	// click purchase upgrade button
					       	$('.get-pro-upgrade').click(function (e) {
					       		// GA - track event
					       		gaTrackEvent('Get Pro Upgrade', 'Get Pro Upgrade > Get Pro Upgrade Button tapped', null)

					       		anyBuyButtonPressed = true;
					       		var $purchaseUpgradeButton = $(this);
					       		e.preventDefault();
					       		
					       		if (!$purchaseUpgradeButton.hasClass('disabled')) {
					       			// order fudget.pro.upgrade IAP
					       			/// log('order');
						       		store.order(iapId);
						       		// store.refresh();
					       		}
					       		else {
					       			store.refresh();
					       		}
					       	});

					       	// enable restore purchases button
					       	$('.restore-purchases').click(function (e) {
					       		anyBuyButtonPressed = true;
					       		var $restorePurchasesButton = $(this);
					       		e.preventDefault();
					       		if (!$restorePurchasesButton.hasClass('disabled')) {
					       			userTappedRestore = true;
					       			store.refresh();
					       			if (platform === 'Android') {
					       				store.order(iapId);
					       			}
					       		}
					       		else {
					       			store.refresh();
					       		}
					       	});


					    });

					    // After we've done our setup, we tell the store to do
					    // it's first refresh. Nothing will happen if we do not call store.refresh()
					    store.refresh();

					}

				}

				initializeStore();

				// if upgrade or restore buttons are disabled and clicked, prompt the user to check their internet connection
				$('.get-pro-upgrade, .restore-purchases').bind('click', function (e) {
					if ($(this).hasClass('disabled')) {
						nativeAlert(
							'Sorry, could not connect to the Store. Please check your internet connection and try again.',
							null,
							'Can\'t connect to store'
						);
						initializeStore();
					}
				});

			}
			// dummy in-app purchases for web app / demo mode
			else{
		       	// click purchase upgrade button
		       	$('.get-pro-upgrade').click(function (e) {
		       		e.preventDefault();

	       			nativeConfirm(
	       				'Do you want to buy one Fudget Upgrade for £2.99?',	// message
	       				getProUpgradeCallback,					            // callback
	       				'Confirm Your In-App Purchase',						// title
	       				['Cancel', 'Buy'],							        // button labels
	       				null,									            // fallback message
	       				2										            // fallback - ok pressed
	       			);

	       			function getProUpgradeCallback(buttonIndex) {
	       		     	// buy pressed
	       		     	if (buttonIndex === 2) {
	       		     		enableProVersion();
	       		     		showAlreadyUpgradedPopup();
	       		     	}
	       			}

		       	});
			}
			


		/* 
			>> tap title bar - scroll to top
		*/

			$('#budgets-container>.title-bar, #entries-container>.title-bar, #settings-container>.title-bar').click(function (e) {
				$('html, body').animate({
					scrollTop: 0
				}, 100);
			});


		/*
			>> show options menu
		*/

			$('.show-menu').click(function (e) {
				e.preventDefault();
				e.stopPropagation();
				if (!$('.menu').hasClass('show')) {
					$('.menu').removeClass('hidden');
					setTimeout(function(){
						$('.menu').addClass('show');
					}, 100);
					// update text
					$('.show-menu small').text('Close');
				}
				else {
					$('.menu').removeClass('show');
					setTimeout(function(){
						$('.menu').addClass('hidden');
					}, 300);
					// update text
					$('.show-menu small').text('Options');
				}
			});

			// click out
			$('body').click(function (e) {
				if ($('.menu').hasClass('show')) {
					$('.menu').removeClass('show').addClass('hidden');
					// update text
					$('.show-menu small').text('Options');
				}
			});


		/*
			>> join newsletter
		*/

			$('.join-newsletter-form').submit(function (e) {

				e.preventDefault();

				// get fields
				var name = $('.newsletter-name').val();
				var email = $('.newsletter-email').val();
				var list;
				var url = 'http://sendy.dconnell.co.uk/subscribe';
				var errorMessage = 'Couldn\'t connect. Please check your internet connection and try again.';
				if (platform === 'Android') {
					// list = 'C1I8Oe0kT5TJLkiS7UhCSA'; // Test list
					list = '2eR84aJ17634qaF6ScKH1NpQ'; // Android list
				}
				else {
					// list = 'C1I8Oe0kT5TJLkiS7UhCSA'; // Test list
					list = 'NfLWde5AFpQSRj3x892plRsQ'; // iOS list
				}
				var data = { name: name, email: email, list: list  };

				// send request
				$.ajax({
					type: "POST",
					url: url,
					data: data,
					success: function(data){
						console.log('data: ', data);
				  		var message = $(data).find('h2').text();
				  		console.log('message: ' + message);
				  		if (message === "You're subscribed!" || data === "") {
				  			message = "You're subscribed!";
				  			var alertHeading = 'Thanks!';
				  			// clear form
				  			$('.join-newsletter-form input').val('').blur();
				  		}
				  		else {
				  			var alertHeading = 'Sorry!';
				  		}
				  		// GA - track feedback - prompt - show prompt
						gaTrackEvent('Newsletter', 'Newsletter (' + platform + ') > ' + message, null);
						// inform the user of the result
				  		nativeAlert(
				  			message,
				  			null,
				  			alertHeading
				  		);
					},
					error: function(XMLHttpRequest, textStatus, errorThrown) {
			  	  		// GA - track feedback - prompt - show prompt
			  			gaTrackEvent('Newsletter', 'Newsletter (' + platform + ') > Error', null);

						// inform the user of the result
				  		nativeAlert(
				  			errorMessage,
				  			null,
				  			'Sorry!'
				  		);
					}
				});

			});


		/*
			>> charts
		*/

			var chart;
			var total;

			$('.show-charts-popup').click(function (e) {
				e.preventDefault();
				$('#charts-popup').show().transition( {y: '0%'}, 300, function() {
					animating = false;

					// get the raw data
					var rawData = [];
					$('#entries .entry.expense').each(function(index) {
						var $this = $(this);
						var thisLabel = $this.find('textarea.entry-title').val();
						var thisValue = $this.find('input.amount').val();
						// newly created entries have no amount value, so set these to 0 to avoid NaN bugs later
						if (thisValue === '') {
							thisValue = 0;
						}
						thisValue = parseFloat(thisValue);
 					    rawData.push({
							label: thisLabel,
							value: thisValue
					    });
					});

					// generate some nice colors
					var colors = randomColor({count: rawData.length + 1});

					// generate the chart from raw data
					generateChart(rawData, 'pie');

					// function to generate the chart
					function generateChart(rawData, chartType) {
						// sort the data ascending by value
						rawData.sort(ascending);

						// loop through raw data and create data array for chart
						var data = [];
						$.each( rawData, function(i) {
							var trimmedLabel = this.label;
							if (trimmedLabel.length > 20) {
								trimmedLabel = trimmedLabel.substring(0,20) + '..';
							}
							data.push({
								value: this.value,
								color: colors[i],
								label: trimmedLabel
							});
						});
						
						// get the total value of all items
						total = 0;
						$.each( data, function() {
							total = total + this.value
						});

						// close the popup if total is 0 and warn user
						if (total === 0) {
							nativeAlert(
								'Please enter a value for at least one expense.',
								function() {
									$('.charts-popup .popup-close').trigger('click');
								},
								'Error!'
							);
						}
						
						// get the cut off point in percent (below which items will be grouped into 'other')
						var cutOff = total * 0.03; // 3 percent
						
						// look at each item value starting with the lowest, find out which index is the cut off
						var runningTotal = 0;
						var cutOffIndex;
						$.each( data, function(index) {
							runningTotal = runningTotal + this.value;
							// console.log(index + ': ' + runningTotal);
							if (runningTotal > cutOff) {
								cutOffIndex = index - 1;
								return false;
							}
						});

						// if there's more than 1 item to bundle into 'other'
						if (cutOffIndex > 0) {
							// calculate the 'other' total
							var otherTotal = 0;
							for (i = 0; i <= cutOffIndex; i++) {
								otherTotal += data[i].value;
							}
							
							// remove the cut-off items from the array
							data.splice(0, cutOffIndex + 1);
						}
					 
						// sort data descending before rendering
						data.sort(descending);
						
						// insert the 'other' item
						if (cutOffIndex > 0) {
							data.push({
								value: otherTotal,
								color: colors[colors.length - 1],
								label: 'Other'
							});
						}
						
						// chart options
						if (platform === 'Android') {
							var chartAnimation = false;
						}
						else {
							var chartAnimation = true;
						}
						var options = {
								segmentShowStroke: false,
								animateRotate: chartAnimation,
								animateScale: false,
								animation: chartAnimation,
								//percentageInnerCutout: 50,
								tooltipTemplate: function(v) {
										return v.label + ' - ' + currencySymbol + v.value.toFixed(2)},
								legendTemplate : "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<segments.length; i++){%><li><span class=\"color\" style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%> - <%=currencySymbol%><%=segments[i].value.toFixed(2)%> - <strong><%=((segments[i].value/total)*100).toFixed(2)%>%</strong><span class=\"remove-data-item touchable\" data-index='<%=i%>'>&times;</span></li><%}%></ul>"
						}

						var ctx = document.getElementById("chart").getContext("2d");
						
						if (chartType === 'pie') {
							// generate chart
							chart = new Chart(ctx).Pie(data, options);
							
							// generate legend
							document.getElementById('js-legend').innerHTML = chart.generateLegend();
						}

						// remove a data item on X click
						$('#js-legend').on('click', '.remove-data-item', function (e) {
							index = $(this).data('index');
							chart.removeData(index);
							if (platform === 'Android') {
								chart.render();
							}
							document.getElementById('js-legend').innerHTML = chart.generateLegend();	
						});
						
					}

					/* functions */

					function getRandomColor() {
							var letters = '0123456789ABCDEF'.split('');
							var color = '#';
							for (var i = 0; i < 6; i++ ) {
									color += letters[Math.floor(Math.random() * 16)];
							}
							return color;
					}

					function descending(a,b) {
						if (a.value > b.value)
							return -1;
						else if (a.value < b.value)
							return 1;
						else 
							return 0;
					}

					function ascending(a,b) {
						if (a.value < b.value)
							return -1;
						else if (a.value > b.value)
							return 1;
						else 
							return 0;
					}					

				});
			});

			// close charts popup
			$('.charts-popup .popup-close').click(function (e) {
				$(this).parent().transition({y: '100%'}, 300, function() {
					$(this).hide();
					// destroy chart
					chart.destroy();
					// clear legend
					$('#js-legend').html('');
					// clear 'remove' click events
					$('#js-legend').off('click', '.remove-data-item');
				});
			});


		/*
			>> toggle entry date column
		*/

			// variables
			var $dateColumnToggle = $('.date-column-toggle');

			// show date column on load (if enabled)
			if (localStorage.showDateColumn === 'true') {
				showDateColumn();
			}

			// toggle on settings page
			$('#show-date-column').change(function (e) {
				// show date column
				if ($(this).is(':checked')) {
					showDateColumn();
				}
				// hide date column
				else {
					hideDateColumn();
				}
			});

			// toggle on menu
			$dateColumnToggle.click(function (e) {
				e.preventDefault();
				var $this = $(this);
				// show date column
				if (!$this.hasClass('on')) {
					showDateColumn();
				}
				// hide date column
				else {
					hideDateColumn();
				}
			});

			// show date column
			function showDateColumn() {
				$dateColumnToggle.addClass('on');
				$('#show-date-column').attr('checked', 'checked');
				$('#entries').addClass('show-date-column');
				localStorage.showDateColumn = true;
			}

			// hide date column
			function hideDateColumn() {
				$dateColumnToggle.removeClass('on');
				$('#show-date-column').removeAttr('checked');
				$('#entries').removeClass('show-date-column');
				localStorage.showDateColumn = false;
			}


		/*
			>> tap show review icon
		*/

			$('.show-feedback-module').click(function (e) {
				e.preventDefault();
				e.stopPropagation();
				// GA - track feedback - title bar - tapped review icon
				gaTrackEvent('Title bar', 'Title bar > Tapped Review icon', null);
				promptForFeedback();
			});


		/*
			>> android back button
		*/

			document.addEventListener("backbutton", function() {
				// if chart showing, close it
				if ($('#charts-popup').is(":visible")) {
					$('.charts-popup .popup-close').trigger('click');
				}
				// if calculator showing, close it
				else if ($('.calculator-container').is(":visible")) {
					$('.calculator-container .close-calculator').trigger('click');
				}
				// if on entries page...
				else if (localStorage.lastPage === 'entries') {
					// if there's a history, go to budgets page
					if (hasHistory) {
						showBudgetsList();
					}
					// otherwise, user never left this page, quit app
					else {
						navigator.app.exitApp();
					}
				}
				// if on budgets page, quit
				else if (localStorage.lastPage === 'budgets') {
					navigator.app.exitApp();
				}
				// if on settings page, go back to budgets
				else if (localStorage.lastPage === 'settings') {
					$('#settings-container').trigger('swipeleft');
				}
			}, false);


		/*
			>> dropbox save & restore setup
		*/

			var $dropboxSaveAndRestore = $('#dropbox-save-and-restore');

			// setup switch on load
			if (localStorage.getItem('dropboxSaveAndRestore') === 'true') {
				$dropboxSaveAndRestore.attr('checked', 'checked');
				// show dropbox options
				$('.dropbox-options').removeClass('hidden');
			}

			// user changes dropbox save & restore switch
			$dropboxSaveAndRestore.change(function (e) {

				e.preventDefault();
				var $this = $(this);

				// switch is on
				if ($this.is(':checked')) {

					// if free version, show popup
					if (freeVersion) {

						animating = true;
						$('#dropbox-save-and-restore-popup').show().transition( {y: '0%'}, 300, function() {
							animating = false;
							// disable Dropbox Save & Restore option
							$dropboxSaveAndRestore.removeAttr('checked');
						});

					}
					// otherwise enable/start authentication
					else {

						// if user has already authenticated with dropbox, switch on dropbox save & restore
						if (localStorage.access_token && localStorage.access_token !== '') {
							console.log('user has already authenticated');
							// turn on dropbox save & restore
							localStorage.dropboxSaveAndRestore = true;
		                    // show dropbox options
		                    $('.dropbox-options').removeClass('hidden');
		                    // check for new data
		                    balance.webdb.checkIfDropboxDataNewer();
						}
						// otherwise, authenticate dropbox
						else {
							authenticateDropbox();
						}
						
					}

				}
				// switch is off
				else {
					// turn off dropbox save & restore
					localStorage.dropboxSaveAndRestore = false;
					// hide dropbox options
					$('.dropbox-options').addClass('hidden');
				}
			});

			// fn: authenticate dropbox
			function authenticateDropbox() {
				var access_token;

				// url of my dropbox redirect page (dropbox will send users to this after authentication)
				var dropboxRedirectUrl = 'https://dropbox.dconnell.co.uk';

				// open dropbox authentication page
				var win = window.open( 'https://www.dropbox.com/1/oauth2/authorize?client_id=ub85ketkmpwfzck&response_type=token&disable_signup=true&redirect_uri=' + dropboxRedirectUrl, '_blank', 'location=no,toolbar=yes');

				// Once the InAppBrowser finishes loading
				win.addEventListener( "loadstop", function() {

				    // Clear out the access_token in localStorage for subsequent opens.
				    win.executeScript({ code: "localStorage.setItem( 'access_token', '' );" });

				    // Start an interval
				    var loop = setInterval(function() {

				        // Execute JavaScript to check for the existence of an access_token in the
				        // child browser's localStorage.
				        win.executeScript(
				            {
				                code: "localStorage.getItem( 'access_token' )"
				            },
				            function( values ) {
				                access_token = values[ 0 ];

				                // If a access_token was set, clear the interval and close the InAppBrowser.
				                if ( access_token ) {
				                    clearInterval( loop );
				                    win.close();

				                    localStorage.access_token = access_token;
				                    localStorage.dropboxSaveAndRestore = true;

				                    // show dropbox options
				                    $('.dropbox-options').removeClass('hidden');

				                    // confirm dropbox save and restore active
				                    setTimeout(function(){
					                    confirmDropboxActive();
				                    }, 1000);

				                }
				            }
				        );
				    }, 1500);
				});

				// if there's an error with the InAppBrowser loading the url
				win.addEventListener( 'loaderror', function() {
					win.close();
			  		nativeAlert(
			  			'Please check your internet connection and try again.',
			  			function() {
			  				// disable Dropbox Save & Restore option
					  		$dropboxSaveAndRestore.removeAttr('checked');
			  			},
			  			'Could not connect to Dropbox!'
			  		);
				});

				// InAppBrowser is closed by user
				win.addEventListener( 'exit', function() {
					if (!localStorage.access_token) {
				  		nativeAlert(
				  			'Could not link to Dropbox because the popup was closed. Please try enabling Dropbox again.',
				  			function() {
				  				// disable Dropbox Save & Restore option
						  		$dropboxSaveAndRestore.removeAttr('checked');
				  			},
				  			'Notice'
				  		);
					}
				});

			}

			// confirm dropbox active
			function confirmDropboxActive() {

				nativeAlert(
					'You can now save your data to Dropbox at any time by tapping "Save data to Dropbox" here on the Settings page, or from the "Options" menu when viewing your budgets.',
		    		function() {
		    			// check for existing data
				  		balance.webdb.checkForData();
		    		},
					'Dropbox Save & Restore active!'
				);

			}

		/*
			>> check data on dropbox
		*/

			/*$('#setting-check-database').click(function (e) {
				balance.webdb.checkForData();
			});*/

		/*
			>> dropbox save database
		*/

			$('.save-data-to-dropbox').click(function (e) {
				e.preventDefault();
				console.log('Clicked Save data to Dropbox');
				balance.webdb.saveDatabase();
			});

		/*
			>> dropbox restore database
		*/

			var restoreClickEvents = (platform == 'Browser' ? ['mousedown', 'mouseup'] : ['touchstart', 'touchend'])

			// restore previous revision (click and hold)
			$('.restore-data-from-dropbox').on(restoreClickEvents[0], function() {
			    restorePreviousRevision = setTimeout(function() {
			    	gettingRevisions = true;
			    	balance.webdb.getRevisions();
			    }, 2000);
			}).bind(restoreClickEvents[1], function() {
			    clearTimeout(restorePreviousRevision);
			});

			// normal restore
			$('.restore-data-from-dropbox').click(function (e) {
				e.preventDefault();
				if (!gettingRevisions) {
					console.log('Clicked Restore data from Dropbox');
					balance.webdb.restoreDatabase(balance.webdb.getAllBudgets);
				}
			});

			// choose revision to restore
			$('#choose-revision').change(function (e) {
				var $this = $(this);
				var label = $('#choose-revision').children(':selected').text();
				var rev = $this.val();
				if ($this.val() !== '') {

					// restore revision confirm
					nativeConfirm(
						'Restore revision "' + label + '"?',	// message
						restoreRevisionCallback,				// callback
						'Restore revision?',					// title
						['No', 'Yes'],							// button labels
						null,									// fallback
						2,										// fallback - ok pressed
						1										// fallback - cancel pressed
					);

					// restore revision confirm callback
					function restoreRevisionCallback(buttonIndex) {
						if (buttonIndex === 2) {
							balance.webdb.restoreRevision(rev);
						}
						else {
							$('#choose-revision').val('');
						}
					}
				}
			});

		/*
			>> persistent storage - restore
		*/

			$('.restore-data-from-persistent-storage').click(function (e) {

				persistent.restoreDatabase(balance.webdb.getAllBudgets);

			});


		/*
			>> persistent storage - stop asking
		*/

			$('.my-data-is-fine').click(function (e) {

				persistent.stopAsking();

			});


		/*
			>> persistent storage - save
		*/

			$('.save-data-to-persistent-storage').click(function (e) {

				persistent.saveDatabase();

			});


		/*
			>> persistent storage - check if database deleted by ios
		*/

			$('.check-if-database-deleted-by-ios').click(function (e) {

				persistent.checkIfDatabaseDeletedByIOS(balance.webdb.getAllBudgets);

			});

	}


/* -----------------------------------------------------------------------------------
	> onAppPaused
--------------------------------------------------------------------------------------- */

	function onAppPaused() {
		// if there's a pin code, log user out and prompt for pin code when they come back
		if (localStorage.pinCode !== undefined && localStorage.pinCode.length > 0) {
			doLogin();
		}
	}


/* -----------------------------------------------------------------------------------
	> onAppResumed
--------------------------------------------------------------------------------------- */

	function onAppResumed() {
		
	}


/*
	functions.js
*/

/*
* CONTENTS
*
*    log recordset as a table!
*    calculate income and balance
*    initialize autogrow textarea
*    currencify	
*    scroll and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
*    scroll to bottom and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
*    scroll to bottom
*    near bottom - check if we're near the bottom of the page
*    load all budgets
*      choose which page to show first
*    load all entries
*    export budget
*    add id to budget markup	
*    add id to entry markup
*    update count of entries made - show 'rate this app' every 50 entries & 'rate this app' button after first 50
*    do login
*    log
*    show pro upgrade banner
*    hide pro upgrade banner
*    enable pro version
*    disable pro version
*    show already upgraded popup
*    show & hide review icon
*    prompt for feedback, review, email
*    admob or house ads
*    check pro trial expired
*    show & hide loading screen
*    ga - track view (page)
*    ga - track event
*    show new version popup
*    show notification
*    native alert
*    native confirm
*    native prompt
*    date to unix timestamp
*    unix timestamp to date
*    unix timestamp to nice date
*    zero padding
*    get android version
*    enable emergency mode
*    disable emergency mode
*/

	/*
		>> log recordset as a table!
	*/
	
		function logTable(recordSetRows) {
			var tableString;
			for (var i=0; i < recordSetRows.length; i++) {
				tableString += JSON.stringify(recordSetRows.item(i)) + ', ';
			}
			tableString = tableString.replace('undefined','');
			tableString = tableString.substring(0, tableString.length - 2);
			eval('console.table([' + tableString + '])');
		}


	/*
		>> calculate income and balance
	*/

		function calculateIncomeAndBalance() {
			var totalIncome = 0;
			var totalExpense = 0;
			var totalPaidIncome = 0;
			var totalPaidExpense = 0;

			var incomeValue = 0;
			var expenseValue = 0;
			
			var remainingBalance = 0;
			var remainingPaid = 0;
			
			/* income, expenses and balance */

				// grab income from each income text box and work out total
				$('#entries .income input.amount').each(function(index) {
					incomeValue = parseFloat(this.value, 10);
					if (isNaN(incomeValue)) {
						incomeValue = 0;
					}
					totalIncome += incomeValue;
				});
				
				// round total income to 2 decimal places
				totalIncome = totalIncome.toFixed(2);
				
				// grab expense from each expense text box and work out total
				$('#entries .expense input.amount').each(function(index) {
					expenseValue = parseFloat(this.value, 10);
					if (isNaN(expenseValue)) {
						expenseValue = 0;
					}
					totalExpense -= expenseValue;
				});	
				
				// round total expense to 2 decimal places
				totalExpense = totalExpense.toFixed(2);
				
				// work out remaining balance
				remainingBalance = parseFloat(totalIncome) + parseFloat(totalExpense);
				
				// round remaining balance to 2 decimal places
				remainingBalance = remainingBalance.toFixed(2);
			
				// update total income
				$('#total-income').attr('data-value', totalIncome);
				fakeTotalIncome = currencify(totalIncome);
				$('#total-income').html(fakeTotalIncome);

				// update total expenses
				$('#total-expenses').attr('data-value', totalExpense);
				fakeTotalExpense = currencify(totalExpense);
				$('#total-expenses').html(fakeTotalExpense);		
				
				// update remaining balance
				var fakeRemainingBalance = '';
				if (remainingBalance < 0) {
					fakeRemainingBalance = '- ';
				}
				
				$('#remaining-balance').attr('data-value', remainingBalance);
				absoluteRemainingBalance = Math.abs(remainingBalance); // make negative balance positive to get rid of - symbol
				fakeRemainingBalance += currencify(Math.abs(absoluteRemainingBalance)); // make negative balance positive to get rid of - symbol
				$('#remaining-balance').html(fakeRemainingBalance);
				
				// update padding of #entries-container for when #info gets taller (when budget/income gets really long)
				var infoHeight = $('#info').height() + 10;
				$('#entries-container').css('padding-bottom', infoHeight + 'px');

			/* paid */

				// grab income from each PAID income text box and work out total
				$('#entries .income.paid input.amount').each(function(index) {
					incomeValue = parseFloat(this.value, 10);
					if (isNaN(incomeValue)) {
						incomeValue = 0;
					}
					totalPaidIncome += incomeValue;
				});
				
				// round total paid income to 2 decimal places
				totalPaidIncome = totalPaidIncome.toFixed(2);
				
				// grab expense from each PAID expense text box and work out total
				$('#entries .expense.paid input.amount').each(function(index) {
					expenseValue = parseFloat(this.value, 10);
					if (isNaN(expenseValue)) {
						expenseValue = 0;
					}
					totalPaidExpense -= expenseValue;
				});	
				
				// round total paid expense to 2 decimal places
				totalPaidExpense = totalPaidExpense.toFixed(2);
				
				// work out remaining paid
				remainingPaid = parseFloat(totalPaidIncome) + parseFloat(totalPaidExpense);
				
				// round remaining balance to 2 decimal places
				remainingPaid = remainingPaid.toFixed(2);		
				
				// update remaining paid
				var fakeRemainingPaid = '';
				if (remainingPaid < 0) {
					fakeRemainingPaid = '- ';
				}
				
				$('#remaining-paid').attr('data-value', remainingPaid);
				absoluteRemainingPaid = Math.abs(remainingPaid); // make negative balance positive to get rid of - symbol
				fakeRemainingPaid += currencify(Math.abs(absoluteRemainingPaid)); // make negative paid positive to get rid of - symbol
				$('#remaining-paid').html(fakeRemainingPaid);

		}
		
	/*
		>> initialize autogrow textarea
	*/
	
		function initializeAutogrowTextarea(textarea) {
			var innerHeight, cssHeight;
			getHeights(textarea);
			
			// adjust heights on load
			if (innerHeight !== cssHeight) {
				newHeight = innerHeight;
				textarea.css('height',  newHeight);
			}
			
			// adjust heights when typing
			textarea.on('keyup paste focus', function (e) {
				getHeights($(this));
				// user is deleting, backspacing or cutting
				if (!e || e.which === 8 || e.which === 46 || (e.ctrlKey && e.which === 88)) {
					$(this).removeAttr('style');
					getHeights($(this));
				}
				if (innerHeight !== cssHeight) {
					$(this).css({
						height: innerHeight
					});	
				}
			});			
			
			//get heights function
			function getHeights(selector) {
				innerHeight = selector[0].scrollHeight;
				cssHeight = selector.height();
			}
		}
	
	
	/*
		>> currencify	
		(converts 2344 to £ 2,344)
	*/

		function currencify(value) {
			value = parseFloat(value).toFixed(2);
			value = value.toString();
			return currencySymbol + ' ' + value.replace(/,/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",");
		}
	
		
	/*
		>> scroll and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
	*/
	
		function scrollAndOffset(selector) {
			// get browser y scroll position
			var browserScrollPosition = $(document).scrollTop();
			// scroll to top of the page, then offset entries container so it doesn't suddenly 'jump'
			$(selector).css('top', '-' + browserScrollPosition + 'px');	
			window.scrollTo(0, 0);
		}


	/*
		>> scroll to bottom and offset - scroll to top of page then offset selected page to avoid a sudden jump on a page transition
	*/
	
		function scrollToBottomAndOffset(selector) {
			// get browser y scroll position
			var browserScrollPosition = $(document).scrollTop();
			// scroll to bottom of the page, then offset entries container so it doesn't suddenly 'jump'
			$(selector).css('top', browserScrollPosition + ($(document).height()-$(window).height()) + 'px');	
			window.scrollTo(0, $(document).height()-$(window).height());
		}


	/*
		>> scroll to bottom
	*/
	
		function scrollToBottom() {
			window.scrollTo(0, $(document).height()-$(window).height());
		}


		
	/*
		>> near bottom - check if we're near the bottom of the page
	*/
	
		function nearBottom(pixels) {
			if($(window).scrollTop() + $(window).height() > $(document).height() - pixels) {
			    return true;
			}
			else {
				return false;	
			}
		}
	
	/*
		>> load all budgets
	*/
	
		var numberOfTimesBudgetsLoaded = 0;

		function loadAllBudgets(tx, rs) {
			var rowOutput = '';
			var $budgets = $('#budgets');
			var tableString;
			for (var i=0; i < rs.rows.length; i++) {
				var id = rs.rows.item(i).id;
				var title = rs.rows.item(i).title;
				rowOutput += '<div class="budget item clearfix clear" data-id="' + id + '">';
				rowOutput +=	'<div class="budget-details item-details clearfix theme-border">';
				rowOutput +=		'<textarea class="budget-title item-title off-page theme-color" rows="1" cols="20" placeholder="E.g. March">' + title + '</textarea>';
				rowOutput +=		'<p class="budget-title item-title fake theme-color">' + title + '</p>';
				rowOutput +=		'<i class="icon-arrow-right"></i>';
				rowOutput +=	'</div>';
				rowOutput +=	'<div class="budget-options item-options theme-bg theme-border">';
				rowOutput +=		'<div class="delete option">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-bin"></i>';
				rowOutput +=				'<span>Delete</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=		'<div class="rename option">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-edit"></i>';
				rowOutput +=				'<span>Rename</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=		'<div class="export option disabled-on-free">';
				rowOutput +=			'<div class="icon">';
				rowOutput +=				'<i class="icon-export"></i>';
				rowOutput +=				'<span>Export</span>';
				rowOutput +=			'</div>';
				rowOutput +=		'</div>';
				rowOutput +=	'</div>';
				rowOutput += '</div>';
			}
			$budgets.html(rowOutput);
			var t = setTimeout(function(){
				/*
				>>> choose which page to show first
				*/
				// budgets (default)
				if (localStorage.getItem('lastPage') === 'budgets') {
					// GA - track page
					gaTrackView('Budgets');
					// nudge settings container to the left a bit, for ios7 parallax effect
					$('#settings-container').css({x: '-90px'});
					// get entries container ready to be animated
					$('#entries-container').css('transform', 'translate(100%, 0px)');
					// fade in budgets container
					$('#budgets-container').fadeIn(function() {
						// remove styles from #budgets-container
						$('#budgets-container').attr('style', 'display: block;');
						// hide loading screen and show data restored message
						if (!$('#loading').hasClass('hidden')) {
							hideLoadingScreen();
           		    		// showNotification('Data restored from Dropbox', 'success', 4000)
						}
					});
					// show pro upgrade banner
					showProUpgradeBanner();
				}
				// entries
				else if (localStorage.getItem('lastPage') === 'entries') {
					// GA - track page
					gaTrackView('Entries');
					var lastBudgetId = localStorage.getItem('lastBudgetId');
					balance.webdb.getAllEntries(lastBudgetId, loadAllEntries);
					// add active class to budget
					$('#budgets .budget[data-id=' + lastBudgetId + ']').addClass('active');
					var budgetTitle = $('.budget[data-id=' + lastBudgetId + ']').find('textarea').val();
					$entriesTitleBarTitle.text(budgetTitle);
					// nudge budgets container to the left a bit, for ios7 parallax effect
					$('#budgets-container').css({x: '-90px'});
					// nudge settings container to the left a bit, for ios7 parallax effect
					$('#settings-container').css({x: '-90px'});
					// prompt for feedback if created over x entries
					if (localStorage.entriesMade >= showRateThisAppPopupAfterEntries && !localStorage.stopAsking) {
						// if user tapped Later, just show the review icon
						if (localStorage.tappedLater) {
							showReviewIcon();
						}
						// else prompt for feedback
						else {
							setTimeout(function(){
								promptForFeedback();
							}, 1000);
						}
					}
					setTimeout(function(){
						$info.removeClass('off-bottom');
					}, 300);
					// show entries container if we've never loaded budgets before
					if (numberOfTimesBudgetsLoaded === 0) {
						numberOfTimesBudgetsLoaded++;
						$('#entries-container').addClass('invisible').css('display', 'block');
						setTimeout(function(){
							// scroll to bottom
							window.scrollTo(0, $(document).height()-$(window).height());
							setTimeout(function(){
								$('#entries-container').removeClass('invisible');
							}, 200);
							$('#entries textarea.entry-title').each(function(index) {
								textarea = $(this);
								initializeAutogrowTextarea(textarea);
							});
						}, 500);
					}
				}
				// settings
				else if (localStorage.getItem('lastPage') === 'settings') {
					// GA - track page
					gaTrackView('Settings');
					// get entries container ready to be animated
					$('#entries-container').css('transform', 'translate(100%, 0px)');
					// show settings
					$('#settings-container').fadeIn();
					$('#budgets-container').hide().css({
						top: '0px',
						x: '100%'
					});
				}

				setTimeout(function(){
					// show 'new in version x popup' - if they've not already seen it
					if (!localStorage['seenNewVersionPopup'] && !localStorage.emergencyMode) {
						showNewVersionPopup();
					}
					// hide loading screen if it's there
					if (!$('#loading').hasClass('hidden')) {
						hideLoadingScreen();
					}

				}, 600);

			}, 500);
			$budgets.find('textarea.budget-title').each(function(index) {
				initializeAutogrowTextarea($(this));
			});
		}		
		
		
	/*
		>> load all entries
	*/
	
		function loadAllEntries(tx, rs) {

			var entriesMarkup = '';

			for (var i=0; i < rs.rows.length; i++) {
				// console.log('rs.rows.item(i): ', rs.rows.item(i));
				var id = rs.rows.item(i).entry_id;
				var title = rs.rows.item(i).title;
				var amount = rs.rows.item(i).amount;
				var pinned = rs.rows.item(i).pinned;
				var isexpense = rs.rows.item(i).isexpense;
				var paid = rs.rows.item(i).paid;
				var date = rs.rows.item(i).date;
				var entryType;
				var operator;
				var pinnedClass;
				var pinMarkup;
				var paidEntryClass;
				var paidOptionClass;
				var inputDate;
				var placeholderAttr;

				// fix null amount
				if (amount === null) {
					amount = 0;
				}

				if (isexpense === 1) {
					entryType = 'expense';
					operator = '-';
					amount = Math.abs(amount); // make the negative number positive
				}
				else {
					entryType = 'income';	
					operator = '+';
				}
				if (pinned === 1) {
					pinnedClass = 'pinned';	
					pinMarkup = '<div class="unpin option">';
					pinMarkup +=		'<div class="icon">';
					pinMarkup +=			'<i class="icon-star-filled"></i>';
					pinMarkup +=			'<span>Star</span>';
					pinMarkup +=		'</div>';
					pinMarkup +=	'</div>';
				}
				else {
					pinnedClass = '';
					pinMarkup = '<div class="pin option">';
					pinMarkup +=		'<div class="icon">';
					pinMarkup += 			'<i class="icon-star"></i>';
					pinMarkup += 			'<span>Star</span>';
					pinMarkup += 		'</div>';
					pinMarkup += 	'</div>';
				}
				// fix undefined amount
				if (amount === undefined) {
					amount = 0;
				}
				// paid / unpaid
				if (paid) {
					paidEntryClass = 'paid';
					paidOptionClass = 'paid'; 
				}
				else {
					paidEntryClass = '';
					paidOptionClass = 'unpaid';
				}
				// date
				if (date) {
					inputDate = unixToDate(date);
				}
				else {
					inputDate = '';
				}
				// placeholder
				if (date) {
					placeholderAttr = '';
				}
				else {
					placeholderAttr = 'placeholder="Date"';
				}

				var fakeInputTextNew = currencify(amount);
				entriesMarkup += '<div class="entry ' + entryType + ' ' + pinnedClass + ' ' + paidEntryClass + ' item clearfix clear" data-id="' + id + '">';
				entriesMarkup += 	'<div class="entry-details item-details clearfix theme-color theme-border">';
				entriesMarkup +=		'<textarea class="entry-title item-title off-page theme-color" rows="1" cols="20" autocapitalize="on" autocorrect="off" autocomplete="off">' + title + '</textarea>';
				entriesMarkup += 		'<p class="entry-title item-title fake theme-color">' + title + '</p>';
				entriesMarkup += 		'<input class="amount item-title invisible theme-color" type="' + numberInputType + '" value="' + amount + '" autocapitalize="off" autocorrect="off" autocomplete="off">';
				entriesMarkup += 		'<p class="amount item-title fake theme-color"><span>' + operator + ' ' + fakeInputTextNew + '</span></p>';
				// entriesMarkup += 		'<input type="text" class="entry-date theme-color" value="Nov ' + Math.floor((Math.random() * 30) + 1) + ' 2016">';
				entriesMarkup += 		'<input type="date" class="entry-date theme-color" ' + placeholderAttr + ' value="' + inputDate + '">';
				entriesMarkup += 	'</div>'; 
				entriesMarkup += 	'<div class="entry-options item-options theme-bg theme-border">';
				entriesMarkup += 		'<div class="delete option">';
				entriesMarkup +=			'<div class="icon">';
				entriesMarkup +=				'<i class="icon-bin"></i>';
				entriesMarkup +=				'<span>Delete</span>';
				entriesMarkup +=			'</div>';
				entriesMarkup +=		'</div>'; 
				entriesMarkup += 		pinMarkup;
				entriesMarkup += 		'<div class="' + paidOptionClass + ' option">';
				entriesMarkup += 			'<div class="icon"><i class="icon-' + paidOptionClass + '"></i>';
				entriesMarkup += 			'<span>Paid</span></div>';
				entriesMarkup += 		'</div>';
				entriesMarkup +=		'<div class="calculator option disabled-on-free">';
				entriesMarkup +=			'<div class="icon">';
				entriesMarkup +=				'<i class="icon-calculator"></i>';
				entriesMarkup +=				'<span>Calc.</span>';
				entriesMarkup +=			'</div>';
				entriesMarkup +=		'</div>'; 
				entriesMarkup += 	'</div>';
				entriesMarkup += '</div>';
			}
			$('#entries').html(entriesMarkup).promise().done(function() {

				finishedLoadingEntries = true;

				// scroll to bottom
				// scrollToBottom();
				// loop through entries, adding paid classes
				var budgetId = parseInt($('#budgets .budget.active').attr('data-id'));
				$('#entries .entry').each(function(index) {
					var $this = $(this);
					var entryId = parseInt($this.attr('data-id'));
					// set a class if the item is paid
					/*(function(budgetId, entryId){
						$.when(balance.webdb.isPaid(budgetId, entryId)).done(function(result) {
							if (result === 'true') {
								$this.addClass('paid');
								$this.find('.option.unpaid').removeClass('unpaid').addClass('paid');
								$this.find('.icon-unpaid').removeClass('icon-unpaid').addClass('icon-paid');
								// when last item has been marked as paid
								if (index === ($('#entries .entry').length - 1)) {
									calculateIncomeAndBalance();
								}
							}
						});
					}(budgetId, entryId));*/

					// add the date if there is one
					/*(function(budgetId, entryId){
						$.when(balance.webdb.getDate(budgetId, entryId)).done(function(date) {
							if (date > 0) {
								unixDate = unixToDate(date);
								$this.find('.entry-date').val(unixDate);
								// when last date has been added
								if (index === ($('#entries .entry').length - 1)) {
									calculateIncomeAndBalance();
								}
							}
						});
					}(budgetId, entryId));*/
				});

				setTimeout(function(){
					calculateIncomeAndBalance();
					// find out if there are any starred entries
					$.when(balance.webdb.hasStarredEntries()).done(function(result) {
						// if there are starred items...
						if (result === 'true') {
							// .. and if this budget is empty, ask if user wants to add starred items
							if (rs.rows.length === 0) {
	
								// confirm add starred items
								nativeConfirm(
									'Add your Starred items to this budget?',	// message
									addStarredConfirm,					        // callback
									'Add Starred items?',						// title
									['No', 'Yes'],							    // button labels
									null,									    // fallback message
									2										    // fallback - ok pressed
								);

								// confirm add starred items callback
								function addStarredConfirm(buttonIndex) {
									// yes pressed
									if (buttonIndex === 2) {
										// add Starred items
										balance.webdb.addPinnedEntriesToBudget(budgetId);
									}
								}

							}
						}
					});

				}, 750);
			});

		}
		
		
		
	/*
		>> export budget
	*/
	
		function exportBudget(tx, rs) {
			showLoadingScreen();
			var csvText = '';
			var amounts = new Array(); // array to keep the amounts
			// get the title of the budget
			var budgetTitle = $('.budget.showing-options,.budget.active').eq(0).find('textarea.budget-title').val();
			// remove punctuation marks from  title
			budgetTitle = budgetTitle.replace(/[\.,-\/#!$%\^&\*;:{}=\-_`~()]/g,"");
			console.log('rs', rs);
			// get all the titles and amounts
			for (var i=0; i < rs.rows.length; i++) {
				var id = rs.rows.item(i).id;
				var title = rs.rows.item(i).title;
				var titleCleaned = title.replace(/"/g, '""');
				var amount = rs.rows.item(i).amount;
				var amountFixed = parseFloat(amount).toFixed(2);

				// push amount to array
				amounts.push(amount);

				// get date
				var budgetId = rs.rows.item(i).budget_id;
				var entryId = rs.rows.item(i).entry_id;

				(function(i, budgetId, entryId, titleCleaned, amountFixed){
					var dateNice;
					// var date = balance.webdb.getDate(budgetId, entryId);
					$.when(balance.webdb.getDate(budgetId, entryId)).done(function(date) {
						dateNice = unixToNiceDate(date);
						// create csv text
						csvText += '"' + titleCleaned + '","' + amountFixed + '","' + dateNice + '"\n';
					});
				}(i, budgetId, entryId, titleCleaned, amountFixed));


			}
			setTimeout(function(){
				
				// calculate balance and add to csv text
				var balanceCalculated = amounts.reduce(add, 0);
				var balanceFixed = parseFloat(balanceCalculated).toFixed(2);
				function add(a, b) {
				    return a + b;
				}
				csvText += '"BALANCE",' + '"' + balanceFixed + '"';
				console.log('csvText: ', csvText);

				// base64 encode csv text
				encodedCsvText = Base64.encode(csvText);

				// do the share
				window.plugins.socialsharing.shareViaEmail(
				   null, 
				   'Fudget - ' + budgetTitle + ' budget export',
				   null, null, null, 
				   ['data:' + budgetTitle + '.csv;text/csv;base64,' + encodedCsvText]
				   // ['data:image/png;base64,R0lGODlhDAAMALMBAP8AAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUKAAEALAAAAAAMAAwAQAQZMMhJK7iY4p3nlZ8XgmNlnibXdVqolmhcRQA7']
				);

				hideLoadingScreen();
			}, 1250);

		}
	
		
	/*
		>> add id to budget markup	
	*/
	
		function addIdToBudgetMarkup($budgetMarkup, id) {
			$budgetMarkup.attr('data-id', id);
		}
		
		
	/*
		>> add id to entry markup
	*/
	 
		function addIdToEntryMarkup($entryMarkup, id) {
			$entryMarkup.attr('data-id', id);
		}
		

	/*
		>> update count of entries made - show 'rate this app' every 50 entries & 'rate this app' button after first 50
	*/
	
		function updateEntriesMade() {
			if (!localStorage.entriesMade) {
				localStorage.entriesMade = 0;
			}
			localStorage.entriesMade ++;
			if (localStorage.entriesMade >= showRateThisAppPopupAfterEntries) {
				localStorage.showRateThisAppButton = true;
			}
		}


	/*
		>> do login
	*/

		function doLogin() {
 
			// show splash screen
			navigator.splashscreen.show();

			setTimeout(function() {
				// if touch id login enabled, show touch id login
				if (localStorage.getItem('touchIdLogin') === 'true') {
					// attempt touch id login
					touchid.authenticate(touchIdSuccess, touchIdFailure, 'Unlock fudget');
					function touchIdSuccess() { 
						// hide splash screen
						navigator.splashscreen.hide();
						setupAdmob();
					}
					function touchIdFailure() {
						// prompt for pin code to log in
						promptForPinCodeLogin("Enter passcode");
					}  
				}
				else {
					// prompt for pin code to log in
					promptForPinCodeLogin("Enter passcode"); 
				}
		    }, 200);

			function promptForPinCodeLogin(title) {

				// if user has entered an email address, show the forgot password button as well as ok
				if (localStorage.emailAddress && localStorage.emailAddress !== '' && title === 'Incorrect passcode') {
					pinPromptButtons = ["Ok", "Forgot password"];
				}
				else {
					pinPromptButtons = ["Ok"];
				}

				// show the dialog
				window.plugins.pinDialog.prompt(
					"Please enter your passcode to log in.",
					checkPin,
					title,
					pinPromptButtons
				);
			}

			function checkPin(results) {
				// clicked Ok
				if(results.buttonIndex == 1) {
					// pin correct, login
					if (results.input1 === localStorage.pinCode) {
						// hide splash screen
						navigator.splashscreen.hide();
						setupAdmob();
					}
					else {
						promptForPinCodeLogin("Incorrect passcode");
					}
				}
				// clicked Forgot password
				else if (results.buttonIndex == 2) {
					/// emailjs.send("gmail","fudget_passcode_reminder",{to: localStorage.emailAddress, content: "Your passcode is: " + localStorage.pinCode});

					// send email using mailgun.dconnell.co.uk
					$.ajax({
						url: 'http://mailgun.dconnell.co.uk',
						method: 'GET',
						dataType: 'json',
						data: {
							'from' : 'fudget@dconnell.co.uk',
							'from_name' : 'Fudget',
							'to' : localStorage.emailAddress,
							'subject' : 'Fudget passcode reminder',
							'text' : 'Your Fudget passcode is: ' + localStorage.pinCode,
						},
						success: function(data){
							console.log(data);
							var statusCode = data.http_response_code;
							var message = data.http_response_body.message;

							if (statusCode === 200) {
								nativeAlert(
									'Your passcode will shortly be emailed to ' + localStorage.emailAddress,
									null,
									'Passcode reminder'
								);
							}
							else {
								nativeAlert(
									'Sorry, your passcode could not be sent: ' + message,
									null,
									'Error'
								);
							}
						}
					});


				}
			}	

		}


	/* 
		>> log
	*/
		
		var logEnabled = false;
		
		function log(label, message) {
			if (logEnabled) {

				// sort out parameters
				if (typeof(message) === 'undefined') {
					message = label;
					label = '';
				}

				// add the log markup
				if ($('.log').length <= 0) {
					$('<div class="log"><pre></pre></div>').appendTo('body');
				}

				// do console.log too
				if (label !== '') {
					console.log(label, message);
				}
				else {
					console.log(message);
				}

				// if its an object
				if (typeof(message) === 'object') {
					message = JSON.stringify(message, null, 4);
				}

				// add log text to markup
				logText += '<div class="log-line">' + label + message + '</div>';
				$('.log pre').html(logText);

				// scroll to bottom 
				$('.log pre').scrollTop(1E10);

				// setup click events
				$('body').on('click', '.log', function (e) {
					if (!$('.log').hasClass('clicked')) {
						$('.log').addClass('clicked');
					}
					$('.log').toggleClass('hide');
				});

			}
		}
		
		function clearLog() {
			logText = '';
		}
		
	/*
		>> show pro upgrade banner
	*/
	
		var proUpgradeBannerTimer;
	
		function showProUpgradeBanner() {
			
			proUpgradeBannerTimer = setTimeout(function(){
				$('.pro-upgrade-banner-slides').slick('slickGoTo', 0, false);
				$proUpgradeBanner.removeClass('off-bottom');
			}, 1500);
			
		}
		
	/*
		>> hide pro upgrade banner
	*/
	
		function hideProUpgradeBanner() {
			clearTimeout(proUpgradeBannerTimer);
			$proUpgradeBanner.addClass('off-bottom');
		}
		
	/*
		>> enable pro version
	*/

		function enableProVersion() {
			// add pro class to body
			$('body').addClass('pro');
			// hide ads
			try {
				if (AdMob) {
					AdMob.hideBanner();
				}
			}
			catch (e) {}
			// hide house ads
			$('.house-ad-iframe').remove();
			// hide pro popups
			$('.pro-upgrade-feature-popup').hide().transition({y: '100%'});
			// close pro upgrade popup
			$('#pro-upgrade-popup').hide().transition( {y: '100%'});
			// set variables
			freeVersion = false;
			proVersion = true;
			// local storage
			localStorage['IAPfudgetProUpgrade'] = true;
		}

	/*
		>> disable pro version
	*/

		function disableProVersion() {
			// remove pro class from body
			$('body').removeClass('pro');
			// show pro popups
			$('.pro-upgrade-feature-popup').show();
			// turn off dropbox save & restore
			localStorage.dropboxSaveAndRestore = false;
			// hide dropbox options
			$('.dropbox-options').addClass('hidden');
			// set variables
			freeVersion = true;
			proVersion = false;
			// local storage
			localStorage.removeItem('IAPfudgetProUpgrade');	
		}

	/*
		>> show already upgraded popup
	*/

		function showAlreadyUpgradedPopup() {
			nativeAlert(
				'You can now enjoy:\n\r\n\rDropbox Save & Restore: Enable on the Settings page, then save or restore your data at anytime from the Settings page or Options menu\n\r\n\rThemes: Go to Settings > Themes\n\r\n\rExport: Swipe left on a budget & tap Export\n\r\n\rCalculator: Swipe left on an expense or income & tap Calculator\n\r\n\rNo ads: Enjoy Fudget ad-free',
				null,
				'Thanks for upgrading!'
			);
		}


	/*
		>> show & hide review icon
	*/

		function showReviewIconAndHint() {
			$('.show-feedback-module').removeClass('off-screen');
			$('.feedback-icon-hint').removeClass('hidden');
			setTimeout(function(){
				$('.feedback-icon-hint').removeClass('fade-out');
				setTimeout(function(){
					$('.feedback-icon-hint').addClass('fade-out');
				}, 4000);
			}, 500);
			localStorage.tappedLater = true;
		}

		function showReviewIcon() {
			$('.show-feedback-module').removeClass('off-screen');
		}

		function hideReviewIcon() {
			$('.show-feedback-module').addClass('off-screen');
		}

	/*
		>> prompt for feedback, review, email
	*/

		function promptForFeedback() {

			// if user has previously reviewed, show different text
			if (localStorage.userReviewed) {
				$('.user-has-reviewed').removeClass('hidden');
				$('.user-not-reviewed').addClass('hidden');
			}

			// show feedback module
			$('.feedback-module').removeClass('hidden');
			setTimeout(function(){
				$('body').addClass('show-feedback-module');
			}, 100);

			// show close button after a delay
			// setTimeout(function(){
			// 	$('.feedback-module .icon-delete').removeClass('hidden');
			// }, 2500);

			// GA - track feedback - prompt - show prompt
			gaTrackEvent('Feedback', 'Show feedback prompt', null);

			// happy
			$('.happy').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - tapped "happy"
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped "Happy"', null);
				// hide prompt for feedback pane
				$('.prompt-for-feedback').addClass('off-left');
				// prompt for review
				promptForReview();
				// remove click event
				$(this).unbind('click');
			});

			// not happy
			$('.not-happy').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - tapped "not happy"
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped "Not Happy"', null);
				// hide prompt for feedback pane
				$('.prompt-for-feedback').addClass('off-left');
				// prompt for email
				promptForEmail();
				// remove click event
				$(this).unbind('click');
			});

			// close feedback module
			$('.close-feedback-module').click(function (e) {
				e.preventDefault();
				// GA - track feedback - prompt - closed feedback module
				gaTrackEvent('Feedback', 'Show feedback prompt > Tapped close button', null);
				// hide feedback module
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);

				// stop showing the review icon
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');

				// remove click event
				$(this).unbind('click');

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 1000);
			});
		}

		function promptForReview() {

			// show prompt for review pane
			$('.prompt-for-review').removeClass('off-right');

			// review this app
			$('.prompt-for-review .review-this-app').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "Ok"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "Ok"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				localStorage.userReviewed = true;
				// hide review icon
				hideReviewIcon();
				// open review link
				setTimeout(function(){
					// android
					if (platform === 'Android') {
						try {
						    window.open(appReviewUrl, '_system'); 
						}
						catch(err) {
						    window.open(appReviewUrlFallback, '_system'); 
						}
					}
					// ios
					else {
						window.open(appReviewUrl, '_system'); 
					}
				}, 250);
				// remove click event
				$(this).unbind('click');
			});

			// later
			$('.prompt-for-review .later').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "later"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "Later"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				// remove click event
				$(this).unbind('click');

				// show review icon and hint
				showReviewIconAndHint();

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 1000);
			});

			// no thanks
			$('.prompt-for-review .no-thanks').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "no thanks"
				gaTrackEvent('Feedback', 'Show feedback prompt > Leave a review? > Tapped "No thanks"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');
			});

		}

		function promptForEmail() {

			// show prompt for email pane
			$('.prompt-for-email').removeClass('off-right');

			// send message
			$('.prompt-for-email .send-message').click(function (e) {
				e.preventDefault();
				// GA - track feedback - send feedback? - tapped "Ok"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "Ok"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// open email link
				setTimeout(function(){
					window.open(feedbackUrl, '_system');
				}, 250);
				// remove click event
				$(this).unbind('click');
			});

			// later
			$('.prompt-for-email .later').click(function (e) {
				e.preventDefault();
				// GA - track feedback - leave a review? - tapped "later"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "Later"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				// remove click event
				$(this).unbind('click');

				// show review icon and hint
				showReviewIconAndHint();

				// reset styles
				setTimeout(function(){
					promptResetStyles();
				}, 2000);
			});

			// no thanks
			$('.prompt-for-email .no-thanks').click(function (e) {
				e.preventDefault();
				// GA - track feedback - send feedback? - tapped "No thanks"
				gaTrackEvent('Feedback', 'Show feedback prompt > Send feedback? > Tapped "No thanks"', null);
				$('body').removeClass('show-feedback-module');
				setTimeout(function(){
					$('.feedback-module').addClass('hidden');
				}, 300);
				localStorage.stopAsking = true;
				// hide review icon
				hideReviewIcon();
				// remove click event
				$(this).unbind('click');
			});

		}

		function promptResetStyles() {
			// reset styles
			$('.prompt-for-feedback').removeClass('off-left');
			$('.prompt-for-review, .prompt-for-email').addClass('off-right');
		}


	/*
		>> admob or house ads
	*/

		function setupAdmob() {
			if (!localStorage['IAPfudgetProUpgrade']) {

				// ios
				if (platform === 'iOS') {

					// try for a house ad
					$.ajax({
						url: houseAdUrl,
						success: function(data) {
							var $iframe = $('<iframe class="house-ad-iframe" src="' + houseAdUrl + '" frameborder="0" width="320" height="50"></iframe>');
							$iframe.appendTo('body');
						},
						// couldn't find house ad, load admob ad
						error: function(XMLHttpRequest, textStatus) { 
							bannerAdId = 'ca-app-pub-6346367103336512/8283337185';
							createBanner();
						}
					});	

				}
				// android
				else if (platform === 'Android') {
					// bannerAdId = 'ca-app-pub-6346367103336512/3434114382'; // old fudget app id
					bannerAdId = 'ca-app-pub-6346367103336512/4661068785';
					createBanner();
				}

				function createBanner() {

					if (platform === 'iOS') {
						bannerOptions = {
							adId: bannerAdId, 
							position: AdMob.AD_POSITION.BOTTOM_CENTER, 
							// position: AdMob.AD_POSITION.POS_XY, x:100, y:200, 
							autoShow: true,
							overlap: true
						}
					}
					else {

						if ($(window).width() < 600) {
							bannerHeight = 50
						}
						else {
							bannerHeight = 100;
						}

						bannerOptions = {
							adId: bannerAdId, 
							position: AdMob.AD_POSITION.BOTTOM_CENTER, 
							adSize: 'CUSTOM',
							height: bannerHeight,
							width: Math.min($(window).width(), $(window).height()),
							autoShow: true,
							overlap: true
						}
					}

					if(AdMob) AdMob.createBanner( 
						bannerOptions
					);
				}

			}

		}

		function refreshBanner() {
			setTimeout(function(){
				if (freeVersion) {
					AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER); 
				}
			}, 1000);	
		}

   	/*
   		>> check pro trial expired
   	*/

   		function checkProTrialExpired() {
			var proTrialExpiryDate = localStorage['proTrialExpiryDate'];
			var currentDate = new Date().getTime(); 
			// pro trial has expired
			if (proTrialExpiryDate < currentDate) {
				// disable 'try pro' button
 				gaTrackEvent('Upgrade Popup', 'Upgrade Popup > Try Pro > Pro Trial Expired', null);
				$('.try-pro').addClass('disabled');
				if (!localStorage['seenProTrialExpiredPopup']) {
					// disable pro version
					disableProVersion();

	       			// pro trial expired confirm
	       			nativeConfirm(
	       				'Did you enjoy the Pro features?\n\rIf so, please upgrade to Fudget Pro now!',	// message
	       				proTrialExpiredCallback,					                                    // callback (with tapped button index as parameter)
	       				'Thanks for trying Fudget Pro!',						                        // title
	       				['Close', 'Upgrade now'],							                        	// button labels
	       				null,									                                        // fallback (null if confirm fallback needed, string or function)
	       				2										                                        // fallback - ok pressed (button index to fire - omit if no confirm required)
	       			);

	       			// pro trial expired confirm callback
	       			function proTrialExpiredCallback(buttonIndex) {
	       				if (buttonIndex === 2) {
	       					// show pro upgrade popup
	       					$('.show-pro-upgrade-popup').first().trigger('click');
	       				}
	       			}
	       			// add seenProTrialExpiredPopup localStorage entry 
	       			localStorage['seenProTrialExpiredPopup'] = true;
				}
			}
   		}

   	/*
   		>> show & hide loading screen
   	*/

   		function showLoadingScreen(message) {
   			if (typeof message !== 'undefined') {
   				$('#loading .text').text(message);
   			}
   			else {
   				$('#loading .text').text('');
   			}
   			$('#loading').removeClass('hidden');
   		}

   		function hideLoadingScreen() {
   			$('#loading').addClass('hidden');
   		}




	/*
		>> ga - track view (page)
	*/

		function gaTrackView(view) {
			if(window.cordova && typeof window.analytics !== undefined) {
				try {
					window.analytics.trackView(view);
				}
				catch(err) {
					console.log('Google Analytics error: ' + err);
				}  
			}
		}


	/*
		>> ga - track event
	*/

		function gaTrackEvent(category, action, label) {
			if(window.cordova && typeof window.analytics !== undefined) {
				try {
					window.analytics.trackEvent(category, action, label);
					// log(category + ', ' + action + ', ' + label);
				}
				catch(err) {
					console.log('Google Analytics error: ' + err);
				}   
			}
		}


   	/*
   		>> show new version popup
   	*/

   		function showNewVersionPopup() {

			nativeAlert(
				newVersionMessage,
				null,
				'New in Fudget version ' + versionNumber,
				'Ok'
			);

			// update localStorage
			localStorage['seenNewVersionPopup'] = true;		
   		}

   	/*
   		>> show notification
   		this will show a notification at the bottom, use it like: showNotification('This is the message', 'error');
   		2nd parameter specifies the type of notification to show, and can be 'error', 'warning', 'success' or 'notice'
   	*/

   		function showNotification(message, type, time) {
   			var $notification = $('.notification')
   			// add the message to the notification
   			$notification.find('.message').text(message);
   			// add correct classes
   			$notification.removeClass('error warning success notice');
   			$notification.addClass(type);
   			// show it
   			$notification.addClass('show');
   			// setup click event to close it
   			$notification.click(function (e) {
   				$notification.removeClass('show');
   				$notification.unbind('click');
   			});
   			// hide after ms if time specified
   			if (typeof time !== 'undefined') {
   				setTimeout(function(){
   					$notification.trigger('click');
   				}, time);
   			}
   		}

   	/*
   		>> native alert
   		show a native alert, or a browser alert as a fallback
   	*/

   		window.nativeAlert = function (message, callback, title, button) {
   		    if(typeof callback === 'undefined')callback = null;
   		    title = (title != undefined) ? title : 'Alert';
   		    button = (button != undefined) ? button : 'Ok';

   		    if (navigator.notification) {
   		        navigator.notification.alert(
   		            message, // message
   		            callback, //callback method... 
   		            title, // title
   		            button // buttonName
   		        );
   		    } else {
   		    	// if only a title was specified, use that as the message
   		    	if (message === null) {
   		    		message = title;
   		    	}
   		        alert(message);
   		        if(typeof callback === "function") callback();
   		    }
   		};


   	/*
   		>> native confirm
   		show a native confirm, or a browser confirm as a fallback
   		if fallback is provided, if string, alert will be shown, if function, function will be fired
   		if fallbackOkButtonIndex is not provided, then no fallback confirm will be shown
   	*/

   		window.nativeConfirm = function (message, callback, title, buttonLabels, fallback, fallbackOkButtonIndex, fallbackCancelButtonIndex) {
   		    title = (title != undefined) ? title : 'Confirm';

   		    // native confirm
   		    if (navigator.notification) {
   		        navigator.notification.confirm(
   		            message, // message
   		            callback, //callback method...
   		            title, // title
   		            buttonLabels // button labels (e.g. ['No', 'Yes'])
   		        );
   		    }
   		    // browser fallback (alert or function)
   		    else if (fallback !== null) {
   		    	// if string provided, alert the string
   		    	if (typeof fallback === 'string') {
	   		    	alert(fallback);
   		    	}
   		    	// else if function provided, fire it
   		    	else if (typeof fallback === 'function') {
   		    		fallback();
   		    	}
   		    }
   		    // browser fallback ok/cancel button index (fire the standard callback with these buttonIndex's)
   		    else if (fallbackOkButtonIndex !== undefined) {
   		    	var browserConfirm = confirm(message);
   		    	if (browserConfirm === true && fallbackOkButtonIndex !== undefined) {
   		    	    callback(fallbackOkButtonIndex);
   		    	}
   		    	else if (browserConfirm === false && fallbackCancelButtonIndex !== undefined) {
   		    		callback(fallbackCancelButtonIndex);
   		    	}
   		    }
   		};
   		

   	/*
   		>> native prompt
   	*/

   		window.nativePrompt = function (message, callback, title, buttonLabels, defaultText, fallbackFunction, fallbackOkButtonIndex) {
   		    title = (title != undefined) ? title : 'Prompt';

   		    if (navigator.notification) {
   		        navigator.notification.prompt(
   		            message,      // message
   		            callback,     //callback method...
   		            title,        // title
   		            buttonLabels, // button labels (e.g. ['No', 'Yes'])
   		            defaultText   // default text in field
   		        );
   		    }
   		    else if (fallbackFunction !== undefined && fallbackFunction !== null) {
   		    	fallbackFunction();
   		    }
   		    else {
   		    	var browserPrompt = prompt(message, defaultText);
   		    	if (browserPrompt !== null) {
   		    		var result = {};
   		    		result.buttonIndex = fallbackOkButtonIndex || 1;
   		    		result.input1 = browserPrompt;
   		    	    callback(result);
   		    	}
   		    }
   		};


   	/*
   		>> date to unix timestamp
   	*/

   		function dateToUnix(date) {
   			var dateArray = date.split('-'),
   			year = parseInt(dateArray[0]),
   			month = parseInt(dateArray[1]) - 1,
   			day = parseInt(dateArray[2]),
   			dateObject = new Date(year, month, day),
   			dateUnix = dateObject.getTime();

   			return dateUnix;
   		}


   	/*
   		>> unix timestamp to date
   	*/

   		function unixToDate(dateUnix) {
   			var dateObject = new Date(dateUnix),
   			year = dateObject.getFullYear(),
   			month = zeroPad(dateObject.getMonth() + 1,2),
   			day = zeroPad(dateObject.getDate(),2),
   			date = year + '-' + month + '-' + day;

   			return date;
   		}


   	/*
   		>> unix timestamp to nice date
   	*/

   		function unixToNiceDate(dateUnix) {

   			console.log('dateUnix: ', dateUnix);

   			if (dateUnix === 0 || dateUnix === null || dateUnix === undefined) {
   				date = '';
   			}
   			else {
	   			var dateObject = new Date(dateUnix),
	   			year = dateObject.getFullYear(),
	   			months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
	   			month = dateObject.getMonth(),
	   			niceMonth = months[month],
	   			day = dateObject.getDate();

	   			var date = niceMonth + ' ' + day + ' ' + year;
	   		}

   			return date;
   		}


   	/*
   		>> zero padding
   	*/

   		function zeroPad(num,count) {
   			var numZeropad = num + '';
   			while(numZeropad.length < count) {
   				numZeropad = "0" + numZeropad;
   			}
   			return numZeropad;
   		}

	/*
		>> get android version
	*/

		function getAndroidVersion(ua) {
		    ua = (ua || navigator.userAgent).toLowerCase(); 
		    var match = ua.match(/android\s([0-9\.]*)/);
		    return match ? match[1] : false;
		}


	/*
		>> enable emergency mode
	*/

		function enableEmergencyMode() {
			localStorage.emergencyMode = true;
			localStorage.seenNewVersionPopup = true;
			localStorage.firstRunTutorialDisplayed = true;	
			$('.emergency-options').removeClass('hidden');
		}

	/*
		>> disable emergency mode
	*/

		function disableEmergencyMode() {
			localStorage.removeItem('emergencyMode');
			localStorage.emergencyModeDisabled = true;
			$('.emergency-options').addClass('hidden');

			// save data to persistent storage
			persistent.saveDatabase();
		}




/*
* tutorial.js
*
* CONTENTS
*
* tutorial carousel
* tutorial animations
*    animation 1
*    animation 2
*    animation 3
*    animation 4
*    animation 5
*    animation 6
*/

/*
	> tutorial carousel
*/

	disableTutorialSwiping = false;

	var currentNav = 1;

    function Carousel(element)
    {
        var self = this;
        element = $(element);

        var container = $(">.tutorial-slides", element);
        var panes = $(">.tutorial-slides>div", element);

        var pane_width = 0;
        var pane_count = panes.length;

        var current_pane = 0;


        /**
         * initial
         */
        this.init = function() {
            setPaneDimensions();

            $(window).on("load resize orientationchange", function() {
                setPaneDimensions();
            })
        };


        /**
         * set the pane dimensions and scale the container
         */
        function setPaneDimensions() {
            pane_width = element.width();
            panes.each(function() {
                $(this).width(pane_width);
            });
            container.width(pane_width*pane_count);
        };


        /**
         * show pane by index
         */
        
        var previousNav = 0;
         
        this.showPane = function(index, animate, direction) {
        	
            // between the bounds
            index = Math.max(0, Math.min(index, pane_count-1));
            current_pane = index;

            var offset = -((100/pane_count)*current_pane);
            setContainerOffset(offset, animate);
            
            // set active tutorial-nav
            currentNav = current_pane + 1;
            $('.tutorial-nav a').removeClass('active');
            $('.tutorial-nav a:nth-child(' + currentNav + ')').addClass('active');
            
            // stop the previous tutorial animation start current tutorial animation            
            // only do stuff if we're on a different slide from before
            if (currentNav != previousNav) {
	        	// disable swiping for a second
	        	disableTutorialSwiping = true;
	        	setTimeout(function(){
	        		disableTutorialSwiping = false;
	        	}, 1000);
	        	
            	// if user swiped forwards
	            if (direction == 'forwards') {
	            	// stop previous slide's animation
	            	stopTutorialAnimation[currentNav-1] = true;
	            	setTimeout(function(){
			            tutorialAnimation(currentNav-1, 'reset');
	            	}, 100);

	            	// start current slide's animation
            		stopTutorialAnimation[currentNav] = false;
			        tutorialAnimation(currentNav);

	            }
            	// if user swiped backwards
	            else if (direction == 'backwards') {
	            	// stop previous slide's animation
	            	stopTutorialAnimation[currentNav+1] = true;
	            	setTimeout(function(){
			            tutorialAnimation(currentNav+1, 'reset');          		
	            	}, 100);

	            	// start current slide's animation
            		stopTutorialAnimation[currentNav] = false;
			        tutorialAnimation(currentNav);

	            }
            }
            
            
            previousNav = currentNav;
        };


        function setContainerOffset(percent, animate) {
            container.removeClass("animate");

            if(animate) {
                container.addClass("animate");
            }

           container.css("transform", "translate("+ percent +"%,0)");
        }

        this.next = function() { return this.showPane(current_pane+1, animateTutorialSlides, 'forwards'); };
        this.prev = function() { return this.showPane(current_pane-1, animateTutorialSlides, 'backwards'); };


        /**
         * handle next / previous taps
         */

        $('.tutorial-next').click(function (e) {
        	e.preventDefault();
        	self.next();
        });
        $('.tutorial-prev').click(function (e) {
        	e.preventDefault();
        	self.prev();
        });



        function handleHammer(ev) {
            // disable browser scrolling
            ev.gesture.preventDefault();

            switch(ev.type) {
                case 'dragright':
                case 'dragleft':
                	// don't allow dragging for a short time if slide just changed
                	if (disableTutorialSwiping == true) {
                		break;
                	}
                
                    // stick to the finger
                    var pane_offset = -(100/pane_count)*current_pane;
                    var drag_offset = ((100/pane_width)*ev.gesture.deltaX) / pane_count;

                    // slow down at the first and last pane
                    if((current_pane == 0 && ev.gesture.direction == "right") ||
                        (current_pane == pane_count-1 && ev.gesture.direction == "left")) {
                        drag_offset *= .4;
                    }

                    setContainerOffset(drag_offset + pane_offset);
                    break;

                case 'swipeleft':
	                // don't allow dragging for a short time if slide just changed
	                if (disableTutorialSwiping == true) {
	                	break;
	                }
                    self.next();
                    ev.gesture.stopDetect();
                    break;

                case 'swiperight':
                	// don't allow dragging for a short time if slide just changed
                	if (disableTutorialSwiping == true) {
                		break;
                	}
                    self.prev();
                    ev.gesture.stopDetect();
                    break;

                case 'release':
                	// don't allow dragging for a short time if slide just changed
                	if (disableTutorialSwiping == true) {
                		break;
                	}
                    // more then 50% moved, navigate
                    if(Math.abs(ev.gesture.deltaX) > pane_width/2) {
                        if(ev.gesture.direction == 'right') {
                            self.prev();
                        } else {
                            self.next();
                        }
                    }
                    else {
                        self.showPane(current_pane, true, 'none');
                    }
                    break;
            }
        }

        new Hammer(element[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer);
    }
		

/* 
	> tutorial animations
*/

	var numberOfTutorialAnimations = $('.tutorial-slide').length;
	var stopTutorialAnimation = new Array;

	for (var i = 1; i < numberOfTutorialAnimations + 1; i++) { 
		// create a stop variable for each animation
		stopTutorialAnimation[i] = false;
	}	
	
	/*$('#tutorial').css({y: 0, display: 'block'});
	carousel.init();*/

	var carousel = new Carousel(".tutorial-slides-container");

	// show on first run
	if (!localStorage.firstRunTutorialDisplayed) {
		$('#tutorial').show().css( {y: '0%'} );
		carousel.init();
	}	
			
	// tutorialAnimation
	function tutorialAnimation(id, reset) {
		
		switch(id) {
			
			/*
				>> animation 1
			*/
			
				case 1:
				
					// no animation for first slide
				
					break;
			
			/* 
				>> animation 2
			*/
			
				case 2:
								
					var $touchIndicator2 = $('.slide-2 .touch-indicator');
					var $tutorialBudget2 = $('.slide-2 .item');
					var $tutorialBudgetTitle2 = $('.slide-2 .item-title');
					var $tutorialBudgetDetails2 = $('.slide-2 .budgets .item:first-child .item-details');
					
					// start animation
					if (reset != 'reset') {
						// move indicator to 'Add Budget'
						if (!stopTutorialAnimation[id]) {
							// reset title again in case timers still running     x / 278
							$tutorialBudgetTitle2.stop(true, true).text('');
							$touchIndicator2.delay(500).animate({
								left: '46%', top: '50px'
							}, 300, function() {
								// tap indicator
								if (!stopTutorialAnimation[id]) {
									$touchIndicator2.transition({
										scale: '0.9',
										opacity: 0.6
									}, 100, function() {
										// untap indicator
										if (!stopTutorialAnimation[id]) {
											$touchIndicator2.transition({
												scale: '1',
												opacity: 0.3
											}, 100, function() {
												// create budget
												if (!stopTutorialAnimation[id]) {
													$tutorialBudgetTitle2.text('');
													$tutorialBudget2.animate({
														height: 49
													}, 500, function() {
														// type August
														if (!stopTutorialAnimation[id]) {
															setTimeout(function(){
																$tutorialBudgetTitle2.text('A|');
																if (!stopTutorialAnimation[id]) {
																	setTimeout(function(){
																		$tutorialBudgetTitle2.text('Au');
																		if (!stopTutorialAnimation[id]) {
																			setTimeout(function(){
																				$tutorialBudgetTitle2.text('Aug|');
																				if (!stopTutorialAnimation[id]) {
																					setTimeout(function(){
																						$tutorialBudgetTitle2.text('Augu');
																						if (!stopTutorialAnimation[id]) {
																							setTimeout(function(){
																								$tutorialBudgetTitle2.text('Augus|');
																								if (!stopTutorialAnimation[id]) {
																									setTimeout(function(){
																										$tutorialBudgetTitle2.text('August');
																										if (!stopTutorialAnimation[id]) {
																											setTimeout(function(){
																												$tutorialBudgetTitle2.text('August|');
																												if (!stopTutorialAnimation[id]) {
																													setTimeout(function(){
																														$tutorialBudgetTitle2.text('August');
																														// move indicator to top item
																														if (!stopTutorialAnimation[id]) {
																															$touchIndicator2.delay(500).animate({
																																top: '50px',
																																left: '78%'
																															}, 300, function() {
																																
																																// tap indicator
																																if (!stopTutorialAnimation[id]) {
																																	$touchIndicator2.delay(300).transition({
																																		scale: '0.9',
																																		opacity: 0.6		
																																	}, 100, function() {
																																		// move indicator across to the left to indicate left swipe
																																		if (!stopTutorialAnimation[id]) {
																																			$touchIndicator2.delay(200).animate({
																																				left: '1%'
																																			}, 300, function() {
																																				// untap indicator
																																				if (!stopTutorialAnimation[id]) {
																																					$touchIndicator2.transition({
																																						scale: '1',
																																						opacity: 0.3		
																																					}, 100);
																																				}
																																			});	
																																		}
																																		if (!stopTutorialAnimation[id]) {
																																			// swipe top item and show options
																																			$tutorialBudgetDetails2.delay(500).transition({
																																				x: '-165'
																																			}, 200, function() {
																																				// move indicator to delete button
																																				if (!stopTutorialAnimation[id]) {
																																					$touchIndicator2.delay(600).animate({
																																						left: '100%',
																																						marginLeft: '-55px'
																																					}, 300, function() {
																																						// tap indicator
																																						if (!stopTutorialAnimation[id]) {
																																							$touchIndicator2.delay(500).transition({
																																								scale: '0.9',
																																								opacity: 0.6
																																							}, 100, function() {
																																								// untap indicator
																																								if (!stopTutorialAnimation[id]) {
																																									$touchIndicator2.transition({
																																										scale: '1',
																																										opacity: 0.3		
																																									}, 100);
																																								}
																																								// delete budget
																																								if (!stopTutorialAnimation[id]) {
																																									$tutorialBudget2.animate({
																																										height: '0'
																																									}, 100, function() {
																																										// reset elements
																																										if (!stopTutorialAnimation[id]) {
																																											setTimeout(function(){
																																												tutorialAnimation(id, 'reset');
																																												tutorialAnimation(id);
																																											}, 2000);
																																										}
																																									});
																																								}
																																								
																																							});		
																																						}
																																					});													
																																				}
																																			});
																																		}
																																	});
																																}
																																
																																
																																
																															});
																														}
																													}, 200);
																												}
																											}, 200);
																										}
																									}, 200);
																								}	
																							}, 200);
																						}
																					}, 200);
																				}	
																			}, 200);
																		}
																	}, 200);
																}
															}, 200);
														}
													});
												}
											});
										}
									});
								}
							});
						}
					}
					// stop and reset animation if 'reset' was specified
					else {
						$touchIndicator2.stop(true, true).css({left: '65%', top: '142px', opacity: 0.3, marginLeft: 0}).show();
						$tutorialBudgetTitle2.stop(true, true).text('');
						$tutorialBudget2.stop(true, true).css({height: 0});
						$tutorialBudgetDetails2.stop(true,true).css({x: 0});
					}
				
					break;	


			/* 
				>> animation 3
			*/
			
				case 3:
				
					var $touchIndicator3 = $('.slide-3 .touch-indicator');
					var $tutorialBudget3 = $('.slide-3 .budgets .item:first-child');
					var $entriesContainer3 = $('.slide-3 .entries-container');
					var $entry3 = $('.slide-3 .entries .item:first-child');
					var $entryTitle3 = $('.slide-3 .entries .item:first-child p.entry-title');
					var $entryValue3 = $('.slide-3 .entries .item:first-child p.amount');
					var $info3 = $('.slide-3 .info');
					
					// start animation
					if (reset != 'reset') {
						// move indicator to top item
						if (!stopTutorialAnimation[id]) {
							$touchIndicator3.delay(500).animate({
								top: '50px'
							}, 300, function() {
								// tap indicator
								if (!stopTutorialAnimation[id]) {
									$touchIndicator3.delay(500).transition({
										scale: '0.9',
										opacity: 0.6
									}, 100, function() {
										// add touch state to top budget
										if (!stopTutorialAnimation[id]) {
											$tutorialBudget3.addClass('touch');
											// untap indicator
											$touchIndicator3.transition({scale: '1', opacity: 0.3});
											// slide in entries
											$entriesContainer3.show().delay(500).transition({
												x: '0%'
											}, 200, function() {
												// move touch indicator over 'Add Income'
												if (!stopTutorialAnimation[id]) {
													$touchIndicator3.delay(400).animate({
														left: '18%'
													}, 500, function() {
														// tap indicator
														if (!stopTutorialAnimation[id]) {
															$touchIndicator3.delay(500).transition({
																scale: '0.9',
																opacity: 0.6
															}, 100, function() {
																// untap indicator
																if (!stopTutorialAnimation[id]) {
																	$touchIndicator3.transition({scale: '1', opacity: 0.3});
																}
																// create entry
																if (!stopTutorialAnimation[id]) {
																	$entry3.animate({
																		height: 49
																	}, 400, function() {
																		// tap indicator
																		if (!stopTutorialAnimation[id]) {
																			$touchIndicator3.delay(750).transition({
																				scale: '0.9',
																				opacity: 0.6
																			}, 100, function() {
																				// untap indicator
																				if (!stopTutorialAnimation[id]) {
																					$touchIndicator3.transition({
																						scale: '1', 
																						opacity: 0.3
																					}, 100);
																				}
																				if (!stopTutorialAnimation[id]) {
																					// reset titles just in case timers are still running
																					$entryTitle3.css('color', '#B1D2C7').text('E.g. Salary');
																					$entryValue3.text('+ $0.00');
																					setTimeout(function(){
																						$entryTitle3.text('|').removeAttr('style');
																						if (!stopTutorialAnimation[id]) {
																							setTimeout(function(){
																								$entryTitle3.text('S');
																								if (!stopTutorialAnimation[id]) {
																									setTimeout(function(){
																										$entryTitle3.text('Sa|');	
																										if (!stopTutorialAnimation[id]) {
																											setTimeout(function(){
																												$entryTitle3.text('Sal');
																												if (!stopTutorialAnimation[id]) {
																													setTimeout(function(){
																														$entryTitle3.text('Sala|');
																														if (!stopTutorialAnimation[id]) {
																															setTimeout(function(){
																																$entryTitle3.text('Salar');
																																if (!stopTutorialAnimation[id]) {
																																	setTimeout(function(){
																																		$entryTitle3.text('Salary');
																																		// move indicator to entry amount
																																		if (!stopTutorialAnimation[id]) {
																																			$touchIndicator3.delay(500).animate({
																																				left: '100%',
																																				marginLeft: '-78px',
																																				top: 50
																																			}, 500, function() {
																																				// tap indicator
																																				if (!stopTutorialAnimation[id]) {
																																					$touchIndicator3.delay(500).transition({
																																						scale: '0.9',
																																						opacity: 0.6
																																					}, 100, function() {
																																						// fade out touch indicator
																																						if (!stopTutorialAnimation[id]) {
																																							$touchIndicator3.fadeOut();
																																							$entryValue3.text('|');
																																							if (!stopTutorialAnimation[id]) {
																																								setTimeout(function(){
																																									$entryValue3.text('2|');
																																									if (!stopTutorialAnimation[id]) {
																																										setTimeout(function(){
																																											$entryValue3.text('20|');
																																											if (!stopTutorialAnimation[id]) {
																																												setTimeout(function(){
																																													$entryValue3.text('200|');
																																													if (!stopTutorialAnimation[id]) {
																																														setTimeout(function(){
																																															$entryValue3.text('2000|');
																																															if (!stopTutorialAnimation[id]) {
																																																setTimeout(function(){
																																																	$entryValue3.text('2000.|');
																																																	if (!stopTutorialAnimation[id]) {
																																																		setTimeout(function(){
																																																			$entryValue3.text('2000.3|');
																																																			if (!stopTutorialAnimation[id]) {
																																																				setTimeout(function(){
																																																					$entryValue3.text('2000.34');
																																																					if (!stopTutorialAnimation[id]) {
																																																						setTimeout(function(){
																																																							$entryValue3.text('+ $2,000.34');
																																																							// show info
																																																							if (!stopTutorialAnimation[id]) {
																																																								$info3.fadeIn();
																																																								// reset elements
																																																								if (!stopTutorialAnimation[id]) {
																																																									setTimeout(function(){
																																																										tutorialAnimation(id, 'reset');
																																																										tutorialAnimation(id);
																																																									}, 2000);
																																																								}
																																																							}
																																																						}, 1000);
																																																					}
																																																				}, 200);
																																																			}
																																																		}, 200);
																																																	}
																																																}, 200);
																																															}
																																														}, 200);
																																													}
																																												}, 200);
																																											}
																																										}, 200);
																																									}
																																								}, 200);
																																							}
																																						}
																																									
																																					});					
																																				}
																																			});	
																																				
																																		}	
																																	}, 200);
																																}		
																															}, 200);
																														}		
																													}, 200);
																												}	
																											}, 200);
																										}		
																									}, 200);
																								}	
																							}, 200);
																						}
																					}, 200);
																				}	

																			});
																		}
																	});
																}
															});
														}
														
													});	
												}
											});
										}
									});
								}
							});
						}							
					}
					
					// stop and reset animation if 'reset' was specified
					else {
						$touchIndicator3.stop(true, true).transition({scale: 1}).css({left: '65%', top: 177, display: 'block', opacity: 0.3, marginLeft: 0});
						$tutorialBudget3.stop(true, true).removeClass('touch');
						$entriesContainer3.stop(true, true).css({x: '100%'});
						$entry3.stop(true, true).css({height: 0});
						$entryTitle3.css('color', '#B1D2C7').text('E.g. Salary');
						$entryValue3.text('+ $0.00');
						$info3.stop(true, true).hide();
					}
				
					break;	


			/* 
				>> animation 4
			*/
			
				case 4:
				
					var $touchIndicator4 = $('.slide-4 .touch-indicator');
					var $entry4 = $('.slide-4 .entries .item:first-child');
					var $entryDetails4 = $('.slide-4 .entries .item:first-child .entry-details');
					var $star4 = $('.slide-4 .entries .item:first-child .pin, .slide-4 .entries .item:first-child .unpin');
					var $starIcon = $('.slide-4 .entries .item:first-child .pin i, .slide-4 .entries .item:first-child .unpin i')
					
					// start animation
					if (reset != 'reset') {
						// move indicator to top item
						if (!stopTutorialAnimation[id]) {
							$touchIndicator4.delay(500).animate({
								top: '50px'
							}, 300, function() {
									
								// tap indicator
								if (!stopTutorialAnimation[id]) {
									$touchIndicator4.delay(500).transition({
										scale: '0.9',
										opacity: 0.6
									}, 100, function() {
										// move indicator across to the left to indicate left swipe
										if (!stopTutorialAnimation[id]) {
											$touchIndicator4.delay(200).animate({
												left: '1%'
											}, 300, function() {
												// untap indicator
												if (!stopTutorialAnimation[id]) {
													$touchIndicator4.transition({
														scale: '1',
														opacity: 0.3
													}, 100);
												}
											});	
										}
										if (!stopTutorialAnimation[id]) {
											// swipe top item and show options
											$entryDetails4.delay(500).transition({
												x: '-165'
											}, 200, function() {
												// move indicator to star button
												if (!stopTutorialAnimation[id]) {
													$touchIndicator4.delay(1000).animate({
														left: '100%',
														marginLeft: '-100px'
													}, 300, function() {
														// tap indicator
														if (!stopTutorialAnimation[id]) {
															$touchIndicator4.delay(500).transition({
																scale: '0.9',
																opacity: 0.6
															}, 100, function() {
																// star entry
																if (!stopTutorialAnimation[id]) {
																	$touchIndicator4.fadeOut();
																	$entry4.addClass('pinned');
																	$star4.addClass('unpin').removeClass('pin');
																	$starIcon.addClass('icon-star-filled').removeClass('icon-star');
																	// slide entry details back across
																	if (!stopTutorialAnimation[id]) {
																		$entryDetails4.delay(500).transition({
																			x: '0'
																		}, 200, function() {
																			// reset elements
																			if (!stopTutorialAnimation[id]) {
																				setTimeout(function(){
																					tutorialAnimation(id, 'reset');
																					tutorialAnimation(id);
																				}, 2000);
																			}																		
																		});
																	}
																}
															});		
														}
													});													
												}
											});
										}
									});
								}
								
							});
						}						
					}
					
					// stop and reset animation if 'reset' was specified
					else {
						$touchIndicator4.stop(true, true).transition({scale: 1}).css({left: '78%', top: 180, display: 'block', opacity: 0.3, marginLeft: 0});
						$entry4.stop(true, true).removeClass('pinned');
						$entryDetails4.stop(true, true).css({x: '0'});
						$star4.removeClass('unpin').addClass('pin');
						$starIcon.removeClass('icon-star-filled').addClass('icon-star');
					}
				
					break;	

			/* 
				>> animation 5
			*/
			
				case 5:
				
					var $touchIndicator5 = $('.slide-5 .touch-indicator');
					var $entry5 = $('.slide-5 .entries .item:last-child');
					var $entryFirst5 = $('.slide-5 .entries .item:first-child');
					var $placeholder5 = $('<div class="placeholder" style="height: 49px"></div>');
					
					// start animation
					if (reset != 'reset') {
						// move indicator to top item
						if (!stopTutorialAnimation[id]) {
							$touchIndicator5.delay(1000).animate({
								left: '48%',
								top: 145
							}, 300, function() {
								// tap indicator
								if (!stopTutorialAnimation[id]) {
									$touchIndicator5.delay(500).transition({
										scale: '0.9',
										opacity: 0.6
									}, 100, function() {
										// start dragging
										if (!stopTutorialAnimation[id]) {
											// get original y offset of entry
											originalOffset = $entry5.position().top;
											// add dragging class and pull out of the page
											$entry5.delay(500).addClass('dragging').transit({scale: 1.05}).css('top', originalOffset + 'px').after($placeholder5);;
											// move touch indicator and drag entry upwards, above middle item
											if (!stopTutorialAnimation[id]) {
												setTimeout(function(){
													if (!stopTutorialAnimation[id]) {
														$touchIndicator5.animate({
															top: 87
														}, { duration: 500, queue: false });
													}														
													if (!stopTutorialAnimation[id]) {
														$entry5.animate({
															top: 87
														}, 500, function() {
															// move placeholder and drop item
															if (!stopTutorialAnimation[id]) {
																$placeholder5.insertAfter($entryFirst5);
																setTimeout(function(){
																	// scale back down
																	if (!stopTutorialAnimation[id]) {
																		$touchIndicator5.transition({scale: '1', opacity: 0.3}, 100);
																		$entry5.transit({
																			scale: 1,
																			top: 100
																		}, 200, function() {
																			$entry5.removeClass('dragging');
																			$entry5.insertAfter($placeholder5)
																			$entry5.removeAttr('style');
																			$placeholder5.remove();
																			// reset elements
																			if (!stopTutorialAnimation[id]) {
																				setTimeout(function(){
																					tutorialAnimation(id, 'reset');
																					tutorialAnimation(id);
																				}, 2000);
																			}
																		});
																	}
																}, 1000);
															}
														});
													}
												}, 1000);
											}
											
										}
									});
								}
															
							});
						}						
					}
					
					// stop and reset animation if 'reset' was specified
					else {
						$touchIndicator5.stop(true, true).transition({scale: 1}).css({left: '78%', top: 180, display: 'block', opacity: 0.3});
						$('.slide-5 .entries .entry').stop(true, true).css({scale: 1, top: 0}).removeAttr('style').removeClass('dragging');
						$('.slide-5 .entries .placeholder').remove();
					}
				
					break;	


			/* 
				>> animation 6
			*/
			
				case 6:
				
					var $touchIndicator6 = $('.slide-6 .touch-indicator');
					var $entriesContainer6 = $('.slide-6 .entries-container');
					var $budgetsContainer6 = $('.slide-6 .budgets-container');
					
					// start animation
					if (reset != 'reset') {
						// move indicator to top item
						if (!stopTutorialAnimation[id]) {
							$touchIndicator6.delay(1000).animate({
								left: '5%',
								top: 103
							}, 300, function() {
								// tap indicator
								if (!stopTutorialAnimation[id]) {
									$touchIndicator6.delay(500).transition({
										scale: 0.9,
										opacity: 0.6
									}, 200, function() {
										// swipe to the right
										if (!stopTutorialAnimation[id]) {
											// swipe indicator
											$touchIndicator6.animate({
												left: '77%'
											}, 300);
											// swipe entries
											$entriesContainer6.delay(200).transition({
												x: '100%'
											}, 300, function() {
												// untap indicator
												if (!stopTutorialAnimation[id]) {
													$touchIndicator6.transition({
														scale: 1,
														opacity: 0.3
													}, 200, function() {
														// move indicator back to the left
														if (!stopTutorialAnimation[id]) {
															$touchIndicator6.delay(300).animate({
																left: '5%'
															}, 300, function() {
																// tap indicator
																if (!stopTutorialAnimation[id]) {
																	$touchIndicator6.delay(500).transition({
																		scale: 0.9,
																		opacity: 0.6
																	}, 200, function() {
																		// swipe to the right
																		if (!stopTutorialAnimation[id]) {
																			// swipe indicator
																			$touchIndicator6.animate({
																				left: '77%'
																			}, 300);
																			// swipe budgets
																			$budgetsContainer6.delay(200).transition({
																				x: '100%'
																			}, 300, function() {
																				// untap indicator
																				if (!stopTutorialAnimation[id]) {
																					$touchIndicator6.transition({
																						scale: 1,
																						opacity: 0.3
																					}, 200, function() {
																						// reset elements
																						if (!stopTutorialAnimation[id]) {
																							setTimeout(function(){
																								tutorialAnimation(id, 'reset');
																								tutorialAnimation(id);
																							}, 3000);
																						}
																					});
																				}
																			});
																		}																
																	});
																}			
															});
														}
													});
												}
											});
											
										}					
									});	
								}
							});
						}						
					}
					
					// stop and reset animation if 'reset' was specified
					else {
						$touchIndicator6.stop(true, true).transition({scale: 1}).css({left: '78%', top: 180, opacity: 0.3});
						$entriesContainer6.stop(true, true).css({x: '0%'})
						$budgetsContainer6.stop(true, true).css({x: '0%'})
					}
				
					break;	

			
		}
		
		

	}
	// end tutorialAnimation
